/*
 *        JacORB - a free Java ORB
 *
 *   Copyright (C) 1997-2002  Gerald Brose.
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Library General Public
 *   License as published by the Free Software Foundation; either
 *   version 2 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Library General Public License for more details.
 *
 *   You should have received a copy of the GNU Library General Public
 *   License along with this library; if not, write to the Free
 *   Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

package net.starmiddleware.starws2.I2WCFE.idl;

import java.io.PrintWriter;
import java.util.Enumeration;
import java.util.Hashtable;
import java.util.Vector;

//lbx
import net.starmiddleware.starws2.description.IDL2WSDL.ServiceDesc;
//mcl
import net.starmiddleware.starws2.description.IDL2WSDL.*;
import net.starmiddleware.starws2.wsdl.IDLToWSDL.*;

/**
 * @author Gerald Brose
 * @version $Id: AttrDecl.java,v 1.2 2004/07/20 03:14:42 jane Exp $
 */

class AttrDecl
        extends Declaration
{

    public boolean readOnly;
    public TypeSpec param_type_spec;
    public SymbolList declarators;
    //mcl
    public SimpleDeclarator simpledeclarator;
   // public TypeDesc typedesc;
    //by mcl
    private Vector operations = new Vector();

    public AttrDecl( int num )
    {
        super( num );
    }

    public void setPackage( String s )
    {
        s = parser.pack_replace( s );
        if( pack_name.length() > 0 )
            pack_name = new String( s + "." + pack_name );
        else
            pack_name = s;
        declarators.setPackage( s );
        param_type_spec.setPackage( s );
    }

    public void parse()
    {
        IdlSymbol myInterface = enclosing_symbol;

        if( param_type_spec.typeSpec() instanceof ScopedName )
        {
            TypeSpec ts =
                    ( (ScopedName)param_type_spec.typeSpec() ).resolvedTypeSpec();
            if( ts != null )
                param_type_spec = ts;

            myInterface.addImportedName( ts.typeName() );
        }

        declarators.parse();

        for( Enumeration e = declarators.v.elements(); e.hasMoreElements(); )
        {
            operations.addElement(
                    new Method( param_type_spec,
                            null,
                            ( (SimpleDeclarator)e.nextElement() ).name(),
                            is_pseudo )
            );
        }
        if( !readOnly )
        {
            for( Enumeration e = declarators.v.elements(); e.hasMoreElements(); )
            {
                SimpleDeclarator d =
                        (SimpleDeclarator)e.nextElement();
                operations.addElement(
                        new Method( null,
                                param_type_spec,
                                d.name(),
                                is_pseudo )
                );
            }
        }
    }

    public void print( PrintWriter ps )
    {
    }

    public Enumeration getOperations()
    {
        return operations.elements();
    }

    /**
     * collect Interface Repository information in the argument hashtable
     */

    public void getIRInfo( Hashtable irInfoTable )
    {
        for( Enumeration e = declarators.v.elements(); e.hasMoreElements(); )
        {
            String fullName = param_type_spec.full_name();
            irInfoTable.put( ( (SimpleDeclarator)e.nextElement() ).name(),
                    "attribute" + ( readOnly?"":"-w" ) + ";" +
                    ( fullName != null ? fullName :  param_type_spec.typeName() ) );
        }
    }

    //mcl
//wsdl.IDLToWSDL
public void toWSDL(ServiceDesc serviceDesc){
           //System.out .println("Entering net.starmiddleware.starws2.I2WCFE.idl.AttrDecl.toWSDL()...") ;
           AttributeDesc attribute = new AttributeDesc();

           FaultDesc faultdesc=new FaultDesc();
                 faultdesc.setName("CORBA.SystemException");
                 attribute.addFault(faultdesc) ;

                 TypedefDesc typedesc1=new TypedefDesc();
                  typedesc1.setName("CORBA.SystemException") ;
            typedesc1.setTypedeftype("CORBA.SystemException") ;
                serviceDesc.addTypedefDesc(typedesc1) ;


           //System.out .println(pack_name);
           //System.out .println(readOnly);

         for( Enumeration e = declarators.v.elements(); e.hasMoreElements(); )
            {
                SimpleDeclarator d =
                        (SimpleDeclarator)e.nextElement();

                //attribute.setXmlName("_get_"+d.name());
                //System.out .println(d.name() );
                 //System.out .println(pack_name);
                 //System.out .println(readOnly);
                 //System.out .println(IDLType.getClass(param_type_spec) );
                // System.out .println(IDLType.getQName(param_type_spec));

                 attribute.setFieldName(d.name());
                 attribute.setpackName(pack_name) ;
                 //serviceDesc.addOperationDesc(attribute);

                 serviceDesc.addAttributeDesc(attribute) ;
                 attribute.setisAttribute("attribute");
                 attribute.setreadonly(readOnly);

                if(param_type_spec.typeSpec() instanceof AliasTypeSpec )
                 {
                  attribute.settypeName(param_type_spec.typeName) ;
                 }
                 else
                 {
                    attribute.settypeName(param_type_spec.typeName()) ;
                 }


                 String mm=param_type_spec.typeName();
   if (mm.equalsIgnoreCase("char")||mm.equalsIgnoreCase("wchar")
       ||mm.equalsIgnoreCase("CORBA.any")||mm.equalsIgnoreCase("CORBA.TypeCode")    )
   {
     TypedefDesc typedesc=new TypedefDesc();

       typedesc.setName(mm) ;
       typedesc.setTypedeftype(mm) ;
       typedesc.settypeName(mm);

        serviceDesc.addTypedefDesc(typedesc) ;
       // if(mm.equalsIgnoreCase("char"))
         // typedesc.settotalDigits(1) ;
   }

              if(IDLType.getClass(param_type_spec)!=null
                 &&!(param_type_spec.typeSpec() instanceof AliasTypeSpec )
                  &&!(param_type_spec.typeSpec() instanceof CharType))
           {

                 attribute.setJavaType(IDLType.getClass(param_type_spec));
                attribute.setXmlType(IDLType.getQName(param_type_spec));}

            }
                //TypeDesc typedesc = new typedesc(IDLType.getClass(param_type_spec));
                /* TypeDesc typedesc = new TypeDesc(IDLType.getClass(param_type_spec));

                 typedesc.addFieldDesc(attribute);
                 typedesc.getAttributeNameForField(d.name() );*/
                 //add by mcl
                 //Emitter emitter=new Emitter();


          //typedesc.addFieldDesc( AttributeDesc attribute);
         /*for( Enumeration e = paramDecls.elements(); e.hasMoreElements(); )
          {
              ( (ParamDecl)e.nextElement() ).toWSDL(serviceDesc) ;
           }*/

          //raisesExpr.toWSDL(serviceDesc) ;

    }
}




