/*
 *        JacORB - a free Java ORB
 *
 *   Copyright (C) 1997-2002  Gerald Brose.
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Library General Public
 *   License as published by the Free Software Foundation; either
 *   version 2 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Library General Public License for more details.
 *
 *   You should have received a copy of the GNU Library General Public
 *   License along with this library; if not, write to the Free
 *   Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

package net.starmiddleware.starws2.I2WCFE.idl;


import net.starmiddleware.starws2.description.IDL2WSDL.*;
import net.starmiddleware.starws2.description.IDL2WSDL.OperationDesc;
import net.starmiddleware.starws2.description.IDL2WSDL.ParameterDesc;
import net.starmiddleware.starws2.wsdl.IDLToWSDL.IDLType;

/**
 * @author Gerald Brose
 * @version $Id: ParamDecl.java,v 1.2 2004/07/20 03:14:43 jane Exp $
 */

import java.io.PrintWriter;

class ParamDecl
    extends IdlSymbol
{
    public int paramAttribute;
    public TypeSpec paramTypeSpec;
    public SimpleDeclarator simple_declarator;

    public ParamDecl( int num )
    {
        super( num );
    }

    public void setPackage( String s )
    {
        s = parser.pack_replace( s );
        if( pack_name.length() > 0 )
            pack_name = new String( s + "." + pack_name );
        else
            pack_name = s;
        paramTypeSpec.setPackage( s );
    }


    public void parse()
    {
        while( paramTypeSpec.typeSpec() instanceof ScopedName )
        {
            TypeSpec ts = ( (ScopedName)paramTypeSpec.typeSpec() ).resolvedTypeSpec();
            if( ts != null )
                paramTypeSpec = ts;
        }

        Environment.doAssert( paramTypeSpec != null , " paramTypeSpec is null " + name );

        //simple_declarator.print(ps);
    }

    public void print( PrintWriter ps )
    {
        switch( paramAttribute )
        {
            case 1:
                //    if( paramTypeSpec instanceof ConstrTypeSpec )
                //ps.print( paramTypeSpec.typeName() );
                //else
                ps.print( paramTypeSpec.toString() );
                break;
            case 2: /*out*/
            case 3: /*inout*/
                ps.print( paramTypeSpec.holderName() );
                break;
        }
        ps.print( " " + simple_declarator );
        //simple_declarator.print(ps);
    }

    public String printWriteStatement( String ps )
    {
        return printWriteStatement( simple_declarator.toString(), ps );
    }

    public String printWriteStatement( String name, String ps )
    {
        if( paramAttribute != 1 )
            return paramTypeSpec.typeSpec().printWriteStatement( name + ".value", ps );
        else
            return paramTypeSpec.typeSpec().printWriteStatement( name, ps );
    }

    public String printReadExpression( String ps )
    {
        return paramTypeSpec.typeSpec().printReadExpression( ps );
    }


    public void toWSDL(ServiceDesc serviceDesc,OperationDesc opdesc){
        //System.out .println("Entering net.starmiddleware.starws2.I2WCFE.idl.ParamDecl.toWSDL()...") ;
        //todo

        ParameterDesc paramDesc = new ParameterDesc();

        //set para mode
        switch( paramAttribute )
         {
             case 1:   //in
                 paramDesc.setMode(ParameterDesc.IN);
                 paramDesc.setIsReturn(false) ;
                break;
             case 2: /*out*/
                 paramDesc.setMode(ParameterDesc.OUT );
                 paramDesc.setIsReturn(true) ;
                 break;
             case 3: /*inout*/
                 paramDesc.setMode(ParameterDesc.INOUT );
                 paramDesc.setIsReturn(true) ;
                 break;
        }

        //mcl parameter name
        paramDesc.setName(simple_declarator.name()) ;
        //System.out .println(paramTypeSpec.pack_name ) ;
        paramDesc.setpackName(paramTypeSpec.pack_name) ;
 //System.out .println (paramTypeSpec.typeName());

    //System.out .println (paramTypeSpec.typeSpec());    //para type
  // paramDesc.settypeName(paramTypeSpec.name()) ;
 if(paramTypeSpec.typeSpec() instanceof AliasTypeSpec )
    {
    paramDesc.settypeName(paramTypeSpec.typeName) ;
    paramDesc.setarrseq(paramTypeSpec.typeName() );
   }
   else{
     paramDesc.settypeName(paramTypeSpec.typeName()) ;
   }


   String mm=paramTypeSpec.typeName();
   if (mm.equalsIgnoreCase("char")||mm.equalsIgnoreCase("wchar")
       ||mm.equalsIgnoreCase("CORBA.any")||mm.equalsIgnoreCase("CORBA.Typecode")    )
   {
     TypedefDesc typedesc=new TypedefDesc();

       typedesc.setName(mm) ;
       typedesc.setTypedeftype(mm) ;
       typedesc.settypeName(mm) ;
        serviceDesc.addTypedefDesc(typedesc) ;
       // if(mm.equalsIgnoreCase("char"))
        //  typedesc.settotalDigits(1) ;
   }


   if(IDLType.getClass(paramTypeSpec.typeName() )!=null
      &&!(paramTypeSpec.typeSpec() instanceof AliasTypeSpec)
       &&!(paramTypeSpec.typeSpec() instanceof CharType))
   {

        paramDesc.setJavaType(IDLType.getClass(paramTypeSpec.typeName()) ) ;
       paramDesc.setTypeQName(IDLType.getQName(paramTypeSpec.typeName()) );
   }

        // OperationDesc todo

        //IdlSymbol sym = this.getEnclosingSymbol();
        //if (sym instanceof OpDecl){
        //  String opName = sym.name() ;
         // OperationDesc opDesc = serviceDesc.getOperationByName(opName);
          if (opdesc != null)
          {
               opdesc.addParameter(paramDesc) ;
          }



    }

}




