package net.starmiddleware.starws2.description;

import org.apache.axis.description.*;
import org.apache.axis.AxisServiceConfig;
import org.apache.axis.InternalException;
import org.apache.axis.Constants;
//import org.apache.axis.message.SOAPEnvelope;
//import org.apache.axis.message.SOAPBodyElement;
import org.apache.axis.components.logger.LogFactory;
import org.apache.axis.encoding.DefaultTypeMappingImpl;
import org.apache.axis.encoding.TypeMapping;
import org.apache.axis.encoding.TypeMappingRegistry;
import org.apache.axis.encoding.TypeMappingRegistryImpl;
import org.apache.axis.enum.Style;
import org.apache.axis.utils.JavaUtils;
import org.apache.axis.utils.Messages;
import org.apache.axis.utils.bytecode.ParamNameExtractor;
import org.apache.axis.wsdl.Skeleton;
import org.apache.commons.logging.Log;
import org.w3c.dom.Element;
import org.w3c.dom.Document;

import javax.xml.namespace.QName;
import javax.xml.rpc.holders.Holder;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.lang.reflect.Modifier;
import java.util.ArrayList;
import java.util.Collection;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.StringTokenizer;
import java.util.Collections;
import java.util.Comparator;

// lbx
import org.omg.CORBA.Repository;
import org.omg.CORBA.OperationDef;
import org.omg.CORBA.InterfaceDef;
import org.omg.CORBA.InterfaceDefHelper;
import org.omg.CORBA.Contained;
import org.omg.CORBA.DefinitionKind;
import org.omg.CORBA.InterfaceDefPackage.FullInterfaceDescription;
import org.omg.CORBA.OperationDescription;
import org.omg.CORBA.ParameterDescription;
import org.omg.CORBA.TypeCode;
import org.omg.CORBA.ParameterMode;
import org.omg.CORBA.ExceptionDescription;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: </p>
 * @author not attributable
 * @version 1.0
 */

public class CORBAServiceDesc extends ServiceDesc{
  /** Method names for which we have completed any introspection necessary */
  private ArrayList completedNames = new ArrayList();
  private HashMap name2OperationsMap = null;
  private HashMap qname2OperationsMap = null;
  private HashMap method2OperationMap = new HashMap();
  private HashMap method2ParamsMap = new HashMap();
  private OperationDesc messageServiceDefaultOp = null;
  /** Style */
  private Style style = Style.RPC;

  //new varible for interface name
  public static String PROP_INFNAME = null;
  //new varible for repository
  public static String PROP_REPOSITORY = "repositoy";

  private boolean introspectionComplete = false;

  ServiceDesc parent=null;


  //new varible
  public String implInterface = null;

  public CORBAServiceDesc(ServiceDesc parent) {

    super();
    this.setName(super.getName());
    this.parent=parent;
  }

  public void loadServiceDescByIR(String infName) {

    if (introspectionComplete || infName == null) {
      return;
    }

    //new varible for preventing redundant initialization
    implInterface = infName;

    //set implClass for preventing redundant initialization
    super.setImplClass( (new Object()).getClass());


    // get all the operations from IR(Interface Repository)
    Repository repository = (Repository)super.getProperty(PROP_REPOSITORY);

    Contained contained = repository.lookup(infName);
    if(contained==null) return;
    if (contained.describe().kind.value() != DefinitionKind._dk_Interface); // how to ?

    InterfaceDef idef = InterfaceDefHelper.narrow(contained);

     /*don't need to process the parents's interfaces.The operations and attributes fields of the FullInterfaceDescription
     structure include descriptions of all of the operations and attributes in
     the transitive closure of the inheritance graph of the interface being described.*/
    FullInterfaceDescription fDesc = idef.describe_interface();

    OperationDescription[] opDescs_IR = fDesc.operations;
    for (int i = 0; i < opDescs_IR.length; i++) {
      getSyncedOperationsForNameByIR(fDesc, opDescs_IR[i]);
    }
  }

  // get the IDL Description info of the specified Interface and the specified Operation
  // from IR, and get the correspondent CORBAOperationDesc
  private void getSyncedOperationsForNameByIR(FullInterfaceDescription fDesc,
                                              OperationDescription opDesc_IR) {
    String opName = opDesc_IR.name;
    // need to consider it? client?
    if (fDesc == null)
      return;

    //check if we hava handled this operation. to do...
    // If we're done introspecting, or have completed this operation, return
    if (completedNames == null || completedNames.contains(opName))
      return;

    //check if the operation is allowed to be published
    if ( (super.getAllowedMethods() != null) &&
        !super.getAllowedMethods().contains(opName))
      return;

    if ( (super.getDisallowedMethods() != null) &&
        super.getDisallowedMethods().contains(opName))
      return;

    // synchorize the cache . to do....

    // create a operationdesc for each operation in idl
    createOperationForOperationByIR(fDesc, opDesc_IR);

    completedNames.add(opName);

  }

  // get the correspondent CORBAOperationDesc
  private void createOperationForOperationByIR(FullInterfaceDescription fDesc,
                                               OperationDescription opDesc_IR) {

    //get IR's ParameterDescriptions
    ParameterDescription[] paramDescs_IR = opDesc_IR.parameters;

    // make new OperationDesc, and fill it with information retrieved from IR
    CORBAOperationDesc operation = new CORBAOperationDesc();
    operation.setName(opDesc_IR.name);
    String defaultNS = "";

    defaultNS = (String)super.getDefaultNamespace();
    operation.setElementQName(new QName(defaultNS, opDesc_IR.name));

    //
    //set the return value's info
    //
    TypeCode tc_result = opDesc_IR.result;
    operation.setReturnTypeCode(tc_result);

    //
    //set the parameters' info
    //
    for (int k = 0; k < paramDescs_IR.length; k++) {
      ParameterDescription paramDesc_IR = paramDescs_IR[k]; //ΪTypeCode
      CORBAParameterDesc paramDesc = new CORBAParameterDesc();
      // If we have a name for this param, use it, otherwise call
      // it "in*"
      String paramName = paramDesc_IR.name;
      if (paramName != null && paramName != null &&
          paramName.length() > 0) {
        paramDesc.setName(paramName);
      }
      else {
        paramDesc.setName("in" + k);
      }

      TypeCode tc_param = paramDesc_IR.type;

      paramDesc.setTypeCode(tc_param);

      //set the parameter's mode
      int param_mode = paramDesc_IR.mode.value();
      if (param_mode == ParameterMode._PARAM_IN) {
        paramDesc.setMode(ParameterDesc.IN);
      }
      else if (param_mode == ParameterMode._PARAM_OUT) {
        paramDesc.setMode(ParameterDesc.OUT);
      }
      else {
        paramDesc.setMode(ParameterDesc.INOUT);
      }

      operation.addParameter(paramDesc);
    }

    //
    //process the exceptions
    //
    //process the exceptions declared in IDL
    ExceptionDescription[] UserExceptionDescs_IR = opDesc_IR.exceptions;
    for (int i = 0; i < UserExceptionDescs_IR.length; i++) {
      // Create a single part with the dummy name "fault"
      // that locates the complexType for this exception.

      ExceptionDescription userException = UserExceptionDescs_IR[i];

      CORBAParameterDesc param = new CORBAParameterDesc(
          new QName("", "fault"),
          ParameterDesc.IN);
      param.setTypeCode(userException.type);
      ArrayList exceptionParams = new ArrayList();
      exceptionParams.add(param);

      String excName = userException.name;
      FaultDesc fault = new FaultDesc();
      fault.setName(excName);
      fault.setParameters(exceptionParams);
      operation.addFault(fault);
    }

    // process CORBA's system exceptions
    CORBAParameterDesc param = new CORBAParameterDesc(
        new QName("", "fault"),
        ParameterDesc.IN);
    ArrayList exceptionParams = new ArrayList();
    exceptionParams.add(param);
    FaultDesc fault = new FaultDesc();
    fault.setName("CORBA.SystemException");
    fault.setParameters(exceptionParams);
    operation.addFault(fault);

    addOperationDesc(operation);
  }

  public void addOperationDesc(OperationDesc operation) {
    super.getOperations().add(operation);
    operation.setParent(this);
    if (name2OperationsMap == null) {
      name2OperationsMap = new HashMap();
    }

    // Add name to name2Operations Map
    String name = operation.getName();
    ArrayList overloads = (ArrayList) name2OperationsMap.get(name);
    if (overloads == null) {
      overloads = new ArrayList();
      name2OperationsMap.put(name, overloads);
    }
    overloads.add(operation);
  }

  public String getImplInterface() {
    return implInterface;
  }

  public void loadServiceDescByIntrospection() {
    return;
  }

  private synchronized void initQNameMap() {
    if (qname2OperationsMap == null) {

      qname2OperationsMap = new HashMap();
      for (Iterator i = super.getOperations().iterator(); i.hasNext(); ) {
        OperationDesc operationDesc = (OperationDesc) i.next();
        ArrayList list =
            (ArrayList) qname2OperationsMap.get(operationDesc.
                                                getElementQName());
        if (list == null) {
          list = new ArrayList();
          qname2OperationsMap.put(operationDesc.getElementQName(),
                                  list);
        }
        list.add(operationDesc);
      }
    }
  }

  public OperationDesc[] getOperationsByQName(QName qname) {
    // Look in our mapping of QNames -> operations.

    // But first, let's make sure we've initialized said mapping....
    initQNameMap();

    ArrayList overloads = (ArrayList) qname2OperationsMap.get(qname);

    if (overloads == null) {
      // Nothing specifically matching this QName.
      if ( ( (style == Style.RPC) || ( (style == Style.MESSAGE) &&
                                      (getDefaultNamespace() == null))) &&
          (name2OperationsMap != null)) {
        // Try ignoring the namespace....?
        overloads = (ArrayList) name2OperationsMap.get(qname.getLocalPart());
      }

      // Handle the case where a single Message-style operation wants
      // to accept anything.
      if ( (style == Style.MESSAGE) && (messageServiceDefaultOp != null))
        return new OperationDesc[] {
            messageServiceDefaultOp};

      if (overloads == null)
        return null;
    }

    // Sort the overloads by number of arguments - prevents us calling methods
    // with more parameters than supplied in the request (with missing parameters
    // defaulted to null) when a perfectly good method exists with exactly the
    // supplied parameters.
    Collections.sort(overloads,
                     new Comparator() {
      public int compare(Object o1, Object o2) {
        Method meth1 = ( (OperationDesc) o1).getMethod();
        Method meth2 = ( (OperationDesc) o2).getMethod();
        return (meth1.getParameterTypes().length -
                meth2.getParameterTypes().length);
      }
    });

    OperationDesc[] array = new OperationDesc[overloads.size()];
    return (OperationDesc[]) overloads.toArray(array);
  }
  public TypeMappingRegistry getTypeMappingRegistry() {
      if (parent.getTypeMappingRegistry() == null) {
         parent.setTypeMappingRegistry(new TypeMappingRegistryImpl());
     }
     return parent.getTypeMappingRegistry();
   }

  public void setTypeMappingRegistry(TypeMappingRegistry tmr) {
     parent.setTypeMappingRegistry(tmr);
   }


}
