/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: </p>
 * @author not attributable
 * @version 1.0
 */
package net.starmiddleware.starws2.description.IDL2WSDL;

import javax.xml.namespace.QName;

/**
 * FieldDescs are metadata objects which control the mapping of a given
 * IDL field to/ XML.
 *
 * @author
 */
public class FieldDesc {
  /** The name of the Java field in question */
  private String fieldName;
  /** The XML QName this field maps to */
  private QName xmlName;
  /** The XML Type this field maps to/from */
  private QName xmlType;
  /** The Java type of this field */
  private Class javaType;
  //mcl
  //private ServiceDesc parent;
  /** An indication of whether this should be an element or an attribute */
  // Q : should this be a boolean, or just "instanceof ElementDesc", etc.
  private boolean _isElement = true;

  /** An indication that minoccurs is zero */
  private boolean minOccursIs0 = false;

  /**
   * Can't construct the base class directly, must construct either an
   * ElementDesc or an AttributeDesc.
   */
  protected FieldDesc(boolean isElement) {
    _isElement = isElement;
  }

  /**
   * Obtain the field name.
   */
  public String getFieldName() {
    return fieldName;
  }

  /**
   * Set the field name.
   */
  public void setFieldName(String fieldName) {
    this.fieldName = fieldName;
  }

  /**
   * Obtain the XML QName for this field
   */
  public QName getXmlName() {
    return xmlName;
  }

  /**
   * Set the XML QName for this field
   */
  public void setXmlName(QName xmlName) {
    this.xmlName = xmlName;
  }

  public Class getJavaType() {
    return javaType;
  }

  public void setJavaType(Class javaType) {
    this.javaType = javaType;
  }

  /**
   * Returns the XML type (e.g. xsd:string) for this field
   */
  public QName getXmlType() {
    return xmlType;
  }

  /**
   * Returns the XML type (e.g. xsd:string) for this field
   */
  public void setXmlType(QName xmlType) {
    this.xmlType = xmlType;
  }

  /**
   * Check if this is an element or an attribute.
   *
   * @return true if this is an ElementDesc, or false if an AttributeDesc
   */
  public boolean isElement() {
    return _isElement;
  }

  public boolean isIndexed() {
    return false;
  }

  /**
   * Check if this field can be omitted.
   */
  public boolean isMinOccursIs0() {
    return minOccursIs0;
  }

  public void setMinOccursIs0(boolean minOccursIs0) {
    this.minOccursIs0 = minOccursIs0;
  }
}
