package net.starmiddleware.starws2.encoding;

/**
 * <p>Title: ComplexType class serialize to SOAP format</p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: </p>
 * @author: shuichao
 * @version 1.0
 */
import java.io.*;
import java.util.*;
import javax.xml.namespace.*;

import org.apache.axis.*;
import org.apache.axis.encoding.*;
import org.apache.axis.schema.*;
import org.apache.axis.soap.*;
import org.apache.axis.utils.*;
import org.apache.axis.wsdl.fromJava.*;
import org.xml.sax.*;
import org.xml.sax.helpers.*;
import net.starmiddleware.starws2.encoding.CORBA.*;

public class CORBAComplexSer
    implements Serializer {
  int idIndex = 0;
  public CORBAComplexSer() {
  }

  public String getMechanismType() {
    return Constants.AXIS_SAX;
  }

  /**
   * @param name is the element name
   * @param attributes are the attributes...serialize is free to add more.
   * @param value is the value
   * @param context is the SerializationContext
   */
  public void serialize(QName name, Attributes attributes,
                        Object value, SerializationContext context) throws
      IOException {
    if (! (value instanceof typeAbstract))
      throw new IOException("Can't serialize a " + value.getClass().getName() +
                            " with a DataSerializer.");
    if (value == null)
      throw new IOException(Messages.getMessage("cantDoNullArray00"));

    org.xml.sax.helpers.AttributesImpl this_attri = new org.xml.sax.helpers.
        AttributesImpl();
    this_attri.setAttributes(attributes);
    String prefix = context.getPrefixForURI(Constants.URI_DEFAULT_SCHEMA_XSI,
                                            "xsi");
    String valueNamespace = ( (ComplexType) value).getValueNamespace();
    int index = attributes.getIndex(prefix + ":type");
    String typeValue = this_attri.getValue(index);
    int typeValueIndex = typeValue.indexOf(":");

    String space = typeValue.substring(0, typeValueIndex);
    typeValue = typeValue.replaceFirst("corba", valueNamespace);
    ( (org.xml.sax.helpers.AttributesImpl) this_attri).setValue(index,
        typeValue);

    //begin serialization
    context.startElement(name, this_attri);
    MessageContext msgContext = context.getMessageContext();
    SchemaVersion schema = msgContext.getSchemaVersion();
    SOAPConstants soap = msgContext.getSOAPConstants();
    //if have children, serialze them.
    java.util.Stack childStack = new java.util.Stack();
    if ( ( (ComplexType) value).hasChilds()) {
      ArrayList realValue = (ArrayList) ( (ComplexType) value).getChild();

      for (int i = 0; i < realValue.size(); i += 2) {

        Object aValue = realValue.get(i);
        org.xml.sax.helpers.AttributesImpl attri = new org.xml.sax.helpers.
            AttributesImpl();

        if (aValue instanceof ComplexType) {

          if ( ( (ComplexType) aValue).getType() == null) {
            QName childQName = null;
            if ( ( (ComplexType) aValue).isSpecialName())
              childQName = new QName( ( (ComplexType) value).getType().
                                     getNamespaceURI(),
                                     ( (ComplexType) value).getType().
                                     getLocalPart() + "." +
                                     ( (ComplexType) value).getName());
            else
              childQName = new QName( ( (ComplexType) value).getType().
                                     getNamespaceURI(),
                                     ( (ComplexType) value).getType().
                                     getLocalPart());
            ( (ComplexType) aValue).setType(childQName);
          }

          if ( ( (ComplexType) aValue).isSpecialName())
            ( (ComplexType) aValue).setParentName( ( (ComplexType) value).
                                                  getName());
          //

          index = attributes.getIndex("id");
          String id = attributes.getValue(index);
          id = id + "_" + ( (ComplexType) aValue).getName() + idIndex;
          idIndex++;
          attri.addAttribute("", "id", "id", "CDATA", id);
          attri.addAttribute("", "xsi:type", "xsi:type", "CDATA",
                             space + ":corba");
          //
          index = attri.getIndex("xmlns:" + space);
          if (index == -1) {

            attri.addAttribute("", "xmlns:" + space, "xmlns:" + space, "CDATA",
                               "http://www.omg.org/IDL-Mapped/");
          }

          context.writeString("<" + ( (ComplexType) aValue).getNamePrefix() +
                              " href=\"#" + id + "\"" + "/>" + "\n");
          childStack.push(attri);
          childStack.push(aValue);

        }
        else {

          QName classType = context.getQNameForClass(aValue.getClass());
          QName typeName = context.getQNameForClass(aValue.getClass());
          String typePrefix = context.getPrefixForURI(typeName.getNamespaceURI());

          attri.addAttribute("", "xsi:type", "xsi:type", "CDATA",
                             typePrefix + ":" + typeName.getLocalPart());
          attri.addAttribute("", "xmlns:" + typePrefix, "xmlns:" + typePrefix,
                             "CDATA", typeName.getNamespaceURI());
          QName elemTypeQName = new QName("", ( (String) realValue.get(i + 1)));

          Serializer ser = context.getSerializerForJavaType(aValue.getClass());

          ser.serialize(elemTypeQName, attri, aValue, context);
        }
      }

    }
    else {

      Object out = ( (ComplexType) value).getValue();

      if (out == null) {
        ( (org.xml.sax.helpers.AttributesImpl) attributes).addAttribute("",
            "xsi:nil", "xsi:nil", "CDATA", "true");
      }
      else context.writeSafeString(out.toString());
    }

    context.endElement();

    while (!childStack.empty()) {
      ComplexType childValue = (ComplexType) childStack.pop();
      org.xml.sax.helpers.AttributesImpl attri = (AttributesImpl) childStack.
          pop();
      QName elemTypeQName = new QName("", "multiRef");
      Serializer ser = context.getSerializerForJavaType(childValue.getClass());
      ser.serialize(elemTypeQName, attri, childValue, context);
    }

  }

  /**
   * Return XML schema for the specified type, suitable for insertion into
   * the <types> element of a WSDL document.
   *
   * @param types the Java2WSDL Types object which holds the context
   *              for the WSDL being generated.
   * @return true if we wrote a schema, false if we didn't.
   * @see org.apache.axis.wsdl.fromJava.Types
   */
  public boolean writeSchema(Types types) throws Exception {
    return false;
  }

}
