package net.starmiddleware.starws2.providers.jms;

import javax.jms.*;
import java.util.HashMap;
import java.io.IOException;

import org.w3c.dom.Element ;
import org.w3c.dom.Document;
import org.apache.axis.message.MessageElement;
import org.apache.axis.message.SOAPBodyElement;
import javax.xml.soap.SOAPEnvelope;
import java.rmi.RemoteException;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.ParserConfigurationException;
import org.w3c.dom.CDATASection;
import org.apache.axis.utils.XMLUtils;
import javax.xml.soap.SOAPBody;
import java.util.Iterator;
import org.w3c.dom.NodeList;
import org.w3c.dom.Node;
import java.util.Vector;
import java.io.ByteArrayInputStream;
import java.io.InputStream;
import java.util.Hashtable;
import java.io.StringBufferInputStream;
import javax.jms.*;
import javax.naming.*;


/*
 * SOAPJMSBridge class
 *
 * @author Nickzuo
 * @version 1.0
 */

public class SOAPJMSBridge
{

  SimpleJMSListener listener;
  String DEFAULT_USERNAME = "anonymous";
  String DEFAULT_PASSWORD = "anonymous";
  String USERNAME = "username";
  String PASSWORD = "password";
  String MESSAGE = "message";
  String CF_JNDINAME = "transport.jms.ConnectionFactoryJNDIName";
  String username;
  String password;
  Object payload;
  Object o;
  HashMap connectorMap ;
  HashMap cfMap;
  static Context ictx = null;
  String info;

  public SOAPJMSBridge()
  {
  }

  /*
   *
   *
   */
  public Element[] invoke(Element[] elems) {

    try{
      DocumentBuilder builder = DocumentBuilderFactory.newInstance().newDocumentBuilder();
      Document doc            = builder.newDocument();
      Element dataElem       = doc.createElementNS("urn:message", "e1");

      if(elems.length == 0){
        CDATASection data      = doc.createCDATASection("Text with\n\tImportant  <b> What your input is wrong </b> and tags! ");
        dataElem.appendChild(data);
        Element[] returnArray  = {dataElem};
        return returnArray;
      }
      else if (elems.length ==1){
        username = DEFAULT_USERNAME;
        password = DEFAULT_PASSWORD;
        payload  = elems[0].getLastChild().getNodeValue();
        CDATASection data  = doc.createCDATASection(invoke(payload));
        //DocumentBuilder builder = DocumentBuilderFactory.newInstance().newDocumentBuilder();
        //Document doc            = builder.newDocument();

        //Element cdataElem       = doc.createElementNS("message", "e3");
        dataElem.appendChild(data);
        Element[] returnArray  = {dataElem};
        return returnArray;
      }
      else if(elems.length == 2){
        CDATASection data      = doc.createCDATASection("What your input is wrong");
        dataElem.appendChild(data);
        Element[] returnArray  = {dataElem};
        return returnArray;
      }
      else if(elems.length>2){
        for(int i = 0; i < elems.length ; i ++){
          if(elems[i].getNamespaceURI().equals(USERNAME)){
            username = XMLUtils.getInnerXMLString(elems[i]);
          }else if(elems[i].getNamespaceURI().equals(PASSWORD)){
            password = XMLUtils.getInnerXMLString(elems[i]);
          }else if(elems[i].getNamespaceURI().equals(MESSAGE)){
            payload  = elems[i].getLastChild().getNodeValue();
          }
        }
        //username = XMLUtils.getInnerXMLString(elems[0]);
        //password = XMLUtils.getInnerXMLString(elems[1]);
        CDATASection data  = doc.createCDATASection(invoke(payload));
        dataElem.appendChild(data);
        Element[] returnArray  = {dataElem};
        return returnArray;
      }

    }catch(ParserConfigurationException e){
      Element[] returnArray  = {XMLUtils.StringToElement("urn:wrongmessage","e1",e.getMessage())};
      return returnArray;
    }
    //I don't know what's state?
    Element[] returnArray  = {XMLUtils.StringToElement("urn:wrongmessage","e1","please send your message again")};
    return returnArray;
  }

  /*
   *
   *
   */
  public SOAPBodyElement[] invoke(SOAPBodyElement[] bodies) throws Exception{

   // try{

/*
      Iterator yes = bodies[0].getChildElements();
      int j = 0;
      Element[] yeselems = new Element[10];
      while(yes.hasNext()){
        yeselems[j] = (Element)yes.next();
        j ++;
      }
      DocumentBuilder builder = DocumentBuilderFactory.newInstance().newDocumentBuilder();
      Document doc            = builder.newDocument();
      Element dataElem       = doc.createElementNS("urn:message", "e1");
      if(bodies.length == 0){
        CDATASection data      = doc.createCDATASection("Text with\n\tImportant  <b> What your input is wrong </b> and tags! ");
        dataElem.appendChild(data);
        SOAPBodyElement[] returnArray = {new org.apache.axis.message.SOAPBodyElement(dataElem)};
        return returnArray;
      }
      if(bodies.length == 1){
        Iterator it = bodies[0].getChildElements();
        int i = 0;
        Element[] elems = new Element[10];
        while(it.hasNext()){
          i ++;
          elems[i] = (Element)it.next();
        }
        Element[] reselems = invoke(elems);
        SOAPBodyElement[] resSBelems = {new org.apache.axis.message.SOAPBodyElement(reselems[0])};
        return resSBelems;
      }else if(bodies.length != 1){
        CDATASection data      = doc.createCDATASection("Text with\n\tImportant  <b> What your input is wrong </b> and tags! ");
        dataElem.appendChild(data);
        SOAPBodyElement[] resSBelems = {new org.apache.axis.message.SOAPBodyElement(dataElem)};
        return resSBelems;
      }
    }catch(ParserConfigurationException e){
      Element dataElem  = XMLUtils.StringToElement("urn:wrongmessage","e1",e.getMessage());
      SOAPBodyElement[] returnArray = {new org.apache.axis.message.SOAPBodyElement(dataElem)};
      return returnArray;
    }
      */
    Element[] dataElem  = invoke(SOAPBodyElement2Element(bodies));
    SOAPBodyElement[] returnArray = new SOAPBodyElement[dataElem.length];
    for(int i = 0 ; i < dataElem.length; i ++){
      try{
        returnArray[i] = new SOAPBodyElement(dataElem[i]);
      }catch(Exception e){
        String wrongmsg = e.getMessage();
        InputStream   input   = new ByteArrayInputStream(wrongmsg.getBytes());
        SOAPBodyElement[] wrongSBElement = {new SOAPBodyElement(input)};
        return wrongSBElement;
      }
    }
    return returnArray;
  }

  /*
   *
   *
   */
  public Document invoke(Document doc)
      throws Exception
  {


    Element ele   = doc.getDocumentElement();
    //NodeList nl = ele.getChildNodes() ;
    //Node node = nl.item(0) ;
    //nl =  node.getChildNodes() ;

    //Node node = doc.getLastChild() ;
    //String ss = ((Element)node).getNamespaceURI();
    Vector els = new Vector();

    //for (int i = 0; i < nl.getLength(); i++) {

    //  Node thisNode = nl.item(i);
    //  if (!(thisNode instanceof Element))
    //    continue;

    //  Element el = (Element)thisNode;
    //if (ele.getNamespaceURI().equals(USERNAME)) {
    //    els.add(ele);
    //}
    //if (el.getNamespaceURI().equals(PASSWORD)) {
    //    els.add(el);
    //}
    if (ele.getNamespaceURI().equals(MESSAGE)) {
        els.add(ele);
    }else throw new Exception("Document Must Hold Nothing Except the Message");
    //}
    Element [] elements = new Element [els.size()];
    els.toArray(elements);
    Element[] reselems = invoke(elements);
    String s = "";
    for(int i = 0; i < reselems.length; i ++){
      s = s + XMLUtils.ElementToString(reselems[i]);
    }
    StringBufferInputStream stringStream = new StringBufferInputStream(s);

    //Element ele   = doc.getDocumentElement();

    return XMLUtils.newDocument(stringStream);

    }

    /*
    SOAPBodyElement[] reqSBElemnt = {new SOAPBodyElement(doc.getDocumentElement())};
    SOAPBodyElement[] respSBElemnt = invoke(reqSBElemnt);
    Document returndoc;

    try{
      returndoc = ((SOAPBodyElement)respSBElemnt[0]).getAsDocument();
      return returndoc;
    }catch(Exception e){
      //fill the exception message in the wrong message document,then return
      DocumentBuilder builder = DocumentBuilderFactory.newInstance().newDocumentBuilder();
      Document datadoc            = builder.newDocument();

      Element cdataElem       = datadoc.createElementNS("wrongmessage", "e3");
      CDATASection cdata      = datadoc.createCDATASection(e.getMessage());
      cdataElem.appendChild(cdata);
      return datadoc;
    }
    */


  /*
   *
   *
   */
  public void invoke(SOAPEnvelope req, SOAPEnvelope resp) throws Exception{

      SOAPBody body = req.getBody();
      Iterator it = body.getChildElements();
      Vector els = new Vector();

      while(it.hasNext()){
        els.add((SOAPBodyElement)it.next());
      }
      SOAPBodyElement[] elems = new org.apache.axis.message.SOAPBodyElement[els.size()];
      els.toArray(elems);
      SOAPBodyElement[] reselems = invoke(elems);
      for (int i = 0 ; i < reselems.length ; i ++){
        //resp.addChildElement(reselems[i]);
        resp.getBody().addChildElement(reselems[i]);
      }
  }

  /*
   *
   *
   */
  public String invoke(Object o){

     try{
       //connectorMap = SimpleJMSListener.createConnectorMap(isTopic);
       cfMap = SimpleJMSListener.createCFMap(JMSConstants.getJNDIFileName());
       boolean isTopic = isTopic((String)cfMap.get(CF_JNDINAME));
       sendJMSMessage(JMSConstants.getJNDIFileName(),JMSConstants.getJMSConfigMessageType(),
                              o,JMSConstants.getDestinationName(),
                              //true,username,password);//for topic application
                              isTopic,username,password);//for queue application
     }catch(Exception e){
       info = e.getMessage();
       return info;
     }
     info = "your message have been accepted";
     return info;
  }
  /*
   * added by zk : judge if service is configed to use Topic destination.
   * 2003.7.4
   */
  public boolean isTopic(String connectionFactory) throws Exception{
    //java.util.Hashtable env = new java.util.Hashtable();
    //env.put("java.naming.factory.initial",
    //        "fr.dyade.aaa.jndi2.client.NamingContextFactory");
    //env.put("java.naming.factory.host", " localhost");
    //env.put("java.naming.factory.port", "" + 16400);
    //env.put(Context.PROVIDER_URL,"joram://localhost:16400");
    // getting initial context
    //ictx = new InitialContext(env);
    Hashtable environment = new Hashtable(cfMap);
    ictx = new InitialContext(environment);
    ConnectionFactory cf = (ConnectionFactory)ictx.lookup(connectionFactory);
    if(cf instanceof QueueConnectionFactory){
      return false;
    }
    else return true;
  }






  private Element[] SOAPBodyElement2Element(SOAPBodyElement[] bodies) throws Exception{

    Element[] elems = new Element[bodies.length];
    for(int i = 0 ; i < bodies.length; i ++){
      if(bodies[i].getNamespaceURI().equals(USERNAME)){
        elems[i] = XMLUtils.StringToElement("urn:"+USERNAME,"e1",bodies[i].getValue());
      }
      else if(bodies[i].getNamespaceURI().equals(PASSWORD)){
        elems[i] = XMLUtils.StringToElement("urn:"+PASSWORD,"e1",bodies[i].getValue());
      }else if (bodies[i].getNamespaceURI().equals(MESSAGE)){
        elems[i] = bodies[i].getAsDOM();
      }
    }
    //elems[0] = XMLUtils.StringToElement("urn:username","e1",bodies[0].getValue());
    //elems[1] = XMLUtils.StringToElement("urn:password","e1",bodies[1].getValue());
    //elems[2] = bodies[2].getAsDOM();
    return elems;
  }

  /*
   *
   * Ϣ
   *
   */
  private void sendJMSMessage(String JNDIPropertiesFileName,String JMSMessageType,
                             Object payload,
                             String destinaionName, boolean isTopic,
                             String usename, String password)
              throws Exception,IOException
  {

    String destination = destinaionName;//configuration destinationName
    String clientConfigJMSType = JMSMessageType;
    String clientusername = usename;//
    String clientpassword = password;//
    connectorMap = SimpleJMSListener.createConnectorMap(isTopic);

    //cfMap = SimpleJMSListener.createCFMap(JNDIPropertiesFileName);//jndi-connection-factory.propertiesļ

    listener = new SimpleJMSListener(connectorMap,
                                     cfMap,
                                     destination,
                                     clientusername,
                                     clientpassword,
                                     true);
    listener.start();
    //
    listener.getConnector().getSendConnection().send(listener.getEndpoint(),clientConfigJMSType,
                                                     payload,null);
    //listener.getConnector()

    listener.shutdown();
  }


//1. subscribe to the targed destination
//2. record the incoming url for the future feedback, the feedback message is processed by SimpleJMSWorker
// add ed by zk
  public String subscribe(String usename, String password,String url,
                          String JNDIPropertiesFileName,
                          String JMSMessageType, String destinationName)
                throws Exception,IOException{

    String destination = destinationName;//destinationName
    String clientConfigJMSType = JMSMessageType;
    String clientusername = usename;//
    String clientpassword = password;//
    HashMap connectorMap = SimpleJMSListener.createConnectorMap(true);

    HashMap cfMap = SimpleJMSListener.createCFMap(JNDIPropertiesFileName);//jndi-connection-factory.propertiesļ

    listener = new SimpleJMSListener(connectorMap,
                                     cfMap,
                                     destination,
                                     clientusername,
                                     clientpassword,
                                     true);
    listener.start();
    //\u6DFB\u52A0\u5BF9URL\u8FDB\u884C\u5904\u7406

    return "ok";

  }

/*
  public SimpleJMSListener createJDS(HashMap configconnectorMap, HashMap cfMap,
                                     String destinationName, String username,
                                     String password, boolean isTopic)
      throws Exception,IOException
  {
    String destination = destinationName;//õdestinationName
    //String clientConfigJMSType = JMSMessageType;
    String clientusername = username;//
    String clientpassword = password;//
    HashMap connectorMap = SimpleJMSListener.createConnectorMap(isTopic);

    //HashMap cfMap = SimpleJMSListener.createCFMap(JNDIPropertiesFileName);//jndi-connection-factory.propertiesļ

    listener = new SimpleJMSListener(connectorMap,
                                     cfMap,
                                     destination,
                                     clientusername,
                                     clientpassword,
                                     true);
    listener.start();


  }
  */
}
