package net.starmiddleware.starws2.security.rbac;

import org.apache.axis.handlers.BasicHandler;
import org.apache.axis.*;
import org.apache.axis.message.*;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;

import org.w3c.dom.*;
import java.io.*;

import com.sun.xacml.*;
import com.sun.xacml.attr.*;
import com.sun.xacml.combine.*;
import com.sun.xacml.cond.*;
import com.sun.xacml.ctx.*;
import com.sun.xacml.finder.*;
import com.sun.xacml.finder.impl.*;

import org.apache.axis.components.logger.LogFactory;
import org.apache.commons.logging.Log;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: </p>
 * @author zm
 * @version 1.0
 */

//can be added to Handler chain, responsible for access control
public class AccessControlHandler
    extends BasicHandler {

  String log4AccessControl = RBACUtil.getSystemRootPath() + //getOption("relativeRootPath") +
      "//conf/security/rbac/logs/AccessControl.log";

  protected static Log log = LogFactory.getLog(AccessControlHandler.class.
                                               getName());

  public void invoke(MessageContext msgContext) throws org.apache.axis.
      AxisFault {

    String user = msgContext.getUsername();
    String role = null;
    boolean isAccessPermit = false;

    String service = null;
    String method = null;

    RBACUtil.log4String(log4AccessControl, "");

    try {

      MessageElement elem = (MessageElement) msgContext.getCurrentMessage().
          getSOAPEnvelope().getBody().getChildElements().next();
      service = elem.getNamespaceURI();
      method = elem.getName();


      Document doc = UserManager.getDocumentInstance();

      NodeList userNodeList = doc.getElementsByTagName("user");

      if (userNodeList != null) {
        for (int i = 0; i < userNodeList.getLength(); i++) {
          Element userElement = (Element) userNodeList.item(i);

          if (userElement.getAttribute("name").equals(user)) {
            NodeList roleNodeList = userElement.getElementsByTagName("role");

            if (roleNodeList != null) {
              for (int j = 0; j < roleNodeList.getLength(); j++) {
                Element roleElement = (Element) roleNodeList.item(j);
                role = roleElement.getAttribute("name");
                isAccessPermit = accessDecision(role, service, method, log4AccessControl);
                if (isAccessPermit)
                  break;
              }
            }
          }
        }
      }

    }
    catch (Exception e) {
      throw AxisFault.makeFault(e);
    }


    String log = "user:   " + user + "   service:   " + service +
        "   method:   " + method;
    if (isAccessPermit) {
      RBACUtil.log4User(log4AccessControl, log + "   >>>   access permitted");
    }
    else {
      RBACUtil.log4User(log4AccessControl, log + "   >>>   access denied");
    }

    if (!isAccessPermit)
      throw AxisFault.makeFault(new Exception("ûȨʸ÷򷽷"));
  }


  private static boolean accessDecision(String role, String service,
                                        String method, String log4AccessControl) throws Exception {
    boolean isPermit = false;


    RequestCtx request = RequestProducer.makeRequest(role, service, method);

    String policyFile = PermissionManager.POLICY_REPOSITORY + role + ".xml";


    SimplePDP pdp = new SimplePDP(policyFile);
    ResponseCtx response = pdp.evaluate(request);


    Object[] results = response.getResults().toArray();
    for (int i = 0; i < results.length; i++) {
      Result result = (Result) results[i];
      int decision = result.getDecision();
      if (decision == Result.DECISION_PERMIT) {
        isPermit = true;
        break;
      }
    }

    String log = "role:   " + role + "  service:   " + service +
        "   method:   " + method;
    if (isPermit) {
      RBACUtil.log4Role(log4AccessControl, log + "   >>>   access permitted");
    }
    else {
      RBACUtil.log4Role(log4AccessControl, log + "   >>>   access denied");
    }

    return isPermit;
  }
}
