package net.starmiddleware.starws2.security.rbac;

import org.apache.axis.handlers.BasicHandler;
import org.apache.axis.*;
import org.apache.axis.handlers.BasicHandler;
import org.apache.axis.*;
import org.apache.axis.message.*;
import org.apache.axis.encoding.DeserializationContextImpl;
import java.io.IOException;
import java.io.InputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.*;
import java.security.InvalidAlgorithmParameterException;
import java.security.InvalidKeyException;
import java.security.KeyStore;
import java.security.KeyStoreException;
import java.security.NoSuchAlgorithmException;
import java.security.NoSuchProviderException;
import java.security.cert.CertificateException;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;

import javax.crypto.BadPaddingException;
import javax.crypto.IllegalBlockSizeException;
import javax.crypto.NoSuchPaddingException;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.transform.TransformerException;
import javax.xml.transform.dom.*;
import javax.xml.transform.*;
import javax.xml.transform.stream.*;

import com.ibm.dom.util.DOMUtil;
import com.ibm.xml.dsig.IDResolver;
import com.ibm.xml.dsig.XSignatureException;
import com.ibm.xml.enc.AlgorithmFactoryExtn;
import com.ibm.xml.enc.EncryptedKeyRetriever;
import com.ibm.xml.enc.EncryptionContext;
import com.ibm.xml.enc.EncryptionEngine;
import com.ibm.xml.enc.DecryptionContext;
import com.ibm.xml.enc.KeyInfoResolver;
import com.ibm.xml.enc.KeyInfoResolvingException;
import com.ibm.xml.enc.StructureException;
import com.ibm.xml.enc.type.EncryptedData;
import com.ibm.xml.enc.util.AdHocIdResolver;
import com.ibm.xml.enc.util.KeyStoreKeyInfoResolver;
import com.ibm.xml.enc.util.SameDocumentEncryptedKeyRetriever;

import org.apache.xerces.parsers.DOMParser;
import org.apache.xml.serialize.OutputFormat;
import org.apache.xml.serialize.XMLSerializer;
import org.apache.xpath.XPathAPI;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.xml.sax.ErrorHandler;
import org.xml.sax.SAXException;
import org.xml.sax.SAXParseException;
import org.xml.sax.InputSource;

//import com.ibm.crypto.provider.IBMJCE;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: </p>
 * @author zm
 * @version 1.0
 */

public class DecryptionHandler
    extends BasicHandler {


  static String KEY_INFO_FILE = "keyinfoFile";
  static String SECURITY_PROVIDER = "securityProvider";

  static String MESSAGE_TYPE = "messageType";


  //implement the BasicHandler's abstract method
  public void invoke(MessageContext msgContext) throws org.apache.axis.
      AxisFault {

    try {
      String relativeRootPath = RBACUtil.getSystemRootPath();
          //(String) getOption("relativeRootPath");

      //get the Document to be decrypted
      Document d = msgContext.getCurrentMessage().getSOAPEnvelope().
          getAsDocument();

      int length = (d.getElementsByTagName("EncryptedData")).getLength();

      if (length == 0) {
        return;
      }
      else {
        System.out.println(
            "*************enter DecryptionHandler***************");

        //prepare the security provider
        AlgorithmFactoryExtn af = new AlgorithmFactoryExtn();
        if (!"*".equals( (String) getOption(SECURITY_PROVIDER))) {
          af.setProvider( (String) getOption(SECURITY_PROVIDER));
        }


        //prepare the keystore and keys's info
        Keyinfo ki = getKeyinfo(relativeRootPath +
                                (String) getOption(KEY_INFO_FILE));


        IDResolver ir = new AdHocIdResolver();

        EncryptedKeyRetriever ekr = new SameDocumentEncryptedKeyRetriever(d);

        KeyInfoResolver kir = getKeyInfoResolver(ki, af, ir, ekr);
        kir.setOperationMode(KeyInfoResolver.DECRYPT_MODE);

        DecryptionContext dc = new DecryptionContext();
        dc.setAlgorithmFactory(af);
        dc.setKeyInfoResolver(kir);
        dc.setIdResolver(ir);
        dc.setEncryptedKeyRetriever(ekr);

        //get the element to be decrypted
        NodeList nl = XPathAPI.selectNodeList(d,
                                              "//*[namespace-uri()='http://www.w3.org/2001/04/xmlenc#' and local-name()='EncryptedData']");

        //decrypt
        decryptEncryptedData(nl, dc);

        printDocument(d);

        //substitute the old SOAP message
        Transformer t = TransformerFactory.newInstance().
            newTransformer();
        Writer w = new StringWriter();
        t.transform(new DOMSource(d), new StreamResult(w));
        SOAPEnvelope newSe = new SOAPEnvelope(
            new ByteArrayInputStream(w.toString().getBytes()));
        String type = (String) getOption(MESSAGE_TYPE);
        DeserializationContextImpl dser =
            new DeserializationContextImpl(new InputSource(
            new ByteArrayInputStream(
            w.toString().getBytes())),
                                           msgContext, type, newSe);
        dser.parse();
        msgContext.setCurrentMessage(new Message(newSe));
      }

    }
    catch (Exception e) {
      throw AxisFault.makeFault(e);
    }

  }

  private static void decryptEncryptedData(NodeList nodes,
                                           DecryptionContext context) {
    for (int i = 0, l = nodes.getLength(); i < l; i++) {
      Node n = nodes.item(i);
      if (n.getNodeType() == Node.ELEMENT_NODE) {
        Element el = (Element) n;
        if (EncryptedData.isOfType(el)) {
          try {
            decryptEncryptedData(el, context);

          }
          catch (Exception ex) {
            printStackTrace(ex);
          }
        }
      }
    }
  }


  private static void decryptEncryptedData(Element encData,
                                           DecryptionContext context) throws
      BadPaddingException, IOException, IllegalBlockSizeException,
      InvalidAlgorithmParameterException, InvalidKeyException,
      KeyInfoResolvingException, NoSuchAlgorithmException,
      NoSuchPaddingException,
      NoSuchProviderException, ParserConfigurationException, SAXException,
      StructureException, XSignatureException {
    context.setEncryptedType(encData, null, null, null);
    context.setKey(null);
    context.decrypt();
    context.replace();
  }


  static Document getDocument(String name) throws IOException, SAXException {
    DOMParser dp = new DOMParser();
    dp.setErrorHandler(new ErrorHandler() {
      //
      // Methods of interface: ErrorHandler
      //

      public void warning(SAXParseException exception) throws
          SAXException {
        printStackTrace(exception);
      }

      public void error(SAXParseException exception) throws SAXException {
        printStackTrace(exception);
      }

      public void fatalError(SAXParseException exception) throws
          SAXException {
        throw exception;
      }
    });
    dp.setFeature("http://apache.org/xml/features/dom/defer-node-expansion", false);
    dp.parse(name);

    return dp.getDocument();
  }


  static Keyinfo getKeyinfo(String name) throws IOException, SAXException {
    Element e = getDocument(name).getDocumentElement();

    return new Keyinfo(e);
  }


  static KeyStore getKeyStore(Keyinfo keyinfo) throws CertificateException,
      IOException, KeyStoreException, NoSuchAlgorithmException,
      NoSuchProviderException {
    String s = keyinfo.fStoretype;
    if (s == null) {
      s = KeyStore.getDefaultType();
    }
    KeyStore store = null;
    if (keyinfo.fProvider != null) {
      store = KeyStore.getInstance(s, keyinfo.fProvider);

    }
    else {
      store = KeyStore.getInstance(s);
    }

    s = keyinfo.fStorename;
    if (s == null) {
      s = System.getProperty("user.home") + File.separator + ".keystore";
    }
    File f = new File(s);
    InputStream is = null;
    if (f.exists()) {
      is = new FileInputStream(f);
    }
    store.load(is, keyinfo.fStorepass);

    return store;
  }


  static KeyInfoResolver getKeyInfoResolver(Keyinfo keyinfo,
                                            AlgorithmFactoryExtn factory,
                                            IDResolver idRes,
                                            EncryptedKeyRetriever retriever) throws
      CertificateException, IOException, KeyStoreException,
      NoSuchAlgorithmException,
      NoSuchProviderException {
    return getKeyInfoResolver(keyinfo, factory, idRes, retriever,
                              getKeyStore(keyinfo));
  }


  static KeyInfoResolver getKeyInfoResolver(Keyinfo keyinfo,
                                            AlgorithmFactoryExtn factory,
                                            IDResolver idRes,
                                            EncryptedKeyRetriever retriever,
                                            KeyStore store) {
    KeyStoreKeyInfoResolver kiRes = new KeyStoreKeyInfoResolver(store);
    kiRes.setAlgorithmFactory(factory);
    kiRes.setIdResolver(idRes);
    kiRes.setEncryptedKeyRetriever(retriever);
    for (Iterator i = keyinfo.fAlias2Keypass.keySet().iterator(); i.hasNext(); ) {
      String s = (String) i.next();
      kiRes.putAliasAndPassword(s, (char[]) keyinfo.fAlias2Keypass.get(s));
    }

    return kiRes;
  }


  static class Keyinfo {
    //
    // Data
    //

    String fStorename;
    String fStoretype;
    char[] fStorepass;
    String fProvider;
    Map fAlias2Keypass;

    private String alias;
    private char[] pass;

    //
    // Constructors
    //

    Keyinfo(Element keyinfo) {
      if (!isOfType(keyinfo)) {
        throw new IllegalArgumentException("Not keyinfo element");
      }

      fAlias2Keypass = new HashMap();
      init(keyinfo);
    }

    //
    // Methods
    //

    static boolean isOfType(Element elem) {
      return (elem != null && "keyinfo".equals(elem.getTagName()));
    }

    private void init(Node node) {
      for (Node n = node.getFirstChild(); n != null; n = n.getNextSibling()) {
        init(n);
      }

      if (node.getNodeType() == Node.ELEMENT_NODE) {
        String s = node.getNodeName();
        if (s.equals("alias")) {
          alias = DOMUtil.getStringValue(node);

        }
        else if (s.equals("key")) {
          fAlias2Keypass.put(alias, pass);
          alias = null;
          pass = null;

        }
        else if (s.equals("keystore")) {
          fStorepass = pass;
          pass = null;

        }
        else if (s.equals("name")) {
          fStorename = RBACUtil.getSystemRootPath() + DOMUtil.getStringValue(node);

        }
        else if (s.equals("password")) {
          pass = DOMUtil.getStringValue(node).toCharArray();

        }
        else if (s.equals("provider")) {
          fProvider = DOMUtil.getStringValue(node);

        }
        else if (s.equals("type")) {
          fStoretype = DOMUtil.getStringValue(node);
        }
      }
    }
  }


  static void printStackTrace(Throwable thr) {
    if (thr instanceof SAXException) {
      Throwable t = ( (SAXException) thr).getException();
      if (t != null) {
        thr = t;
      }
    }
    else if (thr instanceof TransformerException) {
      Throwable t = ( (TransformerException) thr).getException();
      if (t != null) {
        thr = t;
      }
    }
    else if (thr instanceof XSignatureException) {
      Throwable t = ( (XSignatureException) thr).getException();
      if (t != null) {
        thr = t;
      }
    }
    thr.printStackTrace();
  }


  static void printDocument(Document doc) throws IOException {
    OutputFormat of = new OutputFormat(doc);
    of.setPreserveSpace(true);
    XMLSerializer xs = new XMLSerializer(System.out, of);
    xs.serialize(doc);
    System.out.println();
  }

}
