package net.starmiddleware.starws2.security.rbac;

import java.net.URI;
import java.net.URISyntaxException;

import java.util.ArrayList;
import java.util.Collections;
import java.util.Iterator;
import java.util.List;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;

import com.sun.xacml.*;
import com.sun.xacml.attr.*;
import com.sun.xacml.combine.*;
import com.sun.xacml.cond.*;
import com.sun.xacml.ctx.*;
import com.sun.xacml.finder.*;
import com.sun.xacml.finder.impl.*;

import org.w3c.dom.*;
import java.io.*;
//import org.apache.xml.security.utils.XMLUtils;
import org.apache.axis.utils.XMLUtils;

import org.apache.axis.*;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: </p>
 * @author zm
 * @version 1.0
 */


public class RoleManager {


    public static String ROLE_USER_FILE = RBACUtil.getSystemRootPath() +
       // System.getProperty("user.dir") +
       "//conf/security/rbac/role.xml";

   //ROLE_USER_FILEʼһļ
    public static File file = new File(ROLE_USER_FILE);

    //ָ¼ɫ־ļ·
    private static String log4Role = RBACUtil.getSystemRootPath() +
       // System.getProperty("user.dir") +
       "//conf/security/rbac/logs/Role.log";

    //ɫļһɫ
    public static String addRole(String role) throws AxisFault {
        try {

            if (role.equals("")) {
                return  "Role name maybe empty, please assign it first.";
            }
            else {
                boolean role_exist = contains(role);

                if (role_exist) {
                    return "Role: " + role + "  already exists.";
                }

                else {
                    Document doc = getDocument();
                    Element root = doc.getDocumentElement();

                    Element newRoleElement = doc.createElement("role");
                    newRoleElement.setAttribute("name", role);

                    root.appendChild(newRoleElement);
                    root.appendChild(doc.createTextNode("\n"));

                    outputDocument(doc);
                    return  "Succeeded in adding role: " + role ;
                }
            }

        }
        catch (Exception e) {
            throw AxisFault.makeFault(e);
        }
    }


    public static String deleteRole(String role) throws AxisFault {
        try {

            if (role.equals("")) {
                return  "Role name maybe empty, please assign it first.";
            }
            else {
                boolean role_exist = contains(role);

                if (!role_exist) {
                    return  "Role: " + role + "  not exist.";
                }
                else {
                    Document doc = getDocument();
                    NodeList roleNodeList = doc.getElementsByTagName("role");
                    if (roleNodeList != null) {
                        for (int i = 0; i < roleNodeList.getLength(); i++) {
                            Element roleElement = (Element) roleNodeList.item(i);
                            if (roleElement.getAttribute("name").equals(role)) {
                                Node text = roleElement.getNextSibling();
                                Element root = doc.getDocumentElement();
                                root.removeChild(roleElement);
                                root.removeChild(text);
                                break;
                            }
                        }
                    }
                    UserManager.deleteRole(role);
                    outputDocument(doc);
                    return  "Succeeded in deleting Role: " + role ;
                }
            }

        }
        catch (Exception e) {
            throw AxisFault.makeFault(e);
        }
    }

    public static Document getDocument() throws Exception {
        DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
        factory.setIgnoringComments(true);

        DocumentBuilder builder = null;

        factory.setNamespaceAware(false);
        factory.setValidating(false);

        builder = factory.newDocumentBuilder();

        Document doc = builder.parse(file);
        return doc;
    }


    public static void outputDocument(Document doc) throws Exception {
        XMLUtils.DocumentToStream(doc, System.out);
        System.out.println();
        FileOutputStream fos = new FileOutputStream(file);
        XMLUtils.DocumentToStream(doc, fos);
        fos.close();
    }


    public static boolean contains(String role) throws AxisFault {
        try {
            Document doc = getDocument();
            NodeList roleNodeList = doc.getElementsByTagName("role");

            boolean role_exist = false;

            if (roleNodeList != null) {
                for (int i = 0; i < roleNodeList.getLength(); i++) {
                    Element roleElement = (Element) roleNodeList.item(i);
                    if (roleElement.getAttribute("name").equals(role)) {
                        role_exist = true;
                        break;
                    }
                }
            }

            return role_exist;

        }
        catch (Exception e) {
            throw AxisFault.makeFault(e);
        }
    }

    public static NodeList listAllRoles() throws AxisFault {
        try {
            Document doc = getDocument();
            NodeList userNodeList = doc.getElementsByTagName("role");
            return userNodeList;
        }
        catch (Exception e) {
            throw AxisFault.makeFault(e);
        }
    }

    public static void main(String[] args) throws Exception {
        RoleManager rm = new RoleManager();
        String test = //rm.deleteRole("worker");
            rm.addRole("worker");
        System.out.println(test);
    }

}
