package net.starmiddleware.starws2.security.rbac;

import java.io.*;
import java.security.*;
import java.security.cert.*;
import java.util.*;
import java.math.*;
import sun.security.x509.*;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: </p>
 * @author zm
 * @version 1.0
 */

//this class is used for creating a valid certificate signed by CA.

public class SignCert {
  public static void main(String[] args) throws Exception {
    String relativeRootPath = RBACUtil.getSystemRootPath();

    //get relating parameters
    String CAKeystoreFile = null;
    char[] CAStorepass = null;
    char[] CAKeypass = null;
    String CAStoretype = null;
    String CACertificateAlias = null;
    String CAPrivateKeyAlias = null;
    String ClientOriginalCertificateFile = null;
    String ClientGeneratedKeystoreFile = null;
    String ClientGeneratedCertificateAlias = null;
    char[] ClientStorepass = null;

    for (int i = 0; i < args.length; i++) {
      if (args[i].equals("-CAKeystoreFile")) {
        // CA's keystore, storepass, keypass.
        i++;
        CAKeystoreFile = relativeRootPath + args[i];
        //"conf/security/rbac/keystore.jks";
      }
      else if (args[i].equals("-CAStorepass")) {
        i++;
        CAStorepass = args[i].toCharArray();
        //"xmlsecurity".toCharArray();
      }
      else if (args[i].equals("-CAKeypass")) {
        i++;
        CAKeypass = args[i].toCharArray();
        //"xmlsecurity".toCharArray();
      }
      else if (args[i].equals("-CAStoretype")) {
        i++;
        CAStoretype = args[i];
      }
      else if (args[i].equals("-CACertificateAlias")) {
        i++;
        CACertificateAlias = args[i];
      }
      else if (args[i].equals("-CAPrivateKeyAlias")) {
        i++;
        CAPrivateKeyAlias = args[i];
      }
      else if (args[i].equals("-ClientOriginalCertificateFile")) {
        i++;
        ClientOriginalCertificateFile = relativeRootPath + args[i];
      }
      else if (args[i].equals("-ClientGeneratedKeystoreFile")) {
        i++;
        ClientGeneratedKeystoreFile = relativeRootPath + args[i];
      }
      else if (args[i].equals("-ClientGeneratedCertificateAlias")) {
        i++;
        ClientGeneratedCertificateAlias = args[i];
      }
      else if (args[i].equals("-ClientStorepass")) {
        i++;
        ClientStorepass = args[i].toCharArray();
      }

    }

    //get CA's KeyStore
    FileInputStream in = new FileInputStream(CAKeystoreFile);
    KeyStore ks = KeyStore.getInstance(CAStoretype);
    ks.load(in, CAStorepass);

    //get CA's certificate
    java.security.cert.Certificate c1 = ks.getCertificate(CACertificateAlias);
    //get CA's private key
    PrivateKey caprk = (PrivateKey) ks.getKey(CAPrivateKeyAlias, CAKeypass);
    in.close();

    byte[] encod1 = c1.getEncoded();
    X509CertImpl cimp1 = new X509CertImpl(encod1);

    //get CA's certificate's infomation.
    X509CertInfo cinfo1 = (X509CertInfo) cimp1.get(X509CertImpl.NAME + "." +
        X509CertImpl.INFO);
    //get CA's certificate's subject name.
    X500Name issuer = (X500Name) cinfo1.get(X509CertInfo.SUBJECT + "." +
                                            CertificateIssuerName.DN_NAME);

    //get user's original certificate
    CertificateFactory cf = CertificateFactory.getInstance("X.509");
    FileInputStream in2 = new FileInputStream(ClientOriginalCertificateFile);
    java.security.cert.Certificate c2 = cf.generateCertificate(in2);
    X509CertImpl cimp2 = new X509CertImpl(c2.getEncoded());

    //get the old certificate's infomation
    X509CertInfo cinfo2 = (X509CertInfo) cimp2.get(X509CertImpl.NAME + "." +
        X509CertImpl.INFO);

    //the signed certificate's beginning valid date.
    Date begindate = new Date();
    //the signed certificate's ending valid date.
    Date enddate = new Date(begindate.getTime() +
                            3000 * 24 * 60 * 60 * 1000L);

    //set the signed certificate's validity.
    CertificateValidity cv = new CertificateValidity(begindate, enddate);
    cinfo2.set(X509CertInfo.VALIDITY, cv);

    //set the signed certificate's serial number.
    int sn = (int) (begindate.getTime() / 1000);
    CertificateSerialNumber csn = new CertificateSerialNumber(sn);
    cinfo2.set(X509CertInfo.SERIAL_NUMBER, csn);

    //set the signed certificate's issuer name.
    cinfo2.set(X509CertInfo.ISSUER + "." + CertificateIssuerName.DN_NAME,
               issuer);

    //set the signed certificate's algorithm.
    AlgorithmId algo = new AlgorithmId(AlgorithmId.sha1WithDSA_oid);
    cinfo2.set(CertificateAlgorithmId.NAME + "." +
               CertificateAlgorithmId.ALGORITHM, algo);

    X509CertImpl newcert = new X509CertImpl(cinfo2);

    //sign the certificate using CA's private key.
    newcert.sign(caprk, "SHA1WithDSA");
    System.out.println(newcert);

    //set alias for the newcert.
    ks.setCertificateEntry(ClientGeneratedCertificateAlias, newcert);
    //store the new KeyStore in the file "newstore" with storepass "newpass".
    FileOutputStream out = new FileOutputStream(ClientGeneratedKeystoreFile);
    ks.store(out, ClientStorepass);
    out.close();
  }
}
