package net.starmiddleware.starws2.security.rbac;


import org.apache.axis.AxisFault;
import org.apache.axis.Handler;
import org.apache.axis.Message;
import org.apache.axis.MessageContext;
import org.apache.axis.handlers.BasicHandler;
import org.apache.axis.message.SOAPEnvelope;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: </p>
 * @author zm
 * @version 1.0
 */


public class SignatureHandler extends BasicHandler {

    //xmlsec.jar needs initialization
    static {
        org.apache.xml.security.Init.init();
    }

    //private java.util.Hashtable options = new java.util.Hashtable();


    //implement the BasicHandler's abstract method
    public void invoke(MessageContext msgContext) throws AxisFault {

        /** Sign the SOAPEnvelope
         */
        try {
            Handler serviceHandler = msgContext.getService();
            Message requestMessage = msgContext.getRequestMessage();
            SOAPEnvelope unsignedEnvelope = requestMessage.getSOAPEnvelope();

            // need to correctly compute baseuri
            SignedSOAPEnvelope signedEnvelope = new SignedSOAPEnvelope(msgContext, unsignedEnvelope, "http://xml-security", this);

            requestMessage = new Message(signedEnvelope);
            msgContext.setCurrentMessage(requestMessage);
        } catch (Exception e){
            throw AxisFault.makeFault(e);
        }
    }
}
