package net.starmiddleware.starws2.security.rbac;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;

import org.apache.axis.*;
import org.w3c.dom.*;
import java.io.*;
import org.apache.axis.utils.XMLUtils;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: </p>
 * @author not attributable
 * @version 1.0
 */


public class UserManager {

  public static String USER_ROLE_FILE = RBACUtil.getSystemRootPath() +
      // System.getProperty("user.dir") +
      "//conf/security/rbac/user-role.xml";

  public static File file = new File(USER_ROLE_FILE);

  private static Document documentInstance = null;

  public static String addUser(String user) throws AxisFault {
    try {
      if (user.equals("")) {
        return "User name maybe empty, please assign it first.";
      }
      else {
        boolean user_exist = contains(user);
        if (user_exist) {
          return "User: " + user + "  already exists.";
        }
        else {
          Document doc = getDocumentInstance();
          //getDocument();
          Element root = doc.getDocumentElement();

          Element newUserElement = doc.createElement("user");
          newUserElement.setAttribute("name", user);

          root.appendChild(newUserElement);
          root.appendChild(doc.createTextNode("\n"));

          outputDocument(doc);
          return "Succeeded in adding User: " + user;
        }
      }

    }
    catch (Exception e) {
      throw AxisFault.makeFault(e);
    }
  }

  public static String deleteUser(String user) throws AxisFault {
    try {
      if (user.equals("")) {
        return "User name maybe empty, please assign it first.";
      }
      else {
        boolean user_exist = contains(user);

        if (!user_exist) {
          return "User: " + user + "  does not exist.";
        }

        else {
          Document doc = getDocumentInstance();
          //getDocument();
          NodeList userNodeList = doc.getElementsByTagName("user");
          if (userNodeList != null) {
            for (int i = 0; i < userNodeList.getLength(); i++) {
              Element userElement = (Element) userNodeList.item(i);
              if (userElement.getAttribute("name").equals(user)) {
                Node text = userElement.getNextSibling();
                Element root = doc.getDocumentElement();
                root.removeChild(userElement);
                root.removeChild(text);
                break;
              }
            }
          }

          outputDocument(doc);
          return "Succeeded in deleting User: " + user;
        }
      }
    }
    catch (Exception e) {
      throw AxisFault.makeFault(e);
    }
  }


  public static String assignRole(String user, String role) throws AxisFault {
    try {
      if (!contains(user)) {
        return "User: " + user + " not existed. Please Add it first.";
      }
      else if (!RoleManager.contains(role)) {
        return "Role: " + role + " not existed. Please Add it first.";
      }
      else {
        Document doc = getDocumentInstance();
        NodeList userNodeList = doc.getElementsByTagName("user");

        if (userNodeList != null) {
          for (int i = 0; i < userNodeList.getLength(); i++) {
            Element userElement = (Element) userNodeList.item(i);
            boolean role_assigned = false;

            if (userElement.getAttribute("name").equals(user)) {
              NodeList roleNodeList = userElement.getElementsByTagName("role");

              if (roleNodeList != null) {
                for (int j = 0; j < roleNodeList.getLength(); j++) {
                  Element roleElement = (Element) roleNodeList.item(j);
                  if (roleElement.getAttribute("name").equals(role)) {
                    role_assigned = true;
                    System.out.println(
                        "********************the role has been assigned to the user*******************");
                    break;
                  }
                }
              }

              if (!role_assigned) {
                Element newRoleElement = doc.createElement("role");
                newRoleElement.setAttribute("name", role);
                //userElement.appendChild(doc.createTextNode("\n"));
                userElement.appendChild(newRoleElement);
                userElement.appendChild(doc.createTextNode("\n"));
                outputDocument(doc);
                break;
              }
              else {
                break;
              }
            }

          }

        }
        return "Succeeded in assigning Role: " + role + " for User: " + user;
      }

    }
    catch (Exception e) {
      throw AxisFault.makeFault(e);
    }

  }

  public static void deleteRole(String role) throws
      AxisFault {
    try {
      Document doc = getDocumentInstance();
      NodeList userNodeList = doc.getElementsByTagName("user");

      if (userNodeList != null) {
        for (int i = 0; i < userNodeList.getLength(); i++) {
          Element userElement = (Element) userNodeList.item(i);
          //String user = userElement.getAttribute("name");
          NodeList roleNodeList = userElement.getElementsByTagName(
              "role");
          if (roleNodeList != null) {
            for (int j = 0; j < roleNodeList.getLength(); j++) {
              Element roleElement = (Element) roleNodeList.item(j);
              if (roleElement.getAttribute("name").equals(role)) {
                Node text = roleElement.getNextSibling();
                userElement.removeChild(roleElement);
                userElement.removeChild(text);
                outputDocument(doc);
                System.out.println(
                    "********************the role has been deassigned to the user*******************");
                break;
              }
            }
          }
        }
      }
    }
    catch (Exception e) {
      throw AxisFault.makeFault(e);
    }
  }

  public static String deassignRole(String user, String role) throws
      AxisFault {
    try {
      if (!contains(user)) {
        return "User: " + user + "  not exists. Nothing to do :-)";
      }

      else if (!RoleManager.contains(role)) {
        return "Role: " + role + "  not exists. Nothing to do :-)";
      }
      else {

        Document doc = getDocumentInstance();
        NodeList userNodeList = doc.getElementsByTagName("user");

        if (userNodeList != null) {
          for (int i = 0; i < userNodeList.getLength(); i++) {
            Element userElement = (Element) userNodeList.item(i);
            boolean role_deassigned = false;

            if (userElement.getAttribute("name").equals(user)) {
              NodeList roleNodeList = userElement.getElementsByTagName(
                  "role");

              if (roleNodeList != null) {
                for (int j = 0; j < roleNodeList.getLength(); j++) {
                  Element roleElement = (Element) roleNodeList.item(j);
                  if (roleElement.getAttribute("name").equals(role)) {
                    Node text = roleElement.getNextSibling();
                    userElement.removeChild(roleElement);
                    userElement.removeChild(text);
                    outputDocument(doc);
                    System.out.println(
                        "********************the role has been deassigned to the user*******************");
                    break;
                  }
                }
              }
              role_deassigned = true;
            }

            if (role_deassigned) {
              break;
            }

          }
        }

        return "Succeeded in deassigning Role: " + role+ " for User: " + user ;
      }
    }
    catch (Exception e) {
      throw AxisFault.makeFault(e);
    }
  }

  private static Document getDocument() throws Exception {
    DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
    factory.setIgnoringComments(true);

    DocumentBuilder builder = null;

    factory.setNamespaceAware(false);
    factory.setValidating(false);

    builder = factory.newDocumentBuilder();

    Document doc = builder.parse(file);
    return doc;
  }

  public static Document getDocumentInstance() throws AxisFault {
    if (documentInstance == null) {
      try {
        documentInstance = getDocument();
      }
      catch (Exception e) {
        throw AxisFault.makeFault(e);
      }
    }
    return documentInstance;
  }

  private static void outputDocument(Document doc) throws Exception {

    XMLUtils.DocumentToStream(doc, System.out);
    System.out.println();
    FileOutputStream fos = new FileOutputStream(file);
    XMLUtils.DocumentToStream(doc, fos);
    fos.close();
  }

  private static boolean contains(String user) throws AxisFault {
    try {

      //Document doc = getDocument();
      Document doc = getDocumentInstance();
      NodeList userNodeList = doc.getElementsByTagName("user");

      boolean user_exist = false;

      if (userNodeList != null) {
        for (int i = 0; i < userNodeList.getLength(); i++) {
          Element userElement = (Element) userNodeList.item(i);
          if (userElement.getAttribute("name").equals(user)) {
            user_exist = true;
          }
        }
      }
      return user_exist;

    }
    catch (Exception e) {
      throw AxisFault.makeFault(e);
    }
  }

  public static NodeList listAllUsers() throws AxisFault {
    try {

      Document doc = getDocumentInstance();
      //getDocument();
      NodeList userNodeList = doc.getElementsByTagName("user");
      return userNodeList;
    }
    catch (Exception e) {
      throw AxisFault.makeFault(e);
    }
  }

  public static Node listAssignedRoles(String user) throws AxisFault {
    try {

      if (!contains(user)) {
        return null;
      }
      else {
        Document doc = getDocumentInstance();
        //getDocument();
        NodeList userNodeList = doc.getElementsByTagName("user");
        NodeList roleNodeList = null;

        if (userNodeList != null) {
          for (int i = 0; i < userNodeList.getLength(); i++) {
            Element userElement = (Element) userNodeList.item(i);
            if (userElement.getAttribute("name").equals(user)) {
              return userElement;
            }
          }
        }
        return null;
      }
    }
    catch (Exception e) {
      throw AxisFault.makeFault(e);
    }

  }

  public static void main(String[] args) throws Exception {
    UserManager um = new UserManager();
    NodeList nd = um. //listAssignedRoles("tom");
        listAllUsers();
    for (int i = 0; i < nd.getLength(); i++) {
      System.out.println(XMLUtils.ElementToString( (Element) nd.item(i)));
    }
  }
}
