package net.starmiddleware.starws2.transport.http.admin.deploy;

import java.util.Hashtable;
import org.apache.axis.AxisFault;
import org.apache.axis.description.OperationDesc;
import org.apache.axis.description.ServiceDesc;
import org.apache.axis.utils.*;
import java.util.*;
import javax.servlet.http.*;
import java.io.PrintWriter;
import java.io.IOException;
import org.apache.axis.enum.Style;
import java.util.Enumeration;
/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: </p>
 * @author not attributable
 * @version 1.0
 */

public class JavaServiceDeploy implements ServiceDeploy{
  ServiceDesc desc=new ServiceDesc();

  private String provider="java:RPC";
  private String namespace=null;
  private String scope=null;
  private String isStatic=null;

  Hashtable param=new Hashtable();
  public JavaServiceDeploy() {
  }

  public void setProvider(String in) {
    if (in != null) {
      if (in.equals("1")) {
        provider = "java:RPC";
      }
      else if(in.equals("2")){
         provider="java:MSG";
      }
    }
  }

  public String getProvider() {
    return provider;
  }

  public void setServiceName(String in) {
    if(in!=null)    desc.setName(in);
  }

  public String getName(){
    return desc.getName();
  }

  public void setClassName(String className) throws AxisFault {
    if(className!=null){
      if(desc.getImplClass()!=null){
         if(!desc.getImplClass().getName().equals(className))
           desc=new ServiceDesc();
         else return;
      }
      Class serviceClass = null;
      ClassLoader cl = Thread.currentThread().getContextClassLoader();

      try {
        serviceClass = ClassUtils.forName(className, true, cl);
      }
      catch (ClassNotFoundException e) {

        throw new AxisFault(Messages.getMessage("noClassForService00",
                                                className), e);
      }
      desc.setImplClass(serviceClass);
    }
  }
  public void setAllowedMethods(String methods){
    if(methods==null) return;
    if(!methods.equals("*")){
      ArrayList methodList = new ArrayList();
      StringTokenizer tokenizer = new StringTokenizer(methods, ",");
      while (tokenizer.hasMoreTokens()) {
        methodList.add(tokenizer.nextToken());
      }
      desc.setAllowedMethods(methodList);
    }

  }

  public void addNewParameter(String name,String value){
    if((name==null)||(value==null)) return;
    param.put(name,value);

  }
  public void removeParameter(String name){
    param.remove(name);
  }
  public String toString(boolean isDeploy){
     StringBuffer result=new StringBuffer();
     result.append("<service ");

     if(desc.getName()!=null){
        result.append("name=\""+desc.getName()+"\" ");
        result.append("provider=\""+provider+"\"");
     }
     result.append(">");
     String allowed="";
     if(desc.getAllowedMethods()!=null){
       for (int i = 0; i < desc.getAllowedMethods().size(); i++) {
         allowed += desc.getAllowedMethods().get(i);
         allowed += " ";
       }
     }
     if (!allowed.equals("")) {
         result.append("<parameter name=\"allowedMethods\" value=\"" + allowed +
                       "\"/>");
       }
     else{
       result.append("<parameter name=\"allowedMethods\" value=\"*\"/>");
     }
     if(desc.getImplClass()!=null){
       result.append("<parameter name=\"className\" value=\""+desc.getImplClass().getName()+"\"/>");
       result.append(getMethods());
     }
     if(scope!=null){
       result.append("<parameter name=\"scope\" value=\""+scope+"\"/>");
     }
     if(isStatic!=null){
       result.append("<parameter name=\"isStatic\" value=\""+isStatic+"\"/>");
     }
     if(namespace!=null){
       result.append("<parameter name=\"namespace\" value=\""+namespace+"\"/>");
     }

     if(param.isEmpty()){
       if(!isDeploy){
        result.append("<parameter name=\"temp\"/><parameter name=\"temp\"/><parameter name=\"temp\"/><parameter name=\"temp\"/>");
       }
      }
     else{
       Enumeration enum=param.keys();
       while(enum.hasMoreElements()){
         String key=(String)enum.nextElement();
         result.append("<parameter name=\""+key+"\" value=\""+param.get(key)+"\"> </parameter>");
       }

     }
     result.append("</service>");
     return result.toString();

  }
  public void writeStep(HttpServletResponse response,String step){
        String xsltURI=null;
        if(step.equals("1")) xsltURI="../admin/javaService/addNewService1.xsl";
        else if(step.equals("2")) xsltURI="../admin/javaService/addNewService2.xsl";
        else if(step.equals("3")) xsltURI="../admin/javaService/service.xsl";

       PrintWriter writer=null;
       try {
         writer = response.getWriter();
       }
       catch (IOException e) {
         return ;
       }
       response.setContentType("text/xml");

       writer.println("<?xml version=\"1.0\" encoding=\"UTF-8\"?>");
       writer.println("<?xml-stylesheet type=\"text/xsl\" href=\"" + xsltURI +
                      "\"?>");
       writer.println("<deployment>");
       //writer.println("<service ><parameter/><parameter/><parameter/><parameter/></service>");
       writer.println(this.toString(false));

       writer.println("<action name=\"deployServiceStep\"></action>");
       writer.println("</deployment>");
       writer.close();


  }
  public void setStep(HttpServletRequest request, HttpServletResponse response,String step)
  throws Exception{
    try{
      if (step.equals("1")) {
        setStep1(request, response);
      }
      else if (step.equals("2")) {
        setStep2(request, response);
      }
      else if (step.equals("3")) {
        setStep3(request, response);
      }
    }catch(Exception e){
      throw e;
    }

  }
  private void setStep1(HttpServletRequest request, HttpServletResponse response) throws Exception{



    try {
      setClassName( (String) request.getParameter("className"));
    }
    catch (AxisFault e) {

      throw new Exception("<strong><p>can not load service's class--"+request.getParameter("className")+":</p></strong>"+e.getMessage());
    }
    setServiceName( (String) request.getParameter("name"));

    setProvider( (String) request.getParameter("provider"));

  }
  private void setStep2(HttpServletRequest request, HttpServletResponse response){
    String[] methods=request.getParameterValues("methods");
    if(methods==null) return;
    ArrayList methodList = new ArrayList();
    for(int i=0;i<methods.length;i++){

      methodList.add(methods[i]);

    }
    desc.setAllowedMethods(methodList);

  }
  private void setStep3(HttpServletRequest request, HttpServletResponse response)throws Exception{
     try{
       setStep1(request, response);
     }catch(Exception e){
       throw e;
     }

     String methods=request.getParameter("allowedMethods");
     if(methods!=null){
       ArrayList methodList = new ArrayList();
       StringTokenizer token=new StringTokenizer(methods," ");
      while( token.hasMoreTokens()){

          methodList.add(token.nextToken());

       }
       if(methods.equals("*")){
          ArrayList list=desc.getOperations();
          for(int k=0;k<list.size();k++){
            methodList.add(((OperationDesc)list.get(k)).getName());
          }
       }
      desc.setAllowedMethods(methodList);
     }
     String style=request.getParameter("style");
     Style s=null;
     if(style.equals("RPC"))   s=Style.RPC;
     else if(style.equals("Document"))   s=Style.DOCUMENT;
     else if(style.equals("Wrapper"))   s=Style.WRAPPED;
     else if(style.equals("message"))   s=Style.MESSAGE;
     desc.setStyle(s);

     String tNamespace=request.getParameter("namespace");
     if(tNamespace!=null){
       if(!tNamespace.equals("")) namespace=tNamespace;
     }
     String tScope=request.getParameter("scope");
     if(!tScope.equals("request")) scope=tScope;

     String tIsStatic=request.getParameter("isStatic");
     if(!tIsStatic.equals("false")) isStatic=tIsStatic;

     String[] parameterNames=request.getParameterValues("parametername");
     String[] parameterValues=request.getParameterValues("parametervalue");
     if(parameterNames!=null){
       for (int i = 0; i < parameterNames.length; i++) {
         if (!parameterNames[i].equals(""))
           addNewParameter(parameterNames[i], parameterValues[i]);
       }
     }

  }
  public String getMethods(){
    ArrayList list=desc.getOperations();
    StringBuffer buffer=new StringBuffer();
    for(int i=0;i<list.size();i++){
       String name=((OperationDesc)list.get(i)).getName();
       if(isMethodAllowed(name))
         buffer.append("<method isSelected=\"true\" name=\""+name+"\"></method>");
       else   buffer.append("<method name=\""+name+"\"> </method>");
    }
    return buffer.toString();
  }

  private boolean isMethodAllowed(String name){
     List list=desc.getAllowedMethods();
     if(list==null) return false;
     for(int i=0;i<list.size();i++){
       if(list.get(i).equals(name)) return true;
     }
     return false;
  }
}