package net.starmiddleware.starws2.wsdl.IDLToWSDL;
/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: </p>
 * @author not attributable
 * @version 1.0
 */
import com.ibm.wsdl.extensions.soap.SOAPAddressImpl;
import com.ibm.wsdl.extensions.soap.SOAPBindingImpl;
import com.ibm.wsdl.extensions.soap.SOAPBodyImpl;
import com.ibm.wsdl.extensions.soap.SOAPOperationImpl;

import org.apache.axis.AxisFault;
import net.starmiddleware.starws2.wsdl.Constants;
import net.starmiddleware.starws2.description.IDL2WSDL.*;
//mcl
import net.starmiddleware.starws2.description.IDL2WSDL.FieldDesc;
import net.starmiddleware.starws2.description.IDL2WSDL.AttributeDesc;
import org.w3c.dom.Attr;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NamedNodeMap;
import org.w3c.dom.NodeList;
import org.w3c.dom.Node;

import net.starmiddleware.starws2.description.IDL2WSDL.TypedefDesc;
import net.starmiddleware.starws2.description.IDL2WSDL.AttributeDesc;
import net.starmiddleware.starws2.description.IDL2WSDL.ServiceDesc;
import net.starmiddleware.starws2.description.IDL2WSDL.ParameterDesc;
import net.starmiddleware.starws2.description.IDL2WSDL.FaultDesc;
import net.starmiddleware.starws2.description.IDL2WSDL.IntfDesc;
import org.apache.axis.encoding.DefaultTypeMappingImpl;
import org.apache.axis.encoding.TypeMapping;
import org.apache.axis.utils.ClassUtils;
import org.apache.axis.utils.XMLUtils;
import org.apache.axis.utils.JavaUtils;
import org.w3c.dom.Document;

import javax.wsdl.Binding;
import javax.wsdl.BindingInput;
import javax.wsdl.BindingOperation;
import javax.wsdl.BindingOutput;
import javax.wsdl.BindingFault;
import javax.wsdl.Definition;
import javax.wsdl.Input;
import javax.wsdl.Import;
import javax.wsdl.Message;
import javax.wsdl.Operation;
import javax.wsdl.Output;
import javax.wsdl.Part;
import javax.wsdl.Port;
import javax.wsdl.PortType;
import javax.wsdl.Service;
import javax.wsdl.Fault;
import javax.wsdl.WSDLException;

import javax.wsdl.extensions.ExtensibilityElement;

import javax.wsdl.extensions.soap.SOAPAddress;
import javax.wsdl.extensions.soap.SOAPBinding;
import javax.wsdl.extensions.soap.SOAPBody;
import javax.wsdl.extensions.soap.SOAPOperation;

import javax.wsdl.factory.WSDLFactory;

import javax.xml.namespace.QName;

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.StringWriter;
import java.util.ArrayList;
import java.util.*;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;
import java.util.StringTokenizer;
import java.util.Vector;

// lbx
import java_cup.runtime.*;
import net.starmiddleware.starws2.I2WCFE.idl.*;
import net.starmiddleware.starws2.I2WCFE.idl.parser;

/**
 * This class emits WSDL from IDL.  It is used by the ?WSDL
 * Axis browser function and IDL2WSDL commandline utility.
 * See IDL2WSDL for more information.
 *
 */
public class Emitter {
  // Generated WSDL Modes
  public static final int MODE_ALL = 0;
  public static final int MODE_INTERFACE = 1;
  public static final int MODE_IMPLEMENTATION = 2;

  // Style Modes
  public static final int MODE_RPC = 0;
  public static final int MODE_DOCUMENT = 1;
  public static final int MODE_DOC_WRAPPED = 2;
  //use Modes
  public static final int USE_LITERAL=0;
  public static final int USE_ENCODED=1;
  public static final int USE_ALL=2;

  //private Class cls;
  private String idlFileName = null;
  private Class implCls;                 // Optional implementation class
  private Vector allowedMethods = null;  // Names of methods to consider
  private Vector disallowedMethods = null; // Names of methods to exclude
  private ArrayList stopClasses = new ArrayList();// class names which halt inheritace searches
  private boolean useInheritedMethods = false;
  private String intfNS;
  private String tnsNS;
  private String pkgNS;
  private String implNS;
  private String inputWSDL;
  private String locationUrl;
  //private String locationUrl="http://localhost:8080/axis/services/mclwsdl2";
  private String importUrl;
  private String servicePortName;
  private String serviceElementName;
  private String targetService = null;
  private String description;
  private int mode = MODE_RPC;
  private int use=USE_ENCODED;
  private TypeMapping tm = null;        // Registered type mapping
  private TypeMapping defaultTM = null; // Default TM
  private Namespaces namespaces;
  private Map exceptionMsg = null;

  private ArrayList encodingList;
  private Types types;
  //   private String clsName;
  private String infName;

  private String portTypeName;
  private String bindingName;

  private ServiceDesc serviceDesc;
  private ServiceDesc serviceDesc2;
  private String soapAction = "DEFAULT";

  /**
   * Construct Emitter.
   * Set the contextual information using set* methods
   * Invoke emit to emit the code
   */
  public Emitter () {
    namespaces = new Namespaces();
    exceptionMsg = new HashMap();
    //mcl
    //types=createTypes();
  }



  /**
   * Generates WSDL documents for a given <code>IDL</code>
   *
   * @param filename1  interface WSDL
   * @param filename2  implementation WSDL
   * @throws IOException
   * @throws WSDLException
   */
  public void emit(String filename1, String filename2) throws IOException, WSDLException {
    // Get interface and implementation defs
    Definition intf = getIntfWSDL();
    Definition impl = getImplWSDL();

    // Supply reasonable file names if not supplied
    if (filename1 == null) {
      filename1 = getServicePortName() + "_interface.wsdl";
    }
    if (filename2 == null) {
      filename2 = getServicePortName() + "_implementation.wsdl";
    }

    // Write out the interface def
    Document doc = WSDLFactory.newInstance().
                   newWSDLWriter().getDocument(intf);


    types.insertTypesFragment(doc);

    prettyDocumentToFile(doc, filename1);

    // Write out the implementation def
    doc = WSDLFactory.newInstance().newWSDLWriter().getDocument(impl);
    prettyDocumentToFile(doc, filename2);
  }

  /**
   * Generates a complete WSDL document for a given <code>Class</code>
   *
   * @param filename  WSDL
   * @throws IOException
   * @throws WSDLException
   */
  public void emit(String filename) throws IOException, WSDLException {
    emit(filename, MODE_ALL);
  }

  /**
   * Generates a WSDL document for a given <code>Class</code>.
   * The WSDL generated is controlled by the mode parameter
   * mode 0: All
   * mode 1: Interface
   * mode 2: Implementation
   *
   * @param mode generation mode - all, interface, implementation
   * @return Document
   * @throws IOException
   * @throws WSDLException
   */
  public Document emit(int mode) throws IOException, WSDLException {
    Document doc = null;
    Definition def = null;
    switch (mode) {
      case MODE_ALL:
        def = getWSDL();
        doc = WSDLFactory.newInstance().
              newWSDLWriter().getDocument(def);


        writeTypedef(def,doc);
        types.insertTypesFragment(doc);

        break;
      case MODE_INTERFACE:
        def = getIntfWSDL();
        doc = WSDLFactory.newInstance().
              newWSDLWriter().getDocument(def);
        writeTypedef(def,doc);
        types.insertTypesFragment(doc);
        break;
      case MODE_IMPLEMENTATION:
        def = getImplWSDL();
        doc = WSDLFactory.newInstance().
              newWSDLWriter().getDocument(def);
        break;
    }

    // Return the document
    return doc;
  }

  /**
   * Generates a String containing the WSDL for a given <code>Class</code>.
   * The WSDL generated is controlled by the mode parameter
   * mode 0: All
   * mode 1: Interface
   * mode 2: Implementation
   *
   * @param mode generation mode - all, interface, implementation
   * @return String
   * @throws IOException
   * @throws WSDLException
   */
  public String emitToString(int mode) throws IOException, WSDLException {
    Document doc = emit(mode);
    StringWriter sw = new StringWriter();
    XMLUtils.PrettyDocumentToWriter(doc, sw);
    return sw.toString();
  }

  /**
   * Generates a WSDL document for a given <code>Class</code>.
   * The WSDL generated is controlled by the mode parameter
   * mode 0: All
   * mode 1: Interface
   * mode 2: Implementation
   *
   * @param filename  WSDL
   * @param mode generation mode - all, interface, implementation
   * @throws IOException
   * @throws WSDLException
   */
  public void emit(String filename, int mode) throws IOException, WSDLException {
    Document doc = emit(mode);

    // Supply a reasonable file name if not supplied
    if (filename == null) {
      filename = getServicePortName();
      switch (mode) {
        case MODE_ALL:
          filename +=".wsdl";
          break;
        case MODE_INTERFACE:
          filename +="_interface.wsdl";
          break;
        case MODE_IMPLEMENTATION:
          filename +="_implementation.wsdl";
          break;
      }
    }

    prettyDocumentToFile(doc, filename);
  }

  /**
   * Get a Full WSDL <code>Definition</code> for the current
   * configuration parameters
   *
   * @return WSDL <code>Definition</code>
   * @throws IOException
   * @throws WSDLException
   */
  public Definition getWSDL() throws IOException, WSDLException {
    // Invoke the init() method to ensure configuration is setup
    init(MODE_ALL);
    // Create a Definition for the output wsdl
    Definition def = createDefinition();

    // Write interface header
    // writeDefinitions(def, intfNS);
    writeDefinitions(def,tnsNS);
    // Create Types
    types = createTypes(def);
    Binding binding = writeBinding(def, true);

    writeAttPortType(def,binding);
    writePortType(def, binding);
    writeService(def, binding);
    return def;
  }

  /**
   * Get a interface WSDL <code>Definition</code> for the
   * current configuration parameters
   *
   * @return WSDL <code>Definition</code>
   * @throws IOException
   * @throws WSDLException
   */
  public Definition getIntfWSDL() throws IOException, WSDLException {
    // Invoke the init() method to ensure configuration is setup
    init(MODE_INTERFACE);

    // Create a definition for the output wsdl
    Definition def = createDefinition();

    // Write interface header
    //writeDefinitions(def, intfNS);
    writeDefinitions(def, tnsNS);
    // Create Types
    types = createTypes(def);

    // Write the interface WSDL constructs and return the Definition
    Binding binding = writeBinding(def, true);
    writeAttPortType(def,binding);
    writePortType(def, binding);
    return def;
  }

  /**
   * Get implementation WSDL <code>Definition</code> for the
   * current configuration parameters
   *
   * @return WSDL <code>Definition</code>
   * @throws IOException
   * @throws WSDLException
   */
  public Definition getImplWSDL() throws IOException, WSDLException {
    // Invoke the init() method to ensure configuration is setup
    init(MODE_IMPLEMENTATION);

    // Create a Definition for the output wsdl
    Definition def = createDefinition();

    // Write implementation header and import
    writeDefinitions(def, implNS);
    //writeImport(def, intfNS, importUrl);
    writeImport(def, tnsNS, importUrl);
    // Write the implementation WSDL constructs and return Definition
    Binding binding = writeBinding(def, false); // Don't add binding to def
    writeService(def, binding);
    return def;
  }

  /**
   * Invoked prior to building a definition to ensure parms
   * and data are set up.
   */
  private void init(int mode) {

    // Get a default TM if not specified.
    if (defaultTM == null) {
      defaultTM = DefaultTypeMappingImpl.getSingleton();
    }

    // Set up a ServiceDesc to use to introspect the Service
    if (serviceDesc == null) {
  /*             serviceDesc = new ServiceDesc();
      //serviceDesc.setImplClass(cls);
            serviceDesc.setIdlFileName(idlfilename) ;
*/
      // parse IDL file
      serviceDesc = parseIDL(this.idlFileName  );




      // Set the typeMapping to the one provided.
      // If not available use the default TM
      if (tm != null) {
        serviceDesc.setTypeMapping(tm);
      } else {
        serviceDesc.setTypeMapping(defaultTM);
      }

      serviceDesc.setStopClasses(stopClasses);
      serviceDesc.setAllowedMethods(allowedMethods);
      serviceDesc.setDisallowedMethods(disallowedMethods);

    }



    if (encodingList == null) {
      infName = serviceDesc.getInfName() ;
      //clsName = clsName.substring(clsName.lastIndexOf('.') + 1);

      // Default the portType name
      if (getPortTypeName() == null) {
        setPortTypeName(infName);
      }

      // Default the serviceElementName
      if (getServiceElementName() == null) {
        setServiceElementName(getPortTypeName() + "Service");
      }

      // If service port name is null, construct it from location or className
      if (getServicePortName() == null) {
        String name = getLocationUrl();
        if (name != null) {
          if (name.lastIndexOf('/') > 0) {
            name = name.substring(name.lastIndexOf('/') + 1);
          } else if (name.lastIndexOf('\\') > 0) {
            name = name.substring(name.lastIndexOf('\\') + 1);
          } else {
            name = null;
          }
          // if we got the name from the location, strip .jws from it
          if (name != null && name.endsWith(".jws") ) {
            name = name.substring(0,
                                  (name.length() - ".jws".length()));
          }
        }
        if (name == null || name.equals("")) {
          name = infName;
        }
        setServicePortName(name);
      }

      // Default the bindingName
      if (getBindingName() == null) {
        if(use==USE_LITERAL)
          setBindingName(getServicePortName() + "Binding");
        else if(use==USE_ENCODED)
          setBindingName("_SE_"+getServicePortName() + "Binding");
      }

      encodingList = new ArrayList();
      encodingList.add(Constants.URI_DEFAULT_SOAP_ENC);
      tnsNS="http://www.omg.org/IDL-Mapped/";
      if (intfNS == null) {
        //  Package pkg = cls.getPackage();
        // intfNS = namespaces.getCreate(
        //         pkg == null ? null : pkg.getName());
        //lbx
//?

        // tnsNS=namespaces.getCreate("www.omg.org/IDL-Mapped/");

        intfNS = namespaces.getCreate(serviceDesc.getModuleName() == null ? null: serviceDesc.getModuleName() ) ;
        // pkgNS=namespaces.getCreate(serviceDesc.getOperations().
        //to do
        //mcl
     /*mcl         ArrayList pkgs = serviceDesc.getinterfacenames() ; //lbx: pay attention here. The most important!
                     for (Iterator i = pkgs.iterator(); i.hasNext();) {
        // if(i.next().equals(OperationDesc))
           String thisinterface = (String)i.next();
        // AttributeDesc thisattribute = (AttributeDesc)i.next();
            //System.out.println(thisinterface);

         namespaces.getCreate(thisinterface);

         }mcl*/


      }
      // Default the implementation namespace to the interface
      // namespace if not split wsdl mode.
  /*          if (implNS == null) {
                if (mode == MODE_ALL) {
                    implNS = intfNS;
                } else {
                    implNS = intfNS + "-impl";
                }
          }
*/
      namespaces.put(serviceDesc.getInfName() , intfNS, "intf");
      namespaces.put("IDL-Mapped" , tnsNS, "tns");
      namespaces.putPrefix(implNS, "impl");
    }
  }


  /**
   * Build a Definition from the input wsdl file or create
   * a new Definition
   *
   * @return WSDL Definition
   */
  private Definition createDefinition()
      throws WSDLException {
    Definition def;
    if (inputWSDL == null) {
      def = WSDLFactory.newInstance().newDefinition();
    } else {
      javax.wsdl.xml.WSDLReader reader =
          WSDLFactory.newInstance().newWSDLReader();
      Document doc = XMLUtils.newDocument(inputWSDL);
      def = reader.readWSDL(null, doc);
      // The input wsdl types section is deleted.  The
      // types will be added back in at the end of processing.
      def.setTypes(null);
    }
    return def;
  }

  /**
   * Build a Types object and load the input wsdl types
   * @param def Corresponding wsdl Definition
   * @return Types object
   */
  private Types createTypes(Definition def)
      throws IOException, WSDLException {
    //types = new Types(def, tm, defaultTM, namespaces,
    // intfNS, stopClasses);
    types = new Types(def, tm, defaultTM, namespaces,
                      tnsNS, stopClasses);
    if (inputWSDL != null) {
      types.loadInputTypes(inputWSDL);
    }
    return types;
  }


  /**
   * Create the definition header information.
   *
   * @param def  <code>Definition</code>
   * @param tns  target namespace
   */

  private void writeDefinitions1(Definition def, String tns) {
    def.setTargetNamespace(tns);

    def.addNamespace("intf", intfNS);
    def.addNamespace("impl", implNS);

    def.addNamespace(Constants.NS_PREFIX_WSDL_SOAP,
                     Constants.URI_WSDL11_SOAP);
    namespaces.putPrefix(Constants.URI_WSDL11_SOAP,
                         Constants.NS_PREFIX_WSDL_SOAP);

    def.addNamespace(Constants.NS_PREFIX_WSDL,
                     Constants.NS_URI_WSDL11);
    namespaces.putPrefix(Constants.NS_URI_WSDL11,
                         Constants.NS_PREFIX_WSDL);

    def.addNamespace(Constants.NS_PREFIX_SOAP_ENC,
                     Constants.URI_DEFAULT_SOAP_ENC);
    namespaces.putPrefix(Constants.URI_DEFAULT_SOAP_ENC,
                         Constants.NS_PREFIX_SOAP_ENC);

    def.addNamespace(Constants.NS_PREFIX_SCHEMA_XSD,
                     Constants.URI_DEFAULT_SCHEMA_XSD);
    namespaces.putPrefix(Constants.URI_DEFAULT_SCHEMA_XSD,
                         Constants.NS_PREFIX_SCHEMA_XSD);

    def.addNamespace(Constants.NS_PREFIX_XMLSOAP,
                     Constants.NS_URI_XMLSOAP);
    namespaces.putPrefix(Constants.NS_URI_XMLSOAP,
                         Constants.NS_PREFIX_XMLSOAP);
  }


  private void writeDefinitions(Definition def, String tns) {
    def.setTargetNamespace(tns);
    //def.setTargetNamespace("http://www.omg.org/IDL-Mapped/");
    def.addNamespace("intf", intfNS);
    def.addNamespace("tns", tnsNS);
    def.addNamespace("impl", implNS);


    def.addNamespace(Constants.NS_PREFIX_TNS,
                     Constants.NS_URI_IDLMAPPED );
    namespaces.putPrefix(Constants.NS_URI_IDLMAPPED,
                         Constants.NS_PREFIX_TNS);

    def.addNamespace(Constants.NS_PREFIX_SOAP_ENC1,
                     Constants.URI_SOAP11_ENC1  );
    namespaces.putPrefix(Constants.URI_SOAP11_ENC1 ,
                         Constants.NS_PREFIX_SOAP_ENC1);

    def.addNamespace(Constants.NS_PREFIX_CORBA ,
                     Constants.NS_URI_IDL2WSDL );
    namespaces.putPrefix(Constants.NS_URI_IDL2WSDL,
                         Constants.NS_PREFIX_CORBA);
    def.addNamespace(Constants.NS_PREFIX_WSDL_SOAP,
                     Constants.URI_WSDL11_SOAP);
    namespaces.putPrefix(Constants.URI_WSDL11_SOAP,
                         Constants.NS_PREFIX_WSDL_SOAP);

    def.addNamespace(Constants.NS_PREFIX_SOAP,
                     Constants.NS_URI_SOAP);
    namespaces.putPrefix(Constants.NS_URI_SOAP,
                         Constants.NS_PREFIX_SOAP);

    def.addNamespace(Constants.NS_PREFIX_WSDL,
                     Constants.NS_URI_WSDL11);
    namespaces.putPrefix(Constants.NS_URI_WSDL11,
                         Constants.NS_PREFIX_WSDL);

    def.addNamespace(Constants.NS_PREFIX_SCHEMA_XSD,
                     Constants.URI_DEFAULT_SCHEMA_XSD);
    namespaces.putPrefix(Constants.URI_DEFAULT_SCHEMA_XSD,
                         Constants.NS_PREFIX_SCHEMA_XSD);



    def.addNamespace(Constants.NS_PREFIX_XMLSOAP,
                     Constants.NS_URI_XMLSOAP);
    namespaces.putPrefix(Constants.NS_URI_XMLSOAP,
                         Constants.NS_PREFIX_XMLSOAP);
  }

  /**
   * Create and add an import
   *
   * @param def  <code>Definition</code>
   * @param tns  target namespace
   * @param loc  target location
   */
  private void writeImport(Definition def, String tns, String loc) {
    Import imp = def.createImport();

    imp.setNamespaceURI(tns);
    if (loc != null && !loc.equals(""))
      imp.setLocationURI(loc);
    def.addImport(imp);
  }

  /**
   * Create the binding.
   *
   * @param def  <code>Definition</code>
   * @param add  true if binding should be added to the def
   */
  private Binding writeBinding(Definition def, boolean add) {
    // QName bindingQName =new QName(intfNS, getBindingName());
    QName bindingQName =new QName(tnsNS, getBindingName());
    //QName bindingQName =new QName(desc., getBindingName());
    // If a binding already exists, don't replace it.
    Binding binding = def.getBinding(bindingQName);
    if (binding != null) {
      return binding;
    }

    // Create a binding
    binding = def.createBinding();
    binding.setUndefined(false);
    binding.setQName(bindingQName);

    SOAPBinding soapBinding = new SOAPBindingImpl();
    String modeStr = (mode == MODE_RPC) ? "rpc" : "document";
    soapBinding.setStyle(modeStr);
    soapBinding.setTransportURI(Constants.URI_SOAP11_HTTP);

    binding.addExtensibilityElement(soapBinding);

    if (add) {
      def.addBinding(binding);
    }
    return binding;
  }

  /**
   * Create the service.
   *
   * @param def
   * @param binding
   */
  private void writeService(Definition def, Binding binding) {

    QName serviceElementQName =
        new QName(implNS,
        getServiceElementName());

    // Locate an existing service, or get a new service
    Service service = def.getService(serviceElementQName);
    if (service == null) {
      service = def.createService();
      service.setQName(serviceElementQName);
      def.addService(service);
    }

    // Add the port
    Port port = def.createPort();
    port.setBinding(binding);
    // Probably should use the end of the location Url
    port.setName(getServicePortName());

    SOAPAddress addr = new SOAPAddressImpl();
    addr.setLocationURI(locationUrl);

    port.addExtensibilityElement(addr);

    service.addPort(port);
  }

  /** Create a PortType
   *
   * @param def
   * @param binding
   * @throws WSDLException
   * @throws AxisFault
   */
  private void writePortType(Definition def, Binding binding)
      //,String porttypename)
  throws WSDLException, AxisFault {

    //QName portTypeQName = new QName(intfNS, getPortTypeName());
    QName portTypeQName = new QName(tnsNS, getPortTypeName());
    // QName portTypeQName = new QName(tnsNS, porttypename);
    // Get or create a portType
    PortType portType = def.getPortType(portTypeQName);
    boolean newPortType = false;
    if (portType == null) {

      portType = def.createPortType();
      portType.setUndefined(false);
      portType.setQName(portTypeQName);
      newPortType = true;
    }

    // Add the port and binding operations.
    ArrayList operations = serviceDesc.getOperations(); //lbx: pay attention here. The most important!
    for (Iterator i = operations.iterator(); i.hasNext();) {
      // if(i.next().equals(OperationDesc))
      OperationDesc thisOper = (OperationDesc)i.next();
      // AttributeDesc thisattribute = (AttributeDesc)i.next();
      //System.out.println(thisOper.getName());
      //mcl

      //QName bindingQName =new QName(intfNS,getPortTypeName()+"Binding");

      QName  bindingQName =new QName(tnsNS,getPortTypeName()+"Binding");
      if(use==USE_ENCODED){
        bindingQName=new QName(tnsNS,"_SE_"+getPortTypeName()+"Binding");
      }
      binding.setQName(bindingQName) ;
      //mcl

      BindingOperation bindingOper = writeOperation(def,
          binding,
          thisOper);
      Operation oper = bindingOper.getOperation();

      OperationDesc messageOper = thisOper;
      if (serviceDesc2 != null) {
        // If a serviceDesc containing an impl class is provided,
        // try and locate the corresponding operation
        // (same name, same parm types and modes).  If a
        // corresponding operation is found, it is sent
        // to the writeMessages method so that its parameter
        // names will be used in the wsdl file.
        OperationDesc[] operArray =
            serviceDesc2.getOperationsByName(thisOper.getName());
        boolean found = false;
        if (operArray != null) {
          for (int j=0;
               j < operArray.length && !found;
               j++) {
            OperationDesc tryOper = operArray[j];
            if (tryOper.getParameters().size() ==
                thisOper.getParameters().size()) {
              boolean parmsMatch = true;
              for (int k=0;
                   k<thisOper.getParameters().size() && parmsMatch;
                   k++) {
                if (tryOper.getParameter(k).getMode() !=
                    thisOper.getParameter(k).getMode() ||
                    (! tryOper.getParameter(k).getJavaType().
                    equals(thisOper.getParameter(k).getJavaType()))) {
                parmsMatch = false;
              }
              }
              if (parmsMatch) {
                messageOper = tryOper;
                found = true;
              }
            }
          }
        }
      }

      writeMessages(def, oper, messageOper,
                    bindingOper);

      //if (newPortType) {
      portType.addOperation(oper);
      // }
    }

    //if (newPortType) {
    def.addPortType(portType);
    //}

    binding.setPortType(portType);
  }


  //add by mcl
  private void writeAttPortType(Definition def, Binding binding)
      throws WSDLException, AxisFault {
    //QName portTypeQName = new QName(intfNS, getPortTypeName());
    QName portTypeQName = new QName(tnsNS, getPortTypeName());

    // Get or create a portType
    PortType portType = def.getPortType(portTypeQName);
    boolean newPortType = false;
    if (portType == null) {
      portType = def.createPortType();
      portType.setUndefined(false);
      portType.setQName(portTypeQName);
      newPortType = true;
    }
        /* else if (binding.getBindingOperations().size() > 0) {
    // If both portType and binding already exist,
    // no additional processing is needed.
             return;
         }*/

    // Add the port and binding operations.
    ArrayList attributes = serviceDesc.getattributes() ; //lbx: pay attention here. The most important!
    for (Iterator i =  attributes.iterator(); i.hasNext();) {
      // if(i.next().equals(OperationDesc))
      AttributeDesc thisAttr = (AttributeDesc)i.next();
      // AttributeDesc thisattribute = (AttributeDesc)i.next();
      //System.out.println(thisAttr.getFieldName());
      //mcl

      // QName bindingQName =new QName(intfNS,getPortTypeName()+"Binding");
      QName bindingQName =new QName(tnsNS,getPortTypeName()+"Binding");
      binding.setQName(bindingQName) ;
      //mcl

      BindingOperation bindingOper = writeOperation(def,
          binding,
          thisAttr,"_get_");

      Operation oper = bindingOper.getOperation();

      AttributeDesc messageOper = thisAttr;


      writeMessages(def, oper, messageOper,
                    bindingOper);
      if (newPortType) {
        portType.addOperation(oper);
      }

      if(!thisAttr.getreadonly())
      {
        BindingOperation bindingOper2 = writeOperation(def,
            binding,
            thisAttr,"_set_");
        Operation oper2 = bindingOper2.getOperation();

        //AttributeDesc messageOper = thisAttr;

        writeMessages(def, oper2, messageOper,
                      bindingOper2);
        if (newPortType) {
          portType.addOperation(oper2);
        }
      }



      // if (newPortType) {
      //     portType.addOperation(oper);
      //}
    }

    if (newPortType) {
      def.addPortType(portType);
    }

    binding.setPortType(portType);
  }



  private void writeTypedef(Definition def,Document doc)
      throws WSDLException, AxisFault {


    boolean newtypedef = false;
    // if (types == null) {
    //  types = createTypes(def);
    newtypedef = true;
    //}
    // Add the port and binding operations.
    ArrayList typedefs = serviceDesc.gettypedefs() ; //lbx: pay attention here. The most important!
    for (Iterator i = typedefs.iterator(); i.hasNext();) {
      TypedefDesc thistypedef = (TypedefDesc)i.next();

      String qq=thistypedef.getTypedeftype();
      if(qq.equalsIgnoreCase("CORBA.SystemException") )
        if(!types.AvoiedTypeRepeat("xsd:complexType","CORBA.SystemException") )
            {types.writeCORBACompletstat(IDLType.getQName("string")) ;
      types.writeCORBAsysexception(IDLType.getQName("string")) ;
        }

        if(qq.equalsIgnoreCase("CORBA.any") )
            {types.writeAnyType(thistypedef,IDLType.getQName("string"),thistypedef.getName()) ;
        //types.writeTypecodeType(thistypedef,IDLType.getQName("string"),"CORBA.Typecode"  );
        }
        if(qq.equalsIgnoreCase("CORBA.Typecode") )
          types.writeTypecodeType(thistypedef,IDLType.getQName("string"),thistypedef.getName()) ;


        if(qq.equalsIgnoreCase("simpletype") ||qq.equalsIgnoreCase("string") )

          types.writeSimpleType(thistypedef,thistypedef.getTypeQName(),thistypedef.getName(),thistypedef.getTypeQName());

        if(qq.equalsIgnoreCase("char")||qq.equalsIgnoreCase("wchar"))
          types.writeCharType(thistypedef,thistypedef.getTypeQName(),thistypedef.getName() ,thistypedef.getTypeQName() ) ;

        if(qq.equalsIgnoreCase("uniontype") )
          types.writeUnionType(thistypedef,IDLType.getQName("string") ,thistypedef.getName() );

        if(qq.equalsIgnoreCase("fixedpointtype"))

          types.writeFixedPointType(thistypedef.getTypeQName(),thistypedef.getName(),thistypedef.getTypeQName(),
          thistypedef.gettotalDigits(),thistypedef.getfractionDigits());

        if(qq.equalsIgnoreCase("sequencetype"))
            { if(use==USE_LITERAL)
            types.writeSequenceType(thistypedef,thistypedef.getTypeQName(),thistypedef.getName(),thistypedef.getTypeQName());
        if(use==USE_ENCODED)
          //shiyan
        {boolean tt=false;
        if(thistypedef.getTypeQName()==null)
                                      {  String mm=thistypedef.gettypeName() ;

        ArrayList typedefs1 = serviceDesc.gettypedefs() ;
        // boolean tt=false;
        for (Iterator i1 = typedefs1.iterator(); i1.hasNext();)
        {
          TypedefDesc thistypedef1 = (TypedefDesc)i1.next();
          if(thistypedef1.getName().equalsIgnoreCase(mm) )
          {
            tt=thistypedef1.getisof_se() ;
            break;
          }

        }
        }
        types.writeSequenceTypeEncoded(thistypedef,thistypedef.getTypeQName(),thistypedef.getName(),thistypedef.getTypeQName(),tt);

        }
        }

        if(qq.equalsIgnoreCase("arraytype"))
        {
          if(use==USE_LITERAL)
            types.writeArrayType(thistypedef,thistypedef.getTypeQName(),thistypedef.getName(),thistypedef.getTypeQName());
          if(use==USE_ENCODED)
            types.writeArrayTypeEncoded(thistypedef,thistypedef.getTypeQName(),thistypedef.getName(),thistypedef.getTypeQName());
        }

        if(qq.equalsIgnoreCase("structtype"))
            {if(use==USE_LITERAL)
            types.writeStructType(thistypedef,IDLType.getQName("string") ,thistypedef.getName(),thistypedef.getMemberList());
        if(use==USE_ENCODED)
          types.writeStructTypeEncoded(thistypedef,IDLType.getQName("string") ,thistypedef.getName(),thistypedef.getMemberList(),serviceDesc);

        }
        if(qq.equalsIgnoreCase("enumtype"))
          types.writeEnumType(IDLType.getQName("string") ,thistypedef.getName(),thistypedef.getEnumList());

    }

  }



  //mcl

   /* Document docHolder=null;
    public void writeSimpleType
  //(Definition def,
                              ( TypedefDesc typedesc)
//(Class type,String typeName,QName qName)
         throws AxisFault{
  //todo
  //types.writeTypeNamespace(IDLType.getQName(alias.originalType));

            Element simpleType = docHolder.createElement("simpleType");
            types.writeSchemaElement(typedesc.getTypeQName() , simpleType);
            simpleType.setAttribute("name",typedesc.getName() );

  // Element complexContent = docHolder.createElement("complexContent");
  // complexType.appendChild(complexContent);

            Element restriction = docHolder.createElement("restriction");
            simpleType.appendChild(restriction);
  //String baseType = writeType(base, null);
            restriction.setAttribute("base", typedesc.getTypeQName().toString());
}*/
//mcl add end
/** Create a Message
 *
 * @param def Definition, the WSDL definition
 * @param oper Operation, the wsdl operation
 * @param desc OperationDesc, the Operation Description
 * @param bindingOper BindingOperation, corresponding Binding Operation
 * @throws WSDLException
 * @throws AxisFault

 */
  private void writeMessages(Definition def,
                             Operation oper,
                             OperationDesc desc,
                             BindingOperation bindingOper)
      throws WSDLException, AxisFault {
    Input input = def.createInput();

    Message msg = writeRequestMessage(def, desc);



    // Give the input element a name that matches the
    // message.  This is necessary for overloading.
    // The msg QName is unique.
    String name = msg.getQName().getLocalPart();
    input.setMessage(msg);
    //input.setMessage(name) ;
    //mcl
    //System.out.println(name);
    // QName portTypeQName = new QName(intfNS, getPortTypeName());
    //System.out.println(intfNS);
    //name=portTypeQName.toString() +"."+name;
    //System.out.println(name);
    //add by mcl
    //input.setName(name);

    // bindingOper.getBindingInput().setName(name);

    oper.setInput(input);
    def.addMessage(msg);

    msg = writeResponseMessage(def, desc);
    Output output = def.createOutput();
    output.setMessage(msg);


    //mcl
        /*QName qName = createMessageName(def, "tns:CORBA.SystemException", "");
             msg.setQName(qName);
            msg.setUndefined(false);
Fault fault1=def.createFault() ;
         fault1.setMessage(msg) ;*/
    //msg = writeFaultMessage(def,"tns:CORBA.SystemException");

    // Give the output element a name that matches the
    // message.  This is necessary for overloading.
    // The message QName is unique.
    name = msg.getQName().getLocalPart();
    //output.setName(name);

    //bindingOper.getBindingOutput().setName(name);

    oper.setOutput(output);
    def.addMessage(msg);

    ArrayList exceptions = desc.getFaults();

    for (int i = 0; exceptions != null && i < exceptions.size(); i++) {
      FaultDesc faultDesc = (FaultDesc) exceptions.get(i);
      msg = writeFaultMessage(def, faultDesc);
      //System.out .println(faultDesc.getName() ) ;
      Fault fault = def.createFault();
      fault.setMessage(msg);
      //?
      fault.setName((faultDesc).getName());
      oper.addFault(fault);

      if (def.getMessage(msg.getQName()) == null) {
        def.addMessage(msg);
      }
    }

    // Set the parameter ordering using the parameter names
    ArrayList parameters = desc.getParameters();
    Vector names = new Vector();
    for (int i = 0; i < parameters.size(); i++) {
      ParameterDesc param = (ParameterDesc)parameters.get(i);
      names.add(param.getName());
    }

    if (names.size() > 0) {
      if (mode == MODE_DOC_WRAPPED) {
        names.clear();
      }
      oper.setParameterOrdering(names);
    }
  }
//add by mcl
  private void writeMessages(Definition def,
                             Operation oper,
                             AttributeDesc desc,
                             BindingOperation bindingOper)
      throws WSDLException, AxisFault {


    // Message msg = writeRequestMessage(def, desc);
    //String name = msg.getQName().getLocalPart();
    if(bindingOper.getName().substring(0,4) .equalsIgnoreCase("_set"))
    {
      Message msg = writeRequestMessage(def, desc);
      String name = msg.getQName().getLocalPart();
      Input input = def.createInput();
      input.setMessage(msg);


      // Give the input element a name that matches the
      // message.  This is necessary for overloading.
      // The msg QName is unique.
      // String name = msg.getQName().getLocalPart();
      //mcl
      //System.out.println(name);
      // QName portTypeQName = new QName(intfNS, getPortTypeName());
      // System.out.println(intfNS);
      // name=portTypeQName.toString() +"."+name;
      // System.out.println(name);
      //add by mcl
      //input.setName(name);

      //bindingOper.getBindingInput().setName(name);
//mmm

      oper.setInput(input);

      def.addMessage(msg);
    }

    //msg = writeResponseMessage(def, desc);
    if(bindingOper.getName().substring(0,4) .equalsIgnoreCase("_get"))
    {
      Message msg = writeResponseMessage(def, desc);
      Output output = def.createOutput();
      output.setMessage(msg);

      // Give the output element a name that matches the
      // message.  This is necessary for overloading.
      // The message QName is unique.
      String name = msg.getQName().getLocalPart();
      //output.setName(name);

      //bindingOper.getBindingOutput().setName(name);

      oper.setOutput(output);

      def.addMessage(msg);
    }

    ArrayList exceptions = desc.getFaults();

    for (int i = 0; exceptions != null && i < exceptions.size(); i++) {
      FaultDesc faultDesc = (FaultDesc) exceptions.get(i);
      Message msg = writeFaultMessage(def, faultDesc);
      Fault fault = def.createFault();
      fault.setMessage(msg);

      fault.setName((faultDesc).getName());
      oper.addFault(fault);
      if (def.getMessage(msg.getQName()) == null) {
        def.addMessage(msg);
      }
    }


  }


  /** Create a Operation
   *
   * @param def
   * @param binding
   */
  private BindingOperation writeOperation(Definition def,
      Binding binding,
      OperationDesc desc) {
    Operation oper = def.createOperation();
    //oper.setName(desc.getpackName() +"."+desc.getName());
    oper.setName(desc.getName());
    oper.setUndefined(false);
    return writeBindingOperation(def, binding, oper, desc);
  }

//mcl add
  private BindingOperation writeOperation(Definition def,
      Binding binding,
      AttributeDesc desc,String ss) {
    Operation oper = def.createOperation();
    oper.setName(ss+desc.getFieldName());
    oper.setUndefined(false);
        /*Operation oper2 = def.createOperation();
        oper2.setName("_set_"+desc.getFieldName());
        oper2.setUndefined(false);*/
    return writeBindingOperation(def, binding, oper, desc);
  }

  /** Create a Binding Operation
   *
   * @param def
   * @param binding
   * @param oper
   */
  private BindingOperation writeBindingOperation (Definition def,
      Binding binding,
      Operation oper,
      OperationDesc desc) {
    BindingOperation bindingOper = def.createBindingOperation();
    BindingInput bindingInput = def.createBindingInput();
    BindingOutput bindingOutput = def.createBindingOutput();
    //mcl
    //BindingFault bindingFault=def.createBindingFault() ;
    //Element message=docHolder.createElement("message");
    //bindingFault.addExtensibilityElement() ;
    //bindingOper.addBindingFault(bindingFault);

    Fault fault=def.createFault() ;
    Message msg = def.createMessage();

    QName qName = createMessageName(def, "CORBA.SystemException","");// "Request");

    msg.setQName(qName);
    fault.setMessage(msg) ;
    //bindingOpe

    // bindingOper.addBindingFault()  ;
    //fault.setMessage()


    bindingOper.setName(oper.getName());
    bindingOper.setOperation(oper);

    SOAPOperation soapOper = new SOAPOperationImpl();


    // If the soapAction option is OPERATION, force
    // soapAction to the name of the operation. If NONE,
    // force soapAction to "".
    // Otherwise use the information in the operationDesc.
    //MCL
    String soapAction=desc.getpackName()+"#"+desc.getName();
    desc.setSoapAction(soapAction);
    //MCL
    //String soapAction = "";
    if (getSoapAction().equals("OPERATION")) {
      soapAction = oper.getName();
    } else if (getSoapAction().equals("NONE")) {
      soapAction = "";
    } else {
      soapAction = desc.getSoapAction();
      if (soapAction == null) {
        soapAction = "";
      }
    }
    soapOper.setSoapActionURI(soapAction);

    // Until we have per-operation configuration, this will always be
    // the same as the binding default.
    // soapOper.setStyle("rpc");

    bindingOper.addExtensibilityElement(soapOper);

    // Input clause
    ExtensibilityElement input = null;
    input = writeSOAPBody(desc.getElementQName(),desc);
    bindingInput.addExtensibilityElement(input);

    //Output clause
    ExtensibilityElement output = null;
    output = writeSOAPBody(desc.getReturnQName(),desc);

    //mcl
    // ExtensibilityElement fault = null;
    // fault.set
    // bindingOper.addExtensibilityElement(fault);
//mcl
    bindingOutput.addExtensibilityElement(output);

    bindingOper.setBindingInput(bindingInput);

    bindingOper.setBindingOutput(bindingOutput);
    //mcl
    //bindingFault.setName("CORBA.SystemException");


    binding.addBindingOperation(bindingOper);

    return bindingOper;
  }
//add by mcl
  private BindingOperation writeBindingOperation (Definition def,
      Binding binding,
      Operation oper,
      AttributeDesc desc) {
    BindingOperation bindingOper = def.createBindingOperation();
    BindingInput bindingInput = def.createBindingInput();
    BindingOutput bindingOutput = def.createBindingOutput();

    bindingOper.setName(oper.getName());
    bindingOper.setOperation(oper);

    SOAPOperation soapOper = new SOAPOperationImpl();


    // If the soapAction option is OPERATION, force
    // soapAction to the name of the operation. If NONE,
    // force soapAction to "".
    // Otherwise use the information in the operationDesc.
    //MCL
    String soapAction=desc.getpackName()+"#"+desc.getFieldName();
    desc.setSoapAction(soapAction);
    //MCL

    //String soapAction = "";
    if (getSoapAction().equals("OPERATION")) {
      soapAction = oper.getName();
    } else if (getSoapAction().equals("NONE")) {
      soapAction = "";
    } else {
      soapAction = desc.getSoapAction();
      if (soapAction == null) {
        soapAction = "";
      }
    }
    soapOper.setSoapActionURI(soapAction);

    // Until we have per-operation configuration, this will always be
    // the same as the binding default.
    // soapOper.setStyle("rpc");

    bindingOper.addExtensibilityElement(soapOper);

    // Input clause
    ExtensibilityElement input = null;
    input = writeSOAPBody(desc.getElementQName(),desc);
    bindingInput.addExtensibilityElement(input);

    //Output clause
    ExtensibilityElement output = null;
    //output = writeSOAPBody(desc.getReturnQName());
    output = writeSOAPBody(desc.getElementQName(),desc);
    bindingOutput.addExtensibilityElement(output);
    if(bindingOper.getName().substring(0,4) .equalsIgnoreCase("_set"))
      bindingOper.setBindingInput(bindingInput);
    if(bindingOper.getName().substring(0,4) .equalsIgnoreCase("_get"))
      bindingOper.setBindingOutput(bindingOutput);

    binding.addBindingOperation(bindingOper);

    return bindingOper;
  }


  private ExtensibilityElement writeSOAPBody(QName operQName,OperationDesc desc) {
    SOAPBody soapBody = new SOAPBodyImpl();
    // for now, if its document, it is literal use.
    soapBody.setUse("literal");
    if (mode == MODE_RPC && use==USE_ENCODED) {
      soapBody.setUse("encoded");
      soapBody.setEncodingStyles(encodingList);
    }
    //else {
    //  soapBody.setUse("literal");
    //  }

    if (targetService == null)
      //mcl
      //soapBody.setNamespaceURI(intfNS);
      soapBody.setNamespaceURI(desc.getpackName());

    else
      soapBody.setNamespaceURI(targetService);
    if (operQName != null &&
        !operQName.getNamespaceURI().equals("")) {
      soapBody.setNamespaceURI(operQName.getNamespaceURI());
    }
    return soapBody;
  } // writeSOAPBody

  private ExtensibilityElement writeSOAPBody(QName operQName,AttributeDesc desc) {
    SOAPBody soapBody = new SOAPBodyImpl();
    // for now, if its document, it is literal use.
    soapBody.setUse("literal");
    if (mode == MODE_RPC && use==USE_ENCODED) {
      soapBody.setUse("encoded");
      soapBody.setEncodingStyles(encodingList);
    }
       /* else {
            soapBody.setUse("literal");
        }*/

    if (targetService == null)
      //mcl
      soapBody.setNamespaceURI(desc.getpackName());
    //soapBody.setNamespaceURI();

    else
      soapBody.setNamespaceURI(targetService);
    if (operQName != null &&
        !operQName.getNamespaceURI().equals("")) {
      soapBody.setNamespaceURI(operQName.getNamespaceURI());
    }
    return soapBody;
  } // writeSOAPBody

  /** Create a Request Message
   *
   * @param def
   * @throws WSDLException
   * @throws AxisFault
   */
  private Message writeRequestMessage(Definition def,
                                      OperationDesc oper)
      throws WSDLException, AxisFault
  {
    Message msg = def.createMessage();

    QName qName = createMessageName(def, oper.getpackName() +"."+oper.getName(),"");// "Request");

    msg.setQName(qName);
    msg.setUndefined(false);

    ArrayList parameters = oper.getParameters();
    for(int i=0; i<parameters.size(); i++) {
      ParameterDesc parameter = (ParameterDesc) parameters.get(i);
      writePartToMessage(def, msg, true, parameter);
    }

    return msg;
  }

  private Message writeRequestMessage(Definition def,
                                      AttributeDesc attr)
      throws WSDLException, AxisFault
  {
    Message msg = def.createMessage();

    QName qName = createMessageName(def, attr.getpackName() +"._set_"+attr.getFieldName(),"");// "Request");

    msg.setQName(qName);
    msg.setUndefined(false);
    Part part = def.createPart();

    part.setName("value");

    if(attr.getXmlType()!=null)
      part.setTypeName(attr.getXmlType());
    else
    {QName typename=createMessageName(def,attr.gettypeName() ,"");
    part.setTypeName(typename ) ;}

    msg.addPart(part);


    return msg;

    // ?? Throw an exception here?
  }

  //writePartToMessage(def, msg, true, parameter);
          /*ArrayList parameters = attr.getParameters();
          for(int i=0; i<parameters.size(); i++) {
              ParameterDesc parameter = (ParameterDesc) parameters.get(i);
              writePartToMessage(def, msg, true, parameter);
          }*/






          /** Create a Response Message
           *
           * @param def
           * @throws WSDLException
           * @throws AxisFault
           */
  private Message writeResponseMessage(Definition def,
                                       OperationDesc desc)
      throws WSDLException, AxisFault
  {
    Message msg = def.createMessage();

    QName qName = createMessageName(def, desc.getpackName()+"." +desc.getName(), "Response");

    msg.setQName(qName);
    msg.setUndefined(false);

    // Write the part
    ParameterDesc retParam = new ParameterDesc();
    if (desc.getReturnQName() == null) {
      // retParam.setName(desc.getName()+"_return");
      retParam.setName("_return");
    } else {
      retParam.setQName(desc.getReturnQName());
    }
    // if(desc.getReturnType()!=null)
    retParam.setTypeQName(desc.getReturnType());
    //else
    // {retParam.setTypeQName() ;}

    retParam.setMode(ParameterDesc.OUT);
    retParam.setIsReturn(true);
    retParam.setJavaType(desc.getReturnClass());

    retParam.settypeName(desc.gettypeName() ) ;
    if(desc.getarrseq()!=null)
      retParam.setarrseq(desc.getarrseq() ) ;

    writePartToMessage(def, msg, false, retParam);

    ArrayList parameters = desc.getParameters();
    for (Iterator i = parameters.iterator(); i.hasNext();) {
      ParameterDesc param = (ParameterDesc)i.next();
      writePartToMessage(def, msg, false, param);
    }
    return msg;
  }

  private Message writeResponseMessage(Definition def,
                                       AttributeDesc desc)
      throws WSDLException, AxisFault
  {
    Message msg = def.createMessage();

    QName qName = createMessageName(def, desc.getpackName() +"._get_"+desc.getFieldName(), "Response");

    msg.setQName(qName);
    msg.setUndefined(false);
    Part part = def.createPart();

    part.setName("_return");
    if(desc.getXmlType()!=null)
      part.setTypeName(desc.getXmlType());
    else
    {QName typename=createMessageName(def,desc.gettypeName() ,"");
    part.setTypeName(typename ) ;}

    msg.addPart(part);
    return msg;
    // Write the part
    //ParameterDesc retParam = new ParameterDesc();
    //if (desc.getReturnQName() == null) {


        /* ArrayList parameters = desc.getParameters();
         for (Iterator i = parameters.iterator(); i.hasNext();) {
             ParameterDesc param = (ParameterDesc)i.next();
             writePartToMessage(def, msg, false, param);
         }
         return msg;*/
  }



  /** Create a Fault Message
   *
   * @param def
   * @param exception (an ExceptionRep object)
   * @throws WSDLException
   * @throws AxisFault
   */
  private Message writeFaultMessage(Definition def,
                                    FaultDesc exception)
      throws WSDLException, AxisFault
  {

    String pkgAndClsName = exception.getName();
    String clsName = pkgAndClsName.substring(pkgAndClsName.lastIndexOf('.') + 1,
        pkgAndClsName.length());

    // There are inconsistencies in the JSR 101 version 0.7 specification
    // with regards to whether the java exception class name is mapped to
    // the wsdl:fault name= attribute or is mapped to the wsdl:message of
    // the wsdl:fault message= attribute.  Currently WSDL2Java uses the
    // latter mapping to generate the java exception class.
    //
    // The following code uses the class name for both the name= attribute
    // and the message= attribute.

    //exception.setName(clsName);
    //exception.setName(pkgAndClsName);
    Message msg = (Message) exceptionMsg.get(pkgAndClsName);

    if (msg == null) {
      msg = def.createMessage();
      //mcl      QName qName = createMessageName(def, clsName, "");
      QName qName = createMessageName(def, "_exception."+pkgAndClsName, "");
      if(pkgAndClsName.equalsIgnoreCase("CORBA.SystemException") )
          {qName = createMessageName(def, pkgAndClsName, "");};
      msg.setQName(qName);
      msg.setUndefined(false);
/*mcl hide
            ArrayList parameters = exception.getParameters();
            for (int i=0; i<parameters.size(); i++) {
                ParameterDesc parameter = (ParameterDesc) parameters.get(i);
                writePartToMessage(def, msg, true, parameter);
            }*/
      Part part=def.createPart() ;
            part.setName("exception") ;
            QName qName2 = createMessageName(def, pkgAndClsName, "");
            part.setTypeName(qName2) ;
            if(pkgAndClsName.equalsIgnoreCase("CORBA.SystemException") )
            {
              part.setName("_return") ;
            }
            msg.addPart(part);
            exceptionMsg.put(pkgAndClsName, msg);
    }

    return msg;

  }

  /** Create a Part
   *
   * @param def
   * @param msg
   * @param request     message is for a request
   * @param param       ParamRep object
   * @return The parameter name added or null
   * @throws WSDLException
   * @throws AxisFault
   */
  public String writePartToMessage(Definition def,
                                   Message msg,
                                   boolean request,
                                   ParameterDesc param) throws WSDLException, AxisFault
  {
    // Return if this is a void type
    if (param == null ||
        param.getJavaType() == java.lang.Void.TYPE)
      return null;

    // If Request message, only continue if IN or INOUT
    // If Response message, only continue if OUT or INOUT
    if (request &&
        param.getMode() == ParameterDesc.OUT) {
      return null;
    }
    if (!request &&
        param.getMode() == ParameterDesc.IN) {
      return null;
    }

    // Create the Part
    Part part = def.createPart();

    // Get the java type to represent in the wsdl
    // (if the mode is OUT or INOUT and this
    // parameter does not represent the return type,
    // the type held in the Holder is the one that should
    // be written.)
    Class javaType = param.getJavaType();
    if (param.getMode() != ParameterDesc.IN &&
        param.getIsReturn() == false) {
      javaType = JavaUtils.getHolderValueType(javaType);
    }

    switch(mode) {
      case MODE_RPC: {
        // Add the type representing the param
        // For convenience, add an element for the param
        // Write <part name=param_name type=param_type>
        QName typeQName=new QName("");

        if(param.getJavaType()!=null)
        {
          //QName
          typeQName =
              types.writeTypeForPart(javaType,
              param.getTypeQName());
          types.writeElementForPart(javaType, param.getTypeQName());
          if (typeQName != null) {
          part.setTypeName(typeQName);}
        }
        else
        {
          // if(use==USE_LITERAL)
          // QName

          typeQName=createMessageName(def,param.gettypeName(),"");
          if(use==USE_ENCODED)
          {
            String qq=param.gettypeName() ;
            if(param.getarrseq()!=null)
                                  {if(param.getarrseq().endsWith("[]") )

            {String ff=qq.substring(0,qq.lastIndexOf(".")+1)+"_SE_"+ qq.substring(qq.lastIndexOf(".")+1);
            //typeQName=createMessageName(def,param.getpackName()+"._SE_"+param.getName(),"");}
            typeQName=createMessageName(def,ff,"");
            }
            }
            if(searchisofse(param))
            {
              String ff=qq.substring(0,qq.lastIndexOf(".")+1)+"_SE_"+ qq.substring(qq.lastIndexOf(".")+1);
              //typeQName=createMessageName(def,param.getpackName()+"._SE_"+param.getName(),"");}
              typeQName=createMessageName(def,ff,"");

            }

          }
          part.setTypeName(typeQName ) ;
        }
        part.setName(param.getName());

        msg.addPart(part);

        break;
      }
    case MODE_DOCUMENT: {
      // Write the type representing the param.
      // Write the element representing the param
      // If an element was written
      //   Write <part name=param_name element=param_element>
      // Else its a simple type,
      //   Write <part name=param_name type=param_type>
      QName typeQName =
          types.writeTypeForPart(javaType,
          param.getTypeQName());
      QName elemQName =
          types.writeElementForPart(javaType,
          param.getTypeQName());
      if (elemQName != null) {
        part.setName(param.getName());
        part.setElementName(elemQName);
        msg.addPart(part);
      } else if (typeQName != null) {
        part.setName(param.getName());
        part.setTypeName(typeQName);
        msg.addPart(part);
      }
      break;
    }
  case MODE_DOC_WRAPPED: {
    // Write type representing the param
    QName typeQName =
        types.writeTypeForPart(javaType,
        param.getTypeQName());

    // Get the QName of the wrapper element
    QName wrapperQName = null;
    if (request) {
      wrapperQName =
          new QName(
          msg.getQName().getNamespaceURI(),
          msg.getQName().getLocalPart().substring(0,
          msg.getQName().getLocalPart().indexOf("Request")));
    } else {
      wrapperQName = msg.getQName();
    }

    if (typeQName != null) {
      // Write/Get the wrapper element
      // and append a child element repesenting
      // the parameter
      if (types.writeWrapperForPart(wrapperQName,
                                    param.getName(),
                                    typeQName)) {
        // If wrapper element is written
        // add <part name="parameters" element=wrapper_elem />
        // Really shouldn't matter what name is used, but
        // .NET could be using "parameters" as an indication
        // that this is wrapped mode.
        part.setName("parameters");
        part.setElementName(wrapperQName);
        msg.addPart(part);
      }
    }
    break;
  }
default:
  // ?? Throw an exception here?
    }
    return param.getName();
  }

    /*
  * Return a message QName which has not already been defined in the WSDL
     */
  private QName createMessageName(Definition def,
                                  String methodName,
                                  String suffix) {

    // QName qName = new QName(intfNS,
    //                               methodName.concat(suffix));

    QName qName = new QName(tnsNS,
                            methodName.concat(suffix));
    // Check the make sure there isn't a message with this name already
    int messageNumber = 1;
    while (def.getMessage(qName) != null) {
      StringBuffer namebuf =
          new StringBuffer(methodName.concat(suffix));
      namebuf.append(messageNumber);
      //qName = new QName(intfNS, namebuf.toString());
      qName = new QName(tnsNS, namebuf.toString());
      messageNumber++;
    }
    return qName;
  }

  /**
   * Write a prettified document to a file.
   *
   * @param doc the Document to write
   * @param filename the name of the file to be written
   * @throws IOException various file i/o exceptions
   */
  private void prettyDocumentToFile(Document doc, String filename)
      throws IOException {
    FileOutputStream fos = new FileOutputStream(new File(filename));
    XMLUtils.PrettyDocumentToStream(doc, fos);
    fos.close();
  }

  // -------------------- Parameter Query Methods ----------------------------//

  /**
   * Returns the <code>Class</code> to export
   * @return the <code>Class</code> to export
   */
/*    public Class getCls() {
        return cls;
    }
    */
   /**
    * Sets the <code>Class</code> to export
    * @param cls the <code>Class</code> to export
    */
/*    public void setCls(Class cls) {
        this.cls = cls;
    }
    */
   /**
    * Sets the <code>Class</code> to export.
    * @param cls the <code>Class</code> to export
    */
/*    public void setClsSmart(Class cls, String location) {

        if (cls == null || location == null)
            return;

            // Strip off \ and / from location
        if (location.lastIndexOf('/') > 0) {
            location =
              location.substring(location.lastIndexOf('/') + 1);
        } else if (location.lastIndexOf('\\') > 0) {
            location =
              location.substring(location.lastIndexOf('\\') + 1);
        }

        // Get the constructors of the class
        java.lang.reflect.Constructor[] constructors =
          cls.getDeclaredConstructors();
        Class intf = null;
        for (int i=0; i<constructors.length && intf == null; i++) {
            Class[] parms = constructors[i].getParameterTypes();
            // If the constructor has a single parameter
            // that is an interface which
            // matches the location, then use this as the interface class.
            if (parms.length == 1 &&
                parms[0].isInterface() &&
                parms[0].getName() != null &&
                Types.getLocalNameFromFullName(
                    parms[0].getName()).equals(location)) {
                intf = parms[0];
            }
        }
        if (intf != null) {
            setCls(intf);
            if (implCls == null) {
                setImplCls(cls);
            }
        }
        else
            setCls(cls);
    }*/

   /**
    * Sets the <code>Class</code> to export
    * @param className the name of the <code>Class</code> to export
    */
/*    public void setCls(String className) throws ClassNotFoundException {
        cls = ClassUtils.forName(className);
    }
    */
   /**
    * Returns the implementation <code>Class</code> if set
    * @return the implementation Class or null
    */
  public Class getImplCls() {
    return implCls;
  }

  /**
   * Sets the implementation <code>Class</code>
   * @param implCls the <code>Class</code> to export
   */
  public void setImplCls(Class implCls) {
    this.implCls = implCls;
  }

  /**
   * Sets the implementation <code>Class</code>
   * @param className the name of the implementation <code>Class</code>
   */
  public void setImplCls(String className) {
    try {
      implCls = ClassUtils.forName(className);
    }
    catch (Exception ex) {
      ex.printStackTrace();
    }
  }

  /**
   * Returns the interface namespace
   * @return interface target namespace
   */
  public String getIntfNamespace() {
    return intfNS;
  }

  /**
   * Set the interface namespace
   * @param ns interface target namespace
   */
  public void setIntfNamespace(String ns) {
    this.intfNS = ns;
  }

  /**
   * Returns the implementation namespace
   * @return implementation target namespace
   */
  public String getImplNamespace() {
    return implNS;
  }

  /**
   * Set the implementation namespace
   * @param ns implementation target namespace
   */
  public void setImplNamespace(String ns) {
    this.implNS = ns;
  }

  /**
   * Returns a vector of methods to export
   * @return a space separated list of methods to export
   */
  public Vector getAllowedMethods() {
    return allowedMethods;
  }

  /**
   * Add a list of methods to export
   */
  public void setAllowedMethods(String text) {
    if (text != null) {
      StringTokenizer tokenizer = new StringTokenizer(text, " ,+");
      if (allowedMethods == null) {
        allowedMethods = new Vector();
      }
      while (tokenizer.hasMoreTokens()) {
        allowedMethods.add(tokenizer.nextToken());
      }
    }
  }

  /**
   * Add a Vector of methods to export
   * @param allowedMethods a vector of methods to export
   */
  public void setAllowedMethods(Vector allowedMethods) {
    if (this.allowedMethods == null) {
      this.allowedMethods = new Vector();
    }
    this.allowedMethods.addAll(allowedMethods);
  }

  /**
   * Indicates if the emitter will search classes for inherited methods
   */
  public boolean getUseInheritedMethods() {
    return useInheritedMethods;
  }

  /**
   * Turn on or off inherited method WSDL generation.
   */
  public void setUseInheritedMethods(boolean useInheritedMethods) {
    this.useInheritedMethods = useInheritedMethods;
  }

  /**
   * Add a list of methods NOT to export
   * @param disallowedMethods vector of method name strings
   */
  public void setDisallowedMethods(Vector disallowedMethods) {
    if (this.disallowedMethods == null) {
      this.disallowedMethods = new Vector();
    }
    this.disallowedMethods.addAll(disallowedMethods);
  }

  /**
   * Add a list of methods NOT to export
   * @param text space separated list of method names
   */
  public void setDisallowedMethods(String text) {
    if (text != null) {
      StringTokenizer tokenizer = new StringTokenizer(text, " ,+");
      if (disallowedMethods == null) {
        disallowedMethods = new Vector();
      }
      disallowedMethods = new Vector();
      while (tokenizer.hasMoreTokens()) {
        disallowedMethods.add(tokenizer.nextToken());
      }
    }
  }

  /**
   * Return list of methods that should not be exported
   */
  public Vector getDisallowedMethods() {
    return disallowedMethods;
  }

  /**
   * Adds a list of classes (fully qualified) that will stop the traversal
   * of the inheritance tree if encounter in method or complex type generation
   *
   * @param stopClasses vector of class name strings
   */
  public void setStopClasses(ArrayList stopClasses) {
    if (this.stopClasses == null) {
      this.stopClasses = new ArrayList();
    }
    this.stopClasses.addAll(stopClasses);
  }

  /**
   * Add a list of classes (fully qualified) that will stop the traversal
   * of the inheritance tree if encounter in method or complex type generation
   *
   * @param text space separated list of class names
   */
  public void setStopClasses(String text) {
    if (text != null) {
      StringTokenizer tokenizer = new StringTokenizer(text, " ,+");
      if (stopClasses == null) {
        stopClasses = new ArrayList();
      }
      while (tokenizer.hasMoreTokens()) {
        stopClasses.add(tokenizer.nextToken());
      }
    }
  }

  /**
   * Return the list of classes which stop inhertance searches
   */
  public ArrayList getStopClasses() {
    return stopClasses;
  }

  /**
   * get the packagename to namespace map
   * @return <code>Map</code>
   */
  public Map getNamespaceMap() {
    return namespaces;
  }

  /**
   * Set the packagename to namespace map with the given map
   * @param map packagename/namespace <code>Map</code>
   */
  public void setNamespaceMap(Map map) {
    if (map != null)
      namespaces.putAll(map);
  }

  /**
   * Get the name of the input WSDL
   * @return name of the input wsdl or null
   */
  public String getInputWSDL() {
    return inputWSDL;
  }

  /**
   * Set the name of the input WSDL
   * @param inputWSDL the name of the input WSDL
   */
  public void setInputWSDL(String inputWSDL) {
    this.inputWSDL = inputWSDL;
  }

  /**
   * Returns the String representation of the service endpoint URL
   * @return String representation of the service endpoint URL
   */
  public String getLocationUrl() {
    return locationUrl;
  }

  /**
   * Set the String representation of the service endpoint URL
   * @param locationUrl the String representation of the service endpoint URL
   */
  public void setLocationUrl(String locationUrl) {
    this.locationUrl = locationUrl;
  }

  /**
   * Returns the String representation of the interface import location URL
   * @return String representation of the interface import location URL
   */
  public String getImportUrl() {
    return importUrl;
  }

  /**
   * Set the String representation of the interface location URL
   * for importing
   * @param importUrl the String representation of the interface
   * location URL for importing
   */
  public void setImportUrl(String importUrl) {
    this.importUrl = importUrl;
  }

  /**
   * Returns the String representation of the service port name
   * @return String representation of the service port name
   */
  public String getServicePortName() {
    return servicePortName;
  }

  /**
   * Set the String representation of the service port name
   * @param servicePortName the String representation of the service port name
   */
  public void setServicePortName(String servicePortName) {
    this.servicePortName = servicePortName;
  }

  /**
   * Returns the String representation of the service element name
   * @return String representation of the service element name
   */
  public String getServiceElementName() {
    return serviceElementName;
  }

  /**
   * Set the String representation of the service element name
   * @param serviceElementName the String representation of the service element name
   */
  public void setServiceElementName(String serviceElementName) {
    this.serviceElementName = serviceElementName;
  }

  /**
   * Returns the String representation of the portType name
   * @return String representation of the portType name
   */
  public String getPortTypeName() {
    return portTypeName;
  }

  /**
   * Set the String representation of the portType name
   * @param portTypeName the String representation of the portType name
   */
  public void setPortTypeName(String portTypeName) {
    this.portTypeName = portTypeName;
  }

  /**
   * Returns the String representation of the binding name
   * @return String representation of the binding name
   */
  public String getBindingName() {
    return bindingName;
  }

  /**
   * Set the String representation of the binding name
   * @param bindingName the String representation of the binding name
   */
  public void setBindingName(String bindingName) {
    this.bindingName = bindingName;
  }

  /**
   * Returns the target service name
   * @return the target service name
   */
  public String getTargetService() {
    return targetService;
  }

  /**
   * Set the target service name
   * @param targetService the target service name
   */
  public void setTargetService(String targetService) {
    this.targetService = targetService;
  }

  /**
   * Returns the service description
   * @return service description String
   */
  public String getDescription() {
    return description;
  }

  /**
   * Set the service description
   * @param description service description String
   */
  public void setDescription(String description) {
    this.description = description;
  }

  /**
   * Returns the soapAction option value
   * @return the String DEFAULT, NONE or OPERATION
   */
  public String getSoapAction() {
    return soapAction;
  }

  /**
   * Sets the soapAction option value
   * @param value must be DEFAULT, NONE, or OPERATION
   */
  public void setSoapAction(String value) {
    soapAction = value;
  }

  /**
   * Returns the <code>TypeMapping</code> used by the service
   * @return the <code>TypeMapping</code> used by the service
   */
  public TypeMapping getTypeMapping() {
    return tm;
  }

  /**
   * Sets the <code>TypeMapping</code> used by the service
   * @param tm the <code>TypeMapping</code> used by the service
   */
  public void setTypeMapping(TypeMapping tm) {
    this.tm = tm;
  }

  /**
   * Returns the default <code>TypeMapping</code> used by the service
   * @return the default <code>TypeMapping</code> used by the service
   */
  public TypeMapping getDefaultTypeMapping() {
    return defaultTM;
  }

  /**
   * Sets the default <code>TypeMapping</code> used by the service
   * @param defaultTM the default <code>TypeMapping</code> used by the service
   */
  public void setDefaultTypeMapping(TypeMapping defaultTM) {
    this.defaultTM = defaultTM;
  }

  public int getMode() {
    return mode;
  }

  public void setMode(int mode) {
    this.mode = mode;
  }

  public int getUse() {
    return use;
  }

  public void setUse(int use) {
    this.use = use;
  }



  public ServiceDesc getServiceDesc() {
    return serviceDesc;
  }

  public void setServiceDesc(ServiceDesc serviceDesc) {
    this.serviceDesc = serviceDesc;
  }

  //lbx
  public void setIdlFileName(String name) {
    this.idlFileName = name;
  }


  private ServiceDesc parseIDL(String idlFileName){
    //System.out.println("entering IDLToWSDL.Emitter.parseIDL()...") ;
    ServiceDesc serviceDesc = new ServiceDesc();
    // to do
    parser idlparser =  new parser();
    String[] temp = new String[1];
    temp[0] = idlFileName;
    boolean result = idlparser.compile(temp,serviceDesc);

    return serviceDesc;
  }

  private boolean searchisofse(ParameterDesc param)
  {
    //boolean ss=false;
    boolean tt=false;
    //if(thistypedef.getTypeQName()==null)
    {  String mm=param.gettypeName() ;

    ArrayList typedefs1 = serviceDesc.gettypedefs() ;
    // boolean tt=false;
    for (Iterator i1 = typedefs1.iterator(); i1.hasNext();)
    {
      TypedefDesc thistypedef1 = (TypedefDesc)i1.next();
      if(thistypedef1.getName().equalsIgnoreCase(mm) )
      {
        tt=thistypedef1.getisof_se() ;
        break;
      }

    }
    }
    //ss=tt;
    return tt;
  }


}
