package org.apache.axis.utils.tools;

import javax.swing.JPanel;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: </p>
 * @author not attributable
 * @version 1.0
 */
import javax.swing.*;
import javax.swing.border.TitledBorder;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import javax.swing.plaf.basic.BasicButtonListener;
import javax.swing.table.DefaultTableModel;
import javax.swing.table.TableColumn;
import javax.swing.table.TableModel;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowEvent;
import java.awt.*;


public class AdminPage extends JPanel {
        public JRadioButton  listenerButton, proxyButton ;
        public JLabel        hostLabel, tportLabel;
        public JTextField    port, host, tport ;
        public JTabbedPane   noteb ;
        public JCheckBox     HTTPProxyBox ;
        public JTextField    HTTPProxyHost, HTTPProxyPort ;
        public JLabel        HTTPProxyHostLabel, HTTPProxyPortLabel ;
        JTabbedPane notebook;
        String name ;

        public AdminPage( JTabbedPane notebook, String name ) {

          try {
            jbInit();
          }
          catch (Exception e) {
            e.printStackTrace();
          }
        }

        private void jbInit() {

          JPanel mainPane = null;
          JButton addButton = null;

          this.setLayout(new BorderLayout());
          noteb = notebook;

          GridBagLayout layout = new GridBagLayout();
          GridBagConstraints c = new GridBagConstraints();

          mainPane = new JPanel(layout);

          c.anchor = GridBagConstraints.WEST;
          c.gridwidth = GridBagConstraints.REMAINDER;
          mainPane.add(new JLabel(tcpmon.getMessage("newTCP00",
                                             "Create a new TCP/IP Monitor...") + " "),
                       c);

          // Add some blank space
          mainPane.add(Box.createRigidArea(new Dimension(1, 5)), c);

          // The listener info
          ///////////////////////////////////////////////////////////////////
          JPanel tmpPanel = new JPanel(new GridBagLayout());

          c.anchor = GridBagConstraints.WEST;
          c.gridwidth = 1;
          tmpPanel.add(new JLabel(tcpmon.getMessage("listenPort00", "Listen Port #") + " "),
                       c);

          c.anchor = GridBagConstraints.WEST;
          c.gridwidth = GridBagConstraints.REMAINDER;
          tmpPanel.add(port = new JTextField(4), c);

          mainPane.add(tmpPanel, c);

          mainPane.add(Box.createRigidArea(new Dimension(1, 5)), c);

          // Group for the radio buttons
          ButtonGroup btns = new ButtonGroup();

          c.anchor = GridBagConstraints.WEST;
          c.gridwidth = GridBagConstraints.REMAINDER;
          mainPane.add(new JLabel(tcpmon.getMessage("actAs00", "Act as a...")), c);

          // Target Host/Port section
          ///////////////////////////////////////////////////////////////////
          c.anchor = GridBagConstraints.WEST;
          c.gridwidth = GridBagConstraints.REMAINDER;

          final String listener = tcpmon.getMessage("listener00", "Listener");

          mainPane.add(listenerButton = new JRadioButton(listener), c);
          btns.add(listenerButton);
          listenerButton.setSelected(true);

          listenerButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent event) {
              if (listener.equals(event.getActionCommand())) {
                boolean state = listenerButton.isSelected();

                tport.setEnabled(state);
                host.setEnabled(state);
                hostLabel.setForeground(state ? Color.black : Color.gray);
                tportLabel.setForeground(state ? Color.black : Color.gray);
              }
            }
          }
          );

          c.anchor = GridBagConstraints.WEST;
          c.gridwidth = 1;
          mainPane.add(Box.createRigidArea(new Dimension(25, 0)));
          mainPane.add(hostLabel = new JLabel(tcpmon.getMessage("targetHostname00",
              "Target Hostname") + " "), c);

          c.anchor = GridBagConstraints.WEST;
          c.gridwidth = GridBagConstraints.REMAINDER;
          mainPane.add(host = new JTextField(30), c);

          c.anchor = GridBagConstraints.WEST;
          c.gridwidth = 1;
          mainPane.add(Box.createRigidArea(new Dimension(25, 0)));
          mainPane.add(tportLabel = new JLabel(tcpmon.getMessage("targetPort00",
              "Target Port #") + " "), c);

          c.anchor = GridBagConstraints.WEST;
          c.gridwidth = GridBagConstraints.REMAINDER;
          mainPane.add(tport = new JTextField(4), c);

          // Act as proxy section
          ///////////////////////////////////////////////////////////////////
          c.anchor = GridBagConstraints.WEST;
          c.gridwidth = GridBagConstraints.REMAINDER;
          final String proxy = tcpmon.getMessage("proxy00", "Proxy");

          mainPane.add(proxyButton = new JRadioButton(proxy), c);
          btns.add(proxyButton);

          proxyButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent event) {
              if (proxy.equals(event.getActionCommand())) {
                boolean state = proxyButton.isSelected();

                tport.setEnabled(!state);
                host.setEnabled(!state);
                hostLabel.setForeground(state ? Color.gray : Color.black);
                tportLabel.setForeground(state ? Color.gray : Color.black);
              }
            }
          }
          );

          // Spacer
          /////////////////////////////////////////////////////////////////
          c.anchor = GridBagConstraints.WEST;
          c.gridwidth = GridBagConstraints.REMAINDER;
          mainPane.add(Box.createRigidArea(new Dimension(1, 10)), c);

          // Options section
          ///////////////////////////////////////////////////////////////////
          JPanel opts = new JPanel(new GridBagLayout());

          opts.setBorder(new TitledBorder(tcpmon.getMessage("options00", "Options")));
          c.anchor = GridBagConstraints.WEST;
          c.gridwidth = GridBagConstraints.REMAINDER;
          mainPane.add(opts, c);

          // HTTP Proxy Support section
          ///////////////////////////////////////////////////////////////////
          c.anchor = GridBagConstraints.WEST;
          c.gridwidth = GridBagConstraints.REMAINDER;
          final String proxySupport = tcpmon.getMessage("proxySupport00",
                                                 "HTTP Proxy Support");

          opts.add(HTTPProxyBox = new JCheckBox(proxySupport), c);

          c.anchor = GridBagConstraints.WEST;
          c.gridwidth = 1;
          opts.add(HTTPProxyHostLabel = new JLabel(tcpmon.getMessage("hostname00",
              "Hostname") + " "), c);
          HTTPProxyHostLabel.setForeground(Color.gray);

          c.anchor = GridBagConstraints.WEST;
          c.gridwidth = GridBagConstraints.REMAINDER;
          opts.add(HTTPProxyHost = new JTextField(30), c);
          HTTPProxyHost.setEnabled(false);

          c.anchor = GridBagConstraints.WEST;
          c.gridwidth = 1;
          opts.add(HTTPProxyPortLabel = new JLabel(tcpmon.getMessage("port00", "Port #") +
                                                   " "), c);
          HTTPProxyPortLabel.setForeground(Color.gray);

          c.anchor = GridBagConstraints.WEST;
          c.gridwidth = GridBagConstraints.REMAINDER;
          opts.add(HTTPProxyPort = new JTextField(4), c);
          HTTPProxyPort.setEnabled(false);

          HTTPProxyBox.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent event) {
              if (proxySupport.equals(event.getActionCommand())) {
                boolean b = HTTPProxyBox.isSelected();
                Color color = b ? Color.black : Color.gray;

                HTTPProxyHost.setEnabled(b);
                HTTPProxyPort.setEnabled(b);
                HTTPProxyHostLabel.setForeground(color);
                HTTPProxyPortLabel.setForeground(color);
              }
            }
            ;
          }
          );

          // Set default proxy values...
          String tmp = System.getProperty("http.proxyHost");

          if (tmp != null && tmp.equals(""))
            tmp = null;

          HTTPProxyBox.setSelected(tmp != null);
          HTTPProxyHost.setEnabled(tmp != null);
          HTTPProxyPort.setEnabled(tmp != null);
          HTTPProxyHostLabel.setForeground(tmp != null ? Color.black : Color.gray);
          HTTPProxyPortLabel.setForeground(tmp != null ? Color.black : Color.gray);

          if (tmp != null) {
            HTTPProxyBox.setSelected(true);
            HTTPProxyHost.setText(tmp);
            tmp = System.getProperty("http.proxyPort");
            if (tmp != null && tmp.equals(""))
              tmp = null;
            if (tmp == null)
              tmp = "80";
            HTTPProxyPort.setText(tmp);
          }

          // Spacer
          //////////////////////////////////////////////////////////////////
          mainPane.add(Box.createRigidArea(new Dimension(1, 10)), c);

          // ADD Button
          ///////////////////////////////////////////////////////////////////
          c.anchor = GridBagConstraints.WEST;
          c.gridwidth = GridBagConstraints.REMAINDER;
          final String add = tcpmon.getMessage("add00", "Add");

          mainPane.add(addButton = new JButton(add), c);

          this.add(new JScrollPane(mainPane), BorderLayout.CENTER);

          // addButton.setEnabled( false );
          addButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent event) {
              if (add.equals(event.getActionCommand())) {
                String text;
                Listener l = null;
                int lPort = Integer.parseInt(port.getText());
                String tHost = host.getText();
                int tPort = 0;

                text = tport.getText();
                if (text != null && !text.equals(""))
                  tPort = Integer.parseInt(text);
                l = new Listener(noteb, null, lPort, tHost, tPort,
                                 proxyButton.isSelected());

                // Pick-up the HTTP Proxy settings
                ///////////////////////////////////////////////////
                text = HTTPProxyHost.getText();
                if ("".equals(text))
                  text = null;
                l.HTTPProxyHost = text;
                text = HTTPProxyPort.getText();
                if ("".equals(text))
                  text = null;
                if (text != null)
                  l.HTTPProxyPort = Integer.parseInt(text);

                port.setText(null);
                host.setText(null);
                tport.setText(null);
              }
            }
            ;
          }
          );


        }

  }
