package org.apache.axis.utils.tools;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: </p>
 * @author not attributable
 * @version 1.0
 */
import java.net.*;
import javax.swing.*;
import java.awt.Color;
import java.io.*;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.ResourceBundle;
import java.util.Vector;


public class Connection extends Thread {

  Listener     listener ;
  boolean      active ;
  String       fromHost ;
  String       time ;
  JTextArea    inputText    = null ;
  JScrollPane  inputScroll  = null ;
  JTextArea    outputText   = null ;
  JTextArea    info=null;
  infoStruct   infomation=new infoStruct();
  JScrollPane  outputScroll = null ;
  Socket       inSocket     = null ;
  Socket       outSocket    = null ;
  Thread       clientThread = null ;
  Thread       serverThread = null ;
  SocketRR     rr1          = null ;
  SocketRR     rr2          = null ;
  InputStream  inputStream  = null ;

  String       HTTPProxyHost = null ;
  int          HTTPProxyPort = 80 ;

  public Connection(Listener l) {
      listener = l ;
      HTTPProxyHost = l.HTTPProxyHost ;
      HTTPProxyPort = l.HTTPProxyPort ;
  }

  public Connection(Listener l, Socket s ) {
      this (l);
      inSocket = s ;
      start();
  }

  public Connection(Listener l, InputStream in ) {
      this (l);
      inputStream = in ;
      start();
  }

  public void run() {
      try {
          active        = true ;

          HTTPProxyHost = System.getProperty( "http.proxyHost" );
          if ( HTTPProxyHost != null && HTTPProxyHost.equals("") )
              HTTPProxyHost = null ;

          if ( HTTPProxyHost != null ) {
              String tmp = System.getProperty( "http.proxyPort" );

              if ( tmp != null && tmp.equals("") ) tmp = null ;
              if ( tmp == null ) HTTPProxyPort = 80 ;
              else HTTPProxyPort = Integer.parseInt( tmp );
          }

          if ( inSocket != null )
              fromHost = (inSocket.getInetAddress()).getHostName();
          else
              fromHost = "resend" ;

          DateFormat   df = new SimpleDateFormat("MM/dd/yy hh:mm:ss aa");

          time = df.format( new Date() );

          int count = listener.connections.size();

          listener.tableModel.insertRow(count + 1, new Object[] {
                  tcpmon.getMessage("active00", "Active"),
                  time,
                  fromHost,
                  listener.hostField.getText(), ""
              }
          );
          listener.connections.add( this );
          inputText  = new JTextArea( null, null, 20, 80 );
          //inputScroll = new JScrollPane( inputText );
          outputText = new JTextArea( null, null, 20, 80 );
          //outputScroll = new JScrollPane( outputText );
          info=new JTextArea( null, null, 20, 80 );

          ListSelectionModel lsm = listener.connectionTable.getSelectionModel();

          if ( count == 0 || lsm.getLeadSelectionIndex() == 0 ) {
              listener.outPane.setVisible( false );
              int divLoc = listener.outPane.getDividerLocation();

              listener.setLeft( inputText );
              listener.setRight( outputText );
              listener.setBottom(info);

              listener.removeButton.setEnabled(false);
              listener.removeAllButton.setEnabled(true);
              listener.saveButton.setEnabled(true);
              listener.resendButton.setEnabled(true);
              listener.outPane.setDividerLocation(divLoc);
              listener.outPane.setVisible( true );
          }

          String targetHost = listener.hostField.getText();
          int    targetPort = Integer.parseInt(listener.tPortField.getText());

          InputStream  tmpIn1  = inputStream ;
          OutputStream tmpOut1 = null ;

          InputStream  tmpIn2  = null ;
          OutputStream tmpOut2 = null ;

          if ( tmpIn1 == null )
              tmpIn1  = inSocket.getInputStream();

          if ( inSocket != null )
              tmpOut1 = inSocket.getOutputStream();

          String         bufferedData = null ;
          StringBuffer   buf = null ;

          int index = listener.connections.indexOf( this );
          int messageLength=0;
          if (listener.isProxyBox.isSelected() || HTTPProxyHost != null) {
              // Check if we're a proxy
              byte[]       b = new byte[1];

              buf = new StringBuffer();
              String       s ;

              for ( ; ; ) {
                  int len ;

                  len = tmpIn1.read(b, 0, 1);
                  if ( len == -1 ) break ;
                  messageLength+=len;
                  s = new String( b );
                  buf.append( s );
                  if ( b[0] != '\n' ) continue ;
                  break ;
              }

              bufferedData = buf.toString();
              inputText.append( bufferedData );

              if ( bufferedData.startsWith( "GET " ) ||
                  bufferedData.startsWith( "POST " ) ) {
                  int  start, end ;
                  URL  url ;

                  start = bufferedData.indexOf( ' ' ) + 1;
                  while ( bufferedData.charAt(start) == ' ' ) start++ ;
                  end   = bufferedData.indexOf( ' ', start );
                  String urlString = bufferedData.substring( start, end );

                  if ( urlString.charAt(0) == '/' ) urlString = urlString.substring(1);
                  if ( listener.isProxyBox.isSelected() ) {
                      url = new URL( urlString );
                      targetHost = url.getHost();
                      targetPort = url.getPort();
                      if ( targetPort == -1 ) targetPort = 80 ;

                      listener.tableModel.setValueAt( targetHost, index + 1,
                          tcpmon.OUTHOST_COLUMN );
                      bufferedData = bufferedData.substring( 0, start) +
                      url.getFile() +
                      bufferedData.substring( end );
                  }
                  else {
                      url = new URL( "http://" + targetHost + ":" +
                          targetPort + "/" + urlString );

                      listener.tableModel.setValueAt( targetHost, index + 1,
                          tcpmon.OUTHOST_COLUMN );
                      bufferedData = bufferedData.substring( 0, start) +
                      url.toExternalForm() +
                      bufferedData.substring( end );

                      targetHost = HTTPProxyHost ;
                      targetPort = HTTPProxyPort ;
                  }

              }
          }
          else {
              //
              // Change Host: header to point to correct host
              //
              byte[] b1 = new byte[1];

              buf = new StringBuffer();
              String s1;
              String lastLine = null ;

              for ( ; ; ) {
                  int len ;

                  len = tmpIn1.read(b1, 0, 1);
                  if ( len == -1 )
                      break ;
                  messageLength+=len;
                  s1 = new String( b1 );
                  buf.append( s1 );
                  if ( b1[0] != '\n' )
                      continue ;
                  // we have a complete line
                  String line = buf.toString();

                  buf.setLength(0);
                  // check to see if we have found Host: header
                  if (line.startsWith("Host: ")) {
                      // we need to update the hostname to target host
                      String newHost = "Host: " + targetHost + "\r\n";

                      bufferedData = bufferedData.concat(newHost);
                      break ;
                  }
                  // add it to our headers so far
                  if (bufferedData == null)
                      bufferedData = line;
                  else
                      bufferedData = bufferedData.concat(line);

                  // failsafe
                  if (line.equals("\r\n")) break;
                  if ("\n".equals(lastLine) && line.equals("\n")) break ;
                  lastLine = line ;
              }

              if ( bufferedData != null ) {
                  inputText.append( bufferedData );
                  int idx = bufferedData.length() < 50 ? bufferedData.length() : 50;
                  s1 = bufferedData.substring( 0, idx );
                  int i = s1.indexOf('\n');

                  if ( i > 0 ) s1 = s1.substring(0, i - 1);
                  s1 = s1 + "                           " +
                  "                       ";
                  s1 = s1.substring(0, 51);
                  listener.tableModel.setValueAt( s1, index + 1,
                      tcpmon.REQ_COLUMN );
              }
          }

          info.append("get input message's HTTP header tatol byte number is "+bufferedData.getBytes().length+"\n");

          if ( targetPort == -1 ) targetPort = 80 ;
          outSocket = new Socket(targetHost, targetPort );

          tmpIn2  = outSocket.getInputStream();
          tmpOut2 = outSocket.getOutputStream();
          long reWriteTime=System.currentTimeMillis();
          if ( bufferedData != null ) {
              byte[] b = bufferedData.getBytes();

              tmpOut2.write( b );
          }
          boolean format = listener.xmlFormatBox.isSelected();

          rr1 = new SocketRR(this, inSocket, tmpIn1, outSocket,
              tmpOut2, inputText, infomation,format,
              listener.tableModel, index + 1, "request:" );
          rr2 = new SocketRR( this, outSocket, tmpIn2, inSocket,
              tmpOut1, outputText, infomation,format,
              null, 0, "response:" );

          while ( rr1 != null || rr2 != null ) {
              // Only loop as long as the connection to the target
              // machine is available - once that's gone we can stop.
              // The old way, loop until both are closed, left us
              // looping forever since no one closed the 1st one.
              // while( !rr2.isDone() )
              if (null != rr1 && rr1.isDone()) {
                  if ( index >= 0  && rr2 != null) {
                      listener.tableModel.setValueAt(tcpmon.getMessage("resp00", "Resp"),
                          1 + index, tcpmon.STATE_COLUMN );
                  }
                 rr1 = null;
              }
              if (null != rr2 && rr2.isDone()) {
                  if ( index >= 0 && rr1 != null ) {
                      listener.tableModel.setValueAt(tcpmon.getMessage("req00", "Req"),
                          1 + index, tcpmon.STATE_COLUMN );
                  }
                  rr2 = null;
              }

              //  Thread.sleep( 10 );
              synchronized ( this) {
                  this.wait(1000); //Safety just incase we're not told to wake up.
              }
          }

          //  System.out.println("Done ");
          // rr1.halt();
          // rr2.halt();

          info.append(infomation.getAllInfo());
          active = false ;

          /*
           if ( inSocket != null ) {
           inSocket.close();
           inSocket = null ;
           }
           outSocket.close();
           outSocket = null ;
           */

          if ( index >= 0 ) {
              listener.tableModel.setValueAt(tcpmon.getMessage("done00", "Done"),
                  1 + index, tcpmon.STATE_COLUMN );

          }
      }
      catch ( Exception e ) {
          StringWriter st = new StringWriter();
          PrintWriter  wr = new PrintWriter(st);
          int index = listener.connections.indexOf( this );

          if ( index >= 0 )
              listener.tableModel.setValueAt( tcpmon.getMessage("error00", "Error"), 1 + index, tcpmon.STATE_COLUMN );
          e.printStackTrace(wr);
          wr.close();
          outputText.append( st.toString() );
          halt();
      }
  }

  synchronized void wakeUp() {
      this.notifyAll();
  }

  public void halt() {
      try {
          if ( rr1 != null ) rr1.halt();
          if ( rr2 != null ) rr2.halt();
          if ( inSocket  != null ) inSocket.close();
          inSocket = null ;
          if ( outSocket != null ) outSocket.close();
          outSocket = null ;
      }
      catch ( Exception e ) {
          e.printStackTrace();
      }
  }

  public void remove() {
      int index = -1;

      try {
          halt();
          index = listener.connections.indexOf( this );
          listener.tableModel.removeRow( index + 1 );
          listener.connections.remove( index );
      }
      catch ( Exception e ) {
          System.err.println("index:=" + index + this );
          e.printStackTrace();
      }
  }
}

