/*
 * The Apache Software License, Version 1.1
 *
 *
 * Copyright (c) 2001 The Apache Software Foundation.  All rights
 * reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *
 * 3. The end-user documentation included with the redistribution,
 *    if any, must include the following acknowledgment:
 *       "This product includes software developed by the
 *        Apache Software Foundation (http://www.apache.org/)."
 *    Alternately, this acknowledgment may appear in the software itself,
 *    if and wherever such third-party acknowledgments normally appear.
 *
 * 4. The names "Axis" and "Apache Software Foundation" must
 *    not be used to endorse or promote products derived from this
 *    software without prior written permission. For written
 *    permission, please contact apache@apache.org.
 *
 * 5. Products derived from this software may not be called "Apache",
 *    nor may "Apache" appear in their name, without prior written
 *    permission of the Apache Software Foundation.
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED.  IN NO EVENT SHALL THE APACHE SOFTWARE FOUNDATION OR
 * ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
 * USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
 * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 * ====================================================================
 *
 * This software consists of voluntary contributions made by many
 * individuals on behalf of the Apache Software Foundation.  For more
 * information on the Apache Software Foundation, please see
 * <http://www.apache.org/>.
 */
package org.apache.axis.utils.tools ;


import javax.swing.border.TitledBorder;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import javax.swing.plaf.basic.BasicButtonListener;
import javax.swing.table.DefaultTableModel;
import javax.swing.table.TableColumn;
import javax.swing.table.TableModel;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowEvent;
import java.io.ByteArrayInputStream;
import java.io.File;
import java.io.FileOutputStream;
import java.io.InputStream;
import java.io.OutputStream;
import java.io.PrintWriter;
import java.io.StringWriter;
import java.net.ServerSocket;
import java.net.Socket;
import java.net.URL;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.ResourceBundle;
import java.util.Vector;
import javax.swing.*;
import java.awt.*;


/**
 * @author Doug Davis (dug@us.ibm.com)
 */

public class tcpmon extends JFrame {
    private JTabbedPane  notebook = null ;

    public  static int STATE_COLUMN    = 0 ;
    public  static int TIME_COLUMN     = 1 ;
    public  static int INHOST_COLUMN   = 2 ;
    public  static int OUTHOST_COLUMN  = 3 ;
    public  static int REQ_COLUMN      = 4 ;



    public tcpmon(int listenPort, String targetHost, int targetPort) {
      super ( getMessage("tcpmon00", "TCPMonitor") );

      try {
        jbInit();
      }
      catch (Exception e) {
        e.printStackTrace();
      }



    if ( listenPort != 0 ) {
        Listener l = null ;

        if ( targetHost == null )
            l = new Listener( notebook, null, listenPort,
                targetHost, targetPort, true );
        else
            l = new Listener( notebook, null, listenPort,
                targetHost, targetPort, false );
        notebook.setSelectedIndex( 1 );

        l.HTTPProxyHost = System.getProperty( "http.proxyHost" );
        if ( l.HTTPProxyHost != null && l.HTTPProxyHost.equals("") )
            l.HTTPProxyHost = null ;

        if ( l.HTTPProxyHost != null ) {
            String tmp = System.getProperty( "http.proxyPort" );

            if ( tmp != null && tmp.equals("") ) tmp = null ;
            if ( tmp == null ) l.HTTPProxyPort = 80 ;
            else l.HTTPProxyPort = Integer.parseInt( tmp );
        }
    }

    this.pack();
    this.setSize( 600, 600 );
    this.setVisible( true );



    }

    protected void processWindowEvent(WindowEvent event) {
        switch ( event.getID() ) {
        case WindowEvent.WINDOW_CLOSING:
            exit();
            break ;

        default:
            super.processWindowEvent(event);
            break ;
        }
    }

    private void exit() {
        System.exit(0);
    }

    public void setInputPort(int port) {
    }

    public void setOutputHostPort(char hostName, int port) {
    }

    public static void main(String[] args) {
        try {
            if ( args.length == 3 ) {
                int p1 = Integer.parseInt( args[0] );
                int p2 = Integer.parseInt( args[2] );

                UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
                new tcpmon( p1, args[1], p2 );
            }
            else if ( args.length == 1 ) {
                int p1 = Integer.parseInt( args[0] );

                UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
                new tcpmon( p1, null, 0 );
            }
            else if ( args.length != 0 ) {
                System.err.println( getMessage("usage00", "Usage:") + " tcpmon [listenPort targetHost targetPort]\n");
            }
            else {
                UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
                new tcpmon(0, null, 0);
            }
        }
        catch ( Throwable exp ) {
            exp.printStackTrace();
        }
    }

    // Message resource bundle.
    private static ResourceBundle messages = null;
  JButton jButton1 = new JButton();

    /**
     * Get the message with the given key.  There are no arguments for this message.
     */
    public static String getMessage(String key, String defaultMsg) {
        try {
            if (messages == null) {
                initializeMessages();
            }
            return messages.getString(key);
        }
        catch (Throwable t) {
            // If there is any problem whatsoever getting the internationalized
            // message, return the default.
            return defaultMsg;
        }
    } // getMessage

    /**
     * Load the resource bundle messages from the properties file.  This is ONLY done when it is
     * needed.  If no messages are printed (for example, only Wsdl2java is being run in non-
     * verbose mode) then there is no need to read the properties file.
     */
    private static void initializeMessages() {
        messages = ResourceBundle.getBundle("org.apache.axis.utils.tcpmon");
    }


  private void jbInit() throws Exception {
    notebook = new JTabbedPane();
   this.getContentPane().add( notebook );

   AdminPage page=new AdminPage( notebook, getMessage("admin00", "Admin") );
   notebook.addTab(getMessage("admin00", "Admin"), page);
          notebook.repaint();
          notebook.setSelectedIndex(notebook.getTabCount() - 1);

  }

}
