package samples.helloworld.soapclient;

/**
 * <p>Title: CCMProvider Test</p>
 * <p>Description: this is a SOAP client for Web Service test.  </p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: StarMiddleware.net</p>
 * @author Wang Hongjun              flymanmail@163.com
 * @version 1.0
 */



import javax.xml.namespace.*;

import org.apache.axis.client.*;
import org.apache.axis.encoding.*;

public class HelloWorldClient {

  public static void main(String[] args) {
    HelloWorldClient HelloWorldClient1 = new HelloWorldClient();

    String endpointURL = "http://localhost:8080/axis/servlet/AxisServlet";
    for(int i=0;i<args.length-1;i++){
      if(args[i].equals("-port")){
        endpointURL = "http://localhost:" + args[i+1] +
            "/axis/servlet/AxisServlet";
        break;
      }
    }

    try {

      Service service = new Service();
      Call call = (Call) service.createCall();
      call.setTargetEndpointAddress(new java.net.URL(endpointURL));

      String serviceName="ccm-HelloWorld";
      QName opName = new QName(serviceName, "sayHello");
      QName retType = XMLType.SOAP_STRING;
      HelloWorldClient1.invoke(call, opName, retType, "\t\t"+serviceName+".");

      opName = new QName(serviceName, "singSong");
      retType = XMLType.SOAP_STRING;
      HelloWorldClient1.invoke(call, opName, retType, "\t\t"+serviceName+".");

    } catch (Exception e) {
      System.out.println(e);
    }

  }

  protected void invoke(Call call, QName opName, QName retType, String message) {
    try {
      System.out.println("- begin invoking ....");
      call.setOperationName(opName);
      call.setReturnType(retType);
      Object response = call.invoke(new Object[] {});

      System.out.print(message + opName.getLocalPart() + ":\t\t" + response +
                       "\n");
      System.out.println("- end invoking .");
    } catch (Exception e) {
      System.out.println(e);
    }
  }
}
