package samples.simpletest.soapclient;

/**
 * <p>Title: CCMProvider Test</p>
 * <p>Description: this is a SOAP client for Web Service test.  </p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: StarMiddleware.net</p>
 * @author Wang Hongjun              flymanmail@163.com
 * @version 1.0
 */


import javax.xml.namespace.*;

import org.apache.axis.client.*;
import org.apache.axis.encoding.*;

public class SimpleTestCCMClient {

  public static void main(String[] args) {
    SimpleTestCCMClient SimpleTestCCMClient1 = new SimpleTestCCMClient();

    String endpointURL = "http://localhost:8080/starwebservice/servlet/AxisServlet";
    for(int i=0;i<args.length-1;i++){
      if(args[i].equals("-port")){
        endpointURL = "http://localhost:" + args[i+1] +
            "/starwebservice/servlet/AxisServlet";
        break;
      }
    }

    try {

      Service service = new Service();
      Call call = (Call) service.createCall();
      call.setTargetEndpointAddress(new java.net.URL(endpointURL));

      String serviceName="ccm-SimpleTest";
      QName opName = new QName(serviceName, "sayBoolean");
      QName retType = XMLType.SOAP_BOOLEAN;
      SimpleTestCCMClient1.invoke(call, opName, retType, "\t\t"+serviceName+".");

      opName = new QName(serviceName, "sayShort");
      retType = XMLType.SOAP_SHORT;
      SimpleTestCCMClient1.invoke(call, opName, retType, "\t\t"+serviceName+".");

      opName = new QName(serviceName, "sayLong");
      retType = XMLType.SOAP_INT;
      SimpleTestCCMClient1.invoke(call, opName, retType, "\t\t"+serviceName+".");

      opName = new QName(serviceName, "sayLLong");
      retType = XMLType.SOAP_LONG;
      SimpleTestCCMClient1.invoke(call, opName, retType, "\t\t"+serviceName+".");

      opName = new QName(serviceName, "sayUShort");
      retType = XMLType.XSD_UNSIGNEDSHORT;
      SimpleTestCCMClient1.invoke(call, opName, retType, "\t\t"+serviceName+".");

      opName = new QName(serviceName, "sayULong");
      retType = XMLType.XSD_UNSIGNEDINT;
      SimpleTestCCMClient1.invoke(call, opName, retType, "\t\t"+serviceName+".");

      opName = new QName(serviceName, "sayULLong");
      retType = XMLType.XSD_UNSIGNEDLONG;
      SimpleTestCCMClient1.invoke(call, opName, retType, "\t\t"+serviceName+".");

      opName = new QName(serviceName, "sayOctet");
      retType = XMLType.XSD_UNSIGNEDBYTE;
      SimpleTestCCMClient1.invoke(call, opName, retType, "\t\t"+serviceName+".");

      opName = new QName(serviceName, "sayFloat");
      retType = XMLType.SOAP_FLOAT;
      SimpleTestCCMClient1.invoke(call, opName, retType, "\t\t"+serviceName+".");

      opName = new QName(serviceName, "sayDouble");
      retType = XMLType.SOAP_DOUBLE;
      SimpleTestCCMClient1.invoke(call, opName, retType, "\t\t"+serviceName+".");

      opName = new QName(serviceName, "sayString");
      retType = XMLType.SOAP_STRING;
      SimpleTestCCMClient1.invoke(call, opName, retType, "\t\t"+serviceName+".");

    } catch (Exception e) {
      System.out.println(e);
    }
  }

  protected void invoke(Call call, QName opName, QName retType, String message) {
    try {
      System.out.println("- begin invoking ....");
      call.setOperationName(opName);
      call.setReturnType(retType);
      Object response = call.invoke(new Object[] {});

      System.out.print(message + opName.getLocalPart() + ":\t\t" + response +
                       "\n");
      System.out.println("- end invoking .");
    } catch (Exception e) {
      System.out.println(e);
    }
  }

}
