package samples.simpletest.soapclient;

/**
 * <p>Title: CCMProvider Test</p>
 * <p>Description: this is a SOAP client for Web Service test.  </p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: StarMiddleware.net</p>
 * @author Wang Hongjun              flymanmail@163.com
 * @version 1.0
 */


import javax.xml.namespace.*;

import org.apache.axis.client.*;
import org.apache.axis.encoding.*;

public class SimpleTestFacetClient {

  public static void main(String[] args) {
    SimpleTestFacetClient FacetHelloClient1 = new SimpleTestFacetClient();

    String endpointURL = "http://localhost:8080/starwebservice/servlet/AxisServlet";
    for(int i=0;i<args.length-1;i++){
      if(args[i].equals("-port")){
        endpointURL = "http://localhost:" + args[i+1] +
            "/starwebservice/servlet/AxisServlet";
        break;
      }
    }

    try {

      Service service = new Service();
      Call call = (Call) service.createCall();
      call.setTargetEndpointAddress(new java.net.URL(endpointURL));

      String serviceName="ccm-SimpleTest";
      QName opName = new QName(serviceName, "singBoolean");
      QName retType = XMLType.SOAP_BOOLEAN;
      FacetHelloClient1.invoke(call, opName, retType, "\t\t"+serviceName+".");

      opName = new QName(serviceName, "singShort");
      retType = XMLType.SOAP_SHORT;
      FacetHelloClient1.invoke(call, opName, retType, "\t\t"+serviceName+".");

      opName = new QName(serviceName, "singLong");
      retType = XMLType.SOAP_INT;
      FacetHelloClient1.invoke(call, opName, retType, "\t\t"+serviceName+".");

      opName = new QName(serviceName, "singLLong");
      retType = XMLType.SOAP_LONG;
      FacetHelloClient1.invoke(call, opName, retType, "\t\t"+serviceName+".");

      opName = new QName(serviceName, "singUShort");
      retType = XMLType.XSD_UNSIGNEDSHORT;
      FacetHelloClient1.invoke(call, opName, retType, "\t\t"+serviceName+".");

      opName = new QName(serviceName, "singULong");
      retType = XMLType.XSD_UNSIGNEDINT;
      FacetHelloClient1.invoke(call, opName, retType, "\t\t"+serviceName+".");

      opName = new QName(serviceName, "singULLong");
      retType = XMLType.XSD_UNSIGNEDLONG;
      FacetHelloClient1.invoke(call, opName, retType, "\t\t"+serviceName+".");

      opName = new QName(serviceName, "singOctet");
      retType = XMLType.XSD_UNSIGNEDBYTE;
      FacetHelloClient1.invoke(call, opName, retType, "\t\t"+serviceName+".");

      opName = new QName(serviceName, "singFloat");
      retType = XMLType.SOAP_FLOAT;
      FacetHelloClient1.invoke(call, opName, retType, "\t\t"+serviceName+".");

      opName = new QName(serviceName, "singDouble");
      retType = XMLType.SOAP_DOUBLE;
      FacetHelloClient1.invoke(call, opName, retType, "\t\t"+serviceName+".");

      opName = new QName(serviceName, "singString");
      retType = XMLType.SOAP_STRING;
      FacetHelloClient1.invoke(call, opName, retType, "\t\t"+serviceName+".");

    } catch (Exception e) {
      System.out.println(e);
    }
  }

  protected void invoke(Call call, QName opName, QName retType, String message) {
    try {
      System.out.println("- begin invoking ....");
      call.setOperationName(opName);
      call.setReturnType(retType);
      Object response = call.invoke(new Object[] {});

      System.out.print(message + opName.getLocalPart() + "\t\t" + response +
                       "\n");
      System.out.println("- end invoking .");
    } catch (Exception e) {
      System.out.println(e);
    }
  }

}
