/*
 * The Apache Software License, Version 1.1
 *
 *
 * Copyright (c) 2002 The Apache Software Foundation.  All rights
 * reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *
 * 3. The end-user documentation included with the redistribution,
 *    if any, must include the following acknowledgment:
 *       "This product includes software developed by the
 *        Apache Software Foundation (http://www.apache.org/)."
 *    Alternately, this acknowledgment may appear in the software itself,
 *    if and wherever such third-party acknowledgments normally appear.
 *
 * 4. The names "Axis" and "Apache Software Foundation" must
 *    not be used to endorse or promote products derived from this
 *    software without prior written permission. For written
 *    permission, please contact apache@apache.org.
 *
 * 5. Products derived from this software may not be called "Apache",
 *    nor may "Apache" appear in their name, without prior written
 *    permission of the Apache Software Foundation.
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED.  IN NO EVENT SHALL THE APACHE SOFTWARE FOUNDATION OR
 * ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
 * USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
 * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 * ====================================================================
 *
 * This software consists of voluntary contributions made by many
 * individuals on behalf of the Apache Software Foundation.  For more
 * information on the Apache Software Foundation, please see
 * <http://www.apache.org/>.
 */

package samples.message;

import org.apache.axis.client.Service;
import org.apache.axis.client.Call;
import org.apache.axis.message.SOAPBodyElement;
import org.apache.axis.utils.Options;
import org.apache.axis.utils.XMLUtils;
import org.w3c.dom.Element;
import org.w3c.dom.CDATASection;
import org.w3c.dom.Document;

import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.DocumentBuilder;
import java.net.URL;
import java.util.Vector;

import org.apache.axis.message.SOAPHeaderElement;
/**
 * Simple test driver for our message service.
 */
public class JMSTestprocessDocumentMessageSerivce {
  static int flag = 1;
    public String doit(String[] args) throws Exception {
        Options opts = new Options(args);
        //opts.setDefaultURL("http://localhost:8080/axis/services/processElementsMessageService");
        //opts.setDefaultURL("http://localhost:8080/axis/services/processSoapBodyElementMessageService");
        opts.setDefaultURL("http://localhost:8080/axis/services/processDocumentMessageSerivce");
        //opts.setDefaultURL("http://172.26.13.60:8080/axis/services/processSoapEnvelopeMessageService");
        Service  service = new Service();
        Call     call    = (Call) service.createCall();

        call.setTargetEndpointAddress( new URL(opts.getURL()) );

        SOAPBodyElement[] input = new SOAPBodyElement[1];

        //input[0] = new SOAPBodyElement(XMLUtils.StringToElement("username",
        //                                                        "e1", "anonymous"));

        //input[1] = new SOAPBodyElement(XMLUtils.StringToElement("password",
        //                                                        "e2", "anonymous"));

        DocumentBuilder builder = DocumentBuilderFactory.newInstance().newDocumentBuilder();
        Document doc            = builder.newDocument();

        Element cdataElem       = doc.createElementNS("message", "e3");
        CDATASection cdata      = doc.createCDATASection("My order"+ flag);
        cdataElem.appendChild(cdata);

        input[0] = new SOAPBodyElement(cdataElem);

        Vector elems = (Vector) call.invoke( input );
        SOAPBodyElement elem  = null ;
        Element         e     = null ;

        if(elems.size()==0) return "Message have been send to service";


        elem = (SOAPBodyElement) elems.get(0);
        e    = elem.getAsDOM();

        String str = "Res elem[0]=" + XMLUtils.ElementToString(e);
        return( str );



        //call.invokeOneWay(input);

        //call.invokeOneWay( input );//added by zk



        //elem = (SOAPBodyElement) elems.get(1);
        //e    = elem.getAsDOM();
        //str = str + "Res elem[1]=" + XMLUtils.ElementToString(e);

        //elem = (SOAPBodyElement) elems.get(2);
        //e    = elem.getAsDOM();
        //str = str + "Res elem[2]=" + XMLUtils.ElementToString(e);


    }

    public static void main(String[] args) throws Exception {
      for(int i = 0 ; i < 1 ; i ++){
        String res = (new JMSTestSOAPEnvelope()).doit(args);
        flag = flag + 1;
        System.out.println(res);
      }
    }
}
