/***************************************************************************
 * Title:        CorbaDynamic
 * Description:  The version is developed  at Oct,2003
 * Copyright:    Copyright (c) 2003
 * Company:      ƴ nudt_613
 * @author       CORBA WebService Group
 * @version      1.0
******************************************************************************/


package  samples.uddi;

import java.util.Properties;
import org.uddi4j.transport.TransportFactory;


public class Configurator {

   public static String propDirectory(String propname)
   {
   String fileSeparator =  System.getProperty("file.separator");
   String  workingDir = System.getProperty("starws.home",System.getProperty("user.dir"));
   String result = workingDir+fileSeparator+"src"+fileSeparator+ "samples"+fileSeparator+"uddi"+fileSeparator+propname ;
   return result;
    }

   public static String fileDirectory(String propname)
   {
     int i=0;
     String fileSeparator =  System.getProperty("file.separator");
     String result="";
     String propdir=propDirectory(propname);
     int n=propdir.length();
     String[] temp=new String[n];
     while(i!=-1)
     { i=propdir.indexOf(fileSeparator);
       if(i==-1) break;
       temp[i]=propdir.substring(0,i);
       propdir=propdir.substring(i+1);
       result=result+temp[i]+"/";
     }
     return result+propname;
}

   public static Properties load() {
      Properties config = new Properties();
      try {
     //    config.load(new java.io.FileInputStream(propDirectory("uddi.prop")));
           config.load(new java.io.FileInputStream(fileDirectory("uddi.prop")));
     } catch (Exception e) {
         System.out.println("Error loading samples property file\n" + e);
      }

      if (System.getProperty(TransportFactory.PROPERTY_NAME)==null) {
         System.setProperty(TransportFactory.PROPERTY_NAME, config.getProperty("TransportClassName"));
      }
      if (System.getProperty("org.uddi4j.logEnabled")==null) {
         System.setProperty("org.uddi4j.logEnabled", config.getProperty("logEnabled"));
      }

      // Configure JSSE support
      try {
         System.setProperty("java.protocol.handler.pkgs", config.getProperty("handlerPackageName"));

         // Dynamically loads security provider based on properties. Typically configured in JRE
         java.security.Security.addProvider((java.security.Provider)
            Class.forName(config.getProperty("securityClassName")).newInstance());
      } catch (Exception e) {
         System.out.println("Error configuring JSSE provider. Make sure JSSE is in classpath.\n" + e);
      }
      return config;
   }

}
