/***************************************************************************
 * Title:        CorbaDynamic
 * Description:  The version is developed  at Oct,2003
 * Copyright:    Copyright (c) 2003
 * Company:      ƴ nudt_613
 * @author       CORBA WebService Group
 * @version      1.0
******************************************************************************/


package samples.uddi;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import java.net.*;
import java.util.*;
import org.uddi4j.*;
import org.uddi4j.util.*;
import org.uddi4j.client.*;
import org.uddi4j.response.*;
import org.uddi4j.transport.*;
import org.uddi4j.datatype.*;
import org.uddi4j.datatype.assertion.*;
import org.uddi4j.datatype.binding.*;
import org.uddi4j.datatype.business.*;
import org.uddi4j.datatype.service.*;
import org.uddi4j.datatype.tmodel.*;
import org.uddi4j.request.*;

import org.uddi4j.util.*;
import java.util.Properties;
import java.util.Vector;

public class UDDI4JBusinessSample {

  public static final String inquiryURL =
      "http://localhost:8080/RegistryServer/";
  public static final String publishURL =
      "http://localhost:8080/RegistryServer/";

  protected UDDIProxy proxy = null;
  protected BusinessEntity businessEntity = null;

  Properties config = Configurator.load();
  public String userid = config.getProperty("userid");
  public String password = config.getProperty("password");
  protected String authInfo=null;

  public static void main(String args[]) throws Exception {
    UDDI4JBusinessSample sample = new UDDI4JBusinessSample();
    try {
      sample.init();
      sample.findBusiness();
      sample.displayBusinessInfo();
    }
    catch (Exception e) {
      System.out.println("Exception:" + e);
      e.printStackTrace();
    }
  }

  protected void init() throws MalformedURLException, UDDIException,
      TransportException {
    if(config.getProperty("inquiryURL").equals(""))
        { proxy=new UDDIProxy(new URL(inquiryURL),new URL(publishURL)); }
        else {
        UDDIProxy proxy1=new UDDIProxy(new URL(config.getProperty("inquiryURL")),new URL(config.getProperty("publishURL")));
        proxy=proxy1;}
        authInfo=proxy.get_authToken(userid,password).getAuthInfoString();
        }


  protected void findBusiness() throws UDDIException, TransportException {
    Vector names = new Vector();
    names.addElement(new Name("Bill's Office Services"));
    BusinessList list = proxy.find_business(names, null, null, null, null, null,
                                            0);

    BusinessInfos infos = list.getBusinessInfos();
    if (infos.getBusinessInfoVector().size() == 0) {
      throw new RuntimeException("No business found!");
    }

    BusinessInfo info = (BusinessInfo) infos.getBusinessInfoVector().elementAt(
        0);
    String businessKey = info.getBusinessKey();
    businessEntity = (BusinessEntity) proxy.get_businessDetail(businessKey).
        getBusinessEntityVector().elementAt(0);
  }

  protected void displayBusinessInfo() {
    System.out.println("Business Key:" + businessEntity.getBusinessKey());
    System.out.print("Business Name:" + businessEntity.getDefaultNameString());

    CategoryBag cb = businessEntity.getCategoryBag();
    if (cb != null) {
      Vector keyedReferences = cb.getKeyedReferenceVector();

      Enumeration enum = keyedReferences.elements();
      while (enum.hasMoreElements()) {
        KeyedReference kr = (KeyedReference) enum.nextElement();
        System.out.println("\n Key name: " + kr.getKeyName());
        System.out.println("\n Key Value: " + kr.getKeyValue());
        System.out.println("\n TModel Ref ID: " + kr.getTModelKey());
      }
    }

    System.out.println();
    BusinessServices bs = businessEntity.getBusinessServices();
    if (bs != null) {
      Vector services = bs.getBusinessServiceVector();
      Enumeration enum = services.elements();
      while (enum.hasMoreElements()) {
        BusinessService service = (BusinessService) enum.nextElement();
        System.out.println("\n Service Name:" + service.getDefaultNameString());
        System.out.println("\n Service Key:" + service.getServiceKey());

      }

    }

  }
}