/***************************************************************************
 * Title:        CorbaDynamic
 * Description:  The version is developed  at Oct,2003
 * Copyright:    Copyright (c) 2003
 * Company:      ƴ nudt_613
 * @author       CORBA WebService Group
 * @version      1.0
******************************************************************************/

package  samples.uddi;
import java.net.*;
import java.util.*;

import org.uddi4j.*;
import org.uddi4j.client.*;
import org.uddi4j.response.*;

import org.uddi4j.transport.*;
import org.uddi4j.datatype.business.*;
import org.uddi4j.datatype.service.*;
import org.uddi4j.datatype.*;
import org.uddi4j.datatype.tmodel.*;
import org.uddi4j.datatype.binding.*;
import org.uddi4j.util.*;
import org.uddi4j.datatype.*;

public class UDDI4JCompleteSample {
   protected UDDIProxy proxy=null;
   protected String authInfo=null;
   protected String tModelKey=null;
   protected String businessKey=null;
   protected String serviceKey=null;
   protected String bindingKey=null;


   Properties config = Configurator.load();
   public String userid = config.getProperty("userid");
   public String password = config.getProperty("password");

   public static final String inquiryURL="http://localhost:8080/RegistryServer/";
   public static final String publishURL="http://localhost:8080/RegistryServer/";

   public static void main(String args[]) throws Exception {
     System.setProperty("java.protocol.handler.pkgs","com.sun.net.ssl.internal.www.protocol");
     java.security.Security.addProvider(new com.sun.net.ssl.internal.ssl.Provider()) ;

     UDDI4JCompleteSample sample=new UDDI4JCompleteSample();
     try {
        sample.init();
        sample.saveTModel();
        sample.findBusiness();
        sample.addService();
        sample.addBindingTemplate();
         }      catch(Exception e)
         { System.out.println("Exception:"+e);
         }
       }

       protected void init() throws MalformedURLException, UDDIException,TransportException{

       if(config.getProperty("inquiryURL").equals(""))
         { proxy=new UDDIProxy(new URL(inquiryURL),new URL(publishURL)); }
         else {
         UDDIProxy proxy1=new UDDIProxy(new URL(config.getProperty("inquiryURL")),new URL(config.getProperty("publishURL")));
         proxy=proxy1;}
         authInfo=proxy.get_authToken(userid,password).getAuthInfoString();
         }

        protected void saveTModel() throws UDDIException, TransportException{
           TModel tm=new TModel();
           tm.setName("Addressbook tModel");
           tm.setTModelKey("");

           OverviewDoc od=new OverviewDoc();
           od.setOverviewURL("http://localhost:8081/examples/GetQuote.wsdl");
           tm.setOverviewDoc(od);

           KeyedReference kr1=new KeyedReference("uddi-org:types","wsdlSpec");
           kr1.setTModelKey("UUID:C1ACF26D-9672-4404-9D70-39B756E62AB4");

           KeyedReference kr2=new KeyedReference("Office administration or secretarial services","80161501");
           kr2.setTModelKey("UUID:DB77450D-9FA8-45D4-A7BC-04411D14E384");

           Vector krv=new Vector();
           krv.addElement(kr1);
           krv.addElement(kr2);

           CategoryBag cb=new CategoryBag();
           cb.setKeyedReferenceVector(krv);

           tm.setCategoryBag(cb);
           Vector entities=new Vector();
           entities.addElement(tm);
           TModelDetail r=proxy.save_tModel(authInfo,entities);

           tModelKey=((TModel)r.getTModelVector().elementAt(0)).getTModelKey();
           System.out.println("Created tModel with Key:  "+tModelKey);
           System.out.println("tmodel is   "+tm.toString());
           }

        protected void findBusiness() throws UDDIException, TransportException {
        Vector names=new Vector();
        names.addElement(new Name("Bill's"));
        BusinessList bl=proxy.find_business(names,null, null, null, null, null, 0);
        Vector biVector=bl.getBusinessInfos().getBusinessInfoVector();

        if(biVector.size()==0) {
         throw new RuntimeException("Could not find business!!!");

        }
        businessKey=((BusinessInfo)biVector.elementAt(0)).getBusinessKey();
        System.out.println("Found Business with key: "+businessKey);
        }

        protected void addService() throws UDDIException, TransportException{
        BusinessService bs=new BusinessService();
        bs.setDefaultNameString("Address Service","en");
        bs.setBusinessKey(businessKey);
        bs.setServiceKey("");

        Vector btv=new Vector();
        BindingTemplates bts=new BindingTemplates();
        bts.setBindingTemplateVector(btv);
        bs.setBindingTemplates(bts);

         KeyedReference kr=new KeyedReference("Office administration or secretarial services","80161501");
         kr.setTModelKey("UUID:DB77450D-9FA8-45D4-A7BC-04411D14E384");

         Vector krv=new Vector();
         krv.addElement(kr);
         CategoryBag cb=new CategoryBag();
         cb.setKeyedReferenceVector(krv);

         bs.setCategoryBag(cb);
         Vector entities=new Vector();
         entities.addElement(bs);
         ServiceDetail r=proxy.save_service(authInfo,entities);

         serviceKey=((BusinessService)r.getBusinessServiceVector().elementAt(0)).getServiceKey();
         System.out.println("Create Service with key:  "+serviceKey);
         }

         protected void addBindingTemplate() throws UDDIException, TransportException{
         BindingTemplate bt=new BindingTemplate();
         bt.setServiceKey(serviceKey);
         bt.setBindingKey("");


         AccessPoint ap=new AccessPoint();
         ap.setURLType("http");
         ap.setText("http://localhost:8081/axis/servlet/AxisServlet");
         bt.setAccessPoint(ap);

         OverviewDoc tmod=new OverviewDoc();
       //  tmod.setOverviewURL("http://localhost:8080/Wrox/wsdl/AddressbookService.wsdl");
         tmod.setOverviewURL("http://localhost:8081/examples/GetQuote.wsdl");
         InstanceDetails   instanceDetails=new InstanceDetails();
         instanceDetails.setOverviewDoc(tmod);

         TModelInstanceInfo  tmii=new TModelInstanceInfo(tModelKey);
         tmii.setInstanceDetails(instanceDetails);


         Vector tmiiv=new Vector();
         tmiiv.addElement(tmii);

         TModelInstanceDetails tmid=new TModelInstanceDetails();
         tmid.setTModelInstanceInfoVector(tmiiv);


         bt.setTModelInstanceDetails(tmid);

         Vector entities=new Vector();
         entities.addElement(bt);
         BindingDetail r=proxy.save_binding(authInfo,entities);

         bindingKey=((BindingTemplate)r.getBindingTemplateVector().elementAt(0)).getBindingKey();
         System.out.println("Created bindTemplate with key:  "+bindingKey);

        }


}