/***************************************************************************
 * Title:        CorbaDynamic
 * Description:  The version is developed  at Oct,2003
 * Copyright:    Copyright (c) 2003
 * Company:      ƴ nudt_613
 * @author       CORBA WebService Group
 * @version      1.0
******************************************************************************/


package samples.uddi;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import java.net.*;
import java.util.*;
import org.uddi4j.*;
import org.uddi4j.util.*;
import org.uddi4j.client.*;
import org.uddi4j.response.*;
import org.uddi4j.transport.*;
import org.uddi4j.datatype.*;
import org.uddi4j.datatype.assertion.*;
import org.uddi4j.datatype.binding.*;
import org.uddi4j.datatype.business.*;
import org.uddi4j.datatype.service.*;
import org.uddi4j.datatype.tmodel.*;
import org.uddi4j.request.*;

import org.uddi4j.util.*;
import java.util.Properties;
import java.util.Vector;

public class UDDI4JPublishSample {

  protected UDDIProxy proxy = null;
  protected String authInfo = null;
  Properties config = Configurator.load();
  public String userid = config.getProperty("userid");
  public String password = config.getProperty("password");
  public static final String inquiryURL="http://localhost:8080/RegistryServer/";
  public static final String publishURL="http://localhost:8080/RegistryServer/";

  public static void main(String args[]) throws Exception {
    System.setProperty("java.protocol.handler.pkgs",
                       "com.sun.net.ssl.internal.www.protocol");
    java.security.Security.addProvider(new com.sun.net.ssl.internal.ssl.
                                       Provider());
    UDDI4JPublishSample sample = new UDDI4JPublishSample();
    try {
      sample.init();
      sample.publishBusiness();
    }
    catch (Exception e) {
      System.out.println("Exception :" + e);
    }
  }

  protected void init() throws MalformedURLException, TransportException,
      UDDIException {
    if (config.getProperty("inquiryURL").equals("")) {
      proxy = new UDDIProxy(new URL(inquiryURL), new URL(publishURL));
    }
    else {
      UDDIProxy proxy1 = new UDDIProxy(new URL(config.getProperty("inquiryURL")),
                                       new URL(config.getProperty("publishURL")));
      proxy = proxy1;
    }
    authInfo = proxy.get_authToken(userid, password).getAuthInfoString();
  }


protected void publishBusiness() throws UDDIException, TransportException {
  KeyedReference kr = new KeyedReference(
      "Administrative Management and General Management Consulting Services",
      "541611");
  kr.setTModelKey("UUID:C0B9FE13-179F-413D-8A5B-5004DB8E5BB2");
  Vector krVector = new Vector();
  krVector.addElement(kr);
  CategoryBag cb = new CategoryBag();
  cb.setKeyedReferenceVector(krVector);
  org.uddi4j.datatype.business.Address address = new org.uddi4j.datatype.
      business.Address();
  Vector addressStrings = new Vector();
  addressStrings.add("1234 1st Ave SW");
  addressStrings.add("Rochester, MN 55902");
  addressStrings.add("USA");

  Contact contact = new Contact();
  contact.setPersonName("HJQ");

  Vector addresses = new Vector();
  contact.setAddressVector(addresses);

  Vector emails = new Vector();
  emails.add(new Email("jqhucn@hotmail.com"));
  contact.setEmailVector(emails);

  Contacts contacts = new Contacts();
  Vector contactVector = new Vector();

  contactVector.add(contact);
  contacts.setContactVector(contactVector);

  BusinessEntity be = new BusinessEntity();
  be.setDefaultName(new Name("Bill's Office Services"));
  // be.setDefaultNameString("Bill's Office Services","en");
  be.setDefaultDescriptionString(
      "A business offering services around the office");

  be.setBusinessKey("");
  be.setContacts(contacts);
  be.setCategoryBag(cb);

  Vector beVector = new Vector();
  beVector.addElement(be);

  proxy.save_business(authInfo, beVector);
  System.out.println("Business saved.");

}
}