/*
 * The Apache Software License, Version 1.1
 *
 *
 * Copyright (c) 2001 The Apache Software Foundation.  All rights
 * reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *
 * 3. The end-user documentation included with the redistribution,
 *    if any, must include the following acknowledgment:
 *       "This product includes software developed by the
 *        Apache Software Foundation (http://www.apache.org/)."
 *    Alternately, this acknowledgment may appear in the software itself,
 *    if and wherever such third-party acknowledgments normally appear.
 *
 * 4. The names "Axis" and "Apache Software Foundation" must
 *    not be used to endorse or promote products derived from this
 *    software without prior written permission. For written
 *    permission, please contact apache@apache.org.
 *
 * 5. Products derived from this software may not be called "Apache",
 *    nor may "Apache" appear in their name, without prior written
 *    permission of the Apache Software Foundation.
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED.  IN NO EVENT SHALL THE APACHE SOFTWARE FOUNDATION OR
 * ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
 * USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
 * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 * ====================================================================
 *
 * This software consists of voluntary contributions made by many
 * individuals on behalf of the Apache Software Foundation.  For more
 * information on the Apache Software Foundation, please see
 * <http://www.apache.org/>.
 */

package org.apache.axis.transport.http ;

import java.io.IOException;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.xml.soap.SOAPException;


import org.apache.axis.Constants;
import org.apache.axis.Message;
import javax.xml.soap.SOAPBody;

import org.apache.axis.server.AxisServer;
import org.apache.axis.MessageContext;
import org.apache.axis.AxisEngine;
import org.apache.axis.utils.JavaUtils;
import org.apache.axis.utils.Messages;
import org.apache.axis.AxisFault;
import org.apache.axis.components.logger.LogFactory;
import org.apache.commons.logging.Log;
import org.apache.axis.utils.XMLUtils;

import org.w3c.dom.Document;
import org.xml.sax.InputSource;
import org.w3c.dom.NodeList;
import org.w3c.dom.Node;
import org.w3c.dom.NamedNodeMap;
import org.w3c.dom.Element;
import org.apache.xerces.dom.DeepNodeListImpl;
import java.io.*;
/**
 * Proof-of-concept "management" servlet for Axis.
 *
 * Point a browser here to administer the Axis installation.
 *
 * Right now just starts and stops the server.
 *
 * @author Glen Daniels (gdaniels@macromedia.com)
 */
public class AdminServlet extends AxisServletBase {

    private static Log log =
            LogFactory.getLog(AxisServlet.class.getName());

    private String infoPage="../admin/info.jsp";
    /**
     * handle a GET request. Commands are only valid when not in production mode
     * @param request
     * @param response
     * @throws ServletException
     * @throws IOException
     */
    /*
    public void doGet(HttpServletRequest request, HttpServletResponse response)
        throws ServletException, IOException {
        response.setContentType("text/html");
        StringBuffer buffer=new StringBuffer(512);
        buffer.append("<html><head><title>Axis</title></head><body>\n");
        //REVISIT: what happens if there is no engine?
        AxisServer server = getEngine();

        //process command
        String cmd = request.getParameter("cmd");
        if (cmd != null) {
            //who called?
            String callerIP=request.getRemoteAddr();
            if (isDevelopment()) {
                //only in dev mode do these command work
                if (cmd.equals("start")) {
                    log.info(Messages.getMessage("adminServiceStart", callerIP));
                    server.start();
                }
                else if (cmd.equals("stop")) {
                    log.info(Messages.getMessage("adminServiceStop", callerIP));
                    server.stop();
                }
            } else {
                //in production we log a hostile probe. Remember: logs can be
                //used for DoS attacks themselves.
                log.info(Messages.getMessage("adminServiceDeny", callerIP));
            }
        }

        // display status
        if (server.isRunning()) {
            buffer.append("Hi, Nick, " + Messages.getMessage("serverRun00"));  //by zk
        }
        else {
            buffer.append(Messages.getMessage("serverStop00"));
        }
        //add commands
        if(isDevelopment() || true) {   //by zhoubin, to let the cmds out
            buffer.append("<p><a href=\"AdminServlet?cmd=start\">start server</a>\n");
            buffer.append("<p><a href=\"AdminServlet?cmd=stop\">stop server</a>\n");
        }
        //print load
        buffer.append("<p>");
        buffer.append(Messages.getMessage("adminServiceLoad",
                Integer.toString(getLoadCounter())));
        buffer.append("\n</body></html>\n");
        response.getWriter().print( new String(buffer) );
    }
      */
     //shuichao
     public void doPost(HttpServletRequest request, HttpServletResponse response)
         throws ServletException, IOException{
         process(request,response);
     }
     public void doGet(HttpServletRequest request, HttpServletResponse response)
     throws ServletException, IOException{
         process(request,response);
     }
     void process(HttpServletRequest request, HttpServletResponse response)
         throws ServletException, IOException {
         StringBuffer buffer=new StringBuffer();
         //REVISIT: what happens if there is no engine?
         AxisServer server = getEngine();

         //process command
         String cmd = request.getParameter("cmd");
         if (cmd != null) {
                //only in dev mode do these command work
                 if (cmd.equals("start")) {
                     startServer(server,request,response);
                 }
                 else if (cmd.equals("stop")) {
                     stopServer(server,request,response);
                 }
                 else if (cmd.equals("addNewJavaService")) {
                     addNewJavaService(request,response);
                 }
                 else if (cmd.equals("addNewCorbaService")) {
                    addNewCorbaService(request,response);
                }

                 else if (cmd.equals("addServiceParameter")) {
                     addServiceParameter(request,response);
                 }

                 else if (cmd.equals("login")) {
                     login(request,response);
                 }

                 else if(cmd.equals("getGlobal")){
                     getGlobal(request,response);
                 }
                 else if(cmd.equals("getTransport")){
                    getTransport(request,response);
                }

                 else if(cmd.equals("getService")){
                     getService(request,response);
                 }
                 else if(cmd.equals("getJavaServiceDetail")){
                     getJavaServiceDetail(request,response);
                 }

                 else if(cmd.equals("deployService")){
                     deployService(request,response,true);
                 }
                 else if(cmd.equals("undeployService")){
                     deployService(request,response,false);
                 }
                 else if(cmd.equals("showModifyJavaService")){
                      showModifyJavaService(request,response);
                  }

                else if(cmd.equals("getHandlerDetail")){
                        getHandlerDetail(request,response);
                    }

                 else  if(cmd.equals("getStatus")){
                 //in production we log a hostile probe. Remember: logs can be
                 //used for DoS attacks themselves.
                 if (server.isRunning())
                   buffer.append(
                       "server is running ,you can <a href=\"AdminServlet?cmd=stop\"> stop server</a> ");
                 else
                   buffer.append("server is stopping ,you can <a href=\"AdminServlet?cmd=start\"> start server</a> ");
                 request.setAttribute("info", buffer);
                 request.getRequestDispatcher(infoPage).forward(request, response);
                 return;

             }
         }


     }
     void login(HttpServletRequest request, HttpServletResponse response){
       //we should check the user password here

       //now only show the main.jsp
       try{
         this.getServletContext().getRequestDispatcher("/admin/main.jsp").forward(request, response);
       }catch(ServletException e2){

       }catch(IOException e2){

       }

     }
     void startServer(AxisServer server,HttpServletRequest request, HttpServletResponse response){
       StringBuffer buffer=new StringBuffer();
       log.info(Messages.getMessage("adminServiceStart", ""));
       server.start();
       // display status
         if (server.isRunning()) {
            buffer.append("Hi, Nick, " + Messages.getMessage("serverRun00"));
         }
         else {
             buffer.append("error"+Messages.getMessage("serverStop00"));
         }
         try{
           request.setAttribute("info", buffer);
           request.getRequestDispatcher(infoPage).forward(request, response);
         }catch(IOException e1){

         }catch(ServletException e2){
         }

     }
     /**
      * only show a page for modify java service,on the page all the property of
      * special service has show.
      * @param request
      * @param response
      */
     void showModifyJavaService(HttpServletRequest request, HttpServletResponse response){
       Node tNode=getServiceDetail(request,response);
       String action="<action name=\"modifyJavaService\"></action>";
       writerOut(response,XMLUtils.ElementToString( (Element)tNode)+action,"../admin/javaService/service.xsl");
     }

     /**
      * only show a page for add a new service
      * function for realy add a new service is deplyService()
      * @param request
      * @param response
      */
     void addNewJavaService(HttpServletRequest request, HttpServletResponse response){
       String xsltURI="../admin/javaService/service.xsl";

       PrintWriter writer=null;
       try {
         writer = response.getWriter();
       }
       catch (IOException e) {
         return ;
       }
       response.setContentType("text/xml");

       writer.println("<?xml version=\"1.0\" encoding=\"UTF-8\"?>");
       writer.println("<?xml-stylesheet type=\"text/xsl\" href=\"" + xsltURI +
                      "\"?>");
       writer.println("<deployment>");
       writer.println("<service ><parameter/><parameter/><parameter/><parameter/></service>");
       writer.println("<action name=\"deployService\"></action>");
       writer.println("</deployment>");
       writer.close();

     }
     void addNewCorbaService(HttpServletRequest request, HttpServletResponse response){
       String xsltURI="../admin/javaService/corbaService.xsl";

       PrintWriter writer=null;
       try {
         writer = response.getWriter();
       }
       catch (IOException e) {
         return ;
       }
       response.setContentType("text/xml");

       writer.println("<?xml version=\"1.0\" encoding=\"UTF-8\"?>");
       writer.println("<?xml-stylesheet type=\"text/xsl\" href=\"" + xsltURI +
                      "\"?>");
       writer.println("<deployment>");
       writer.println("<service ><parameter/><parameter/><parameter/><parameter/></service>");
       writer.println("<action name=\"deployService\"></action>");
       writer.println("</deployment>");
       writer.close();

     }

     void stopServer(AxisServer server,HttpServletRequest request, HttpServletResponse response){
       StringBuffer buffer=new StringBuffer();
       log.info(Messages.getMessage("adminServiceStart", ""));
       server.stop();
       // display status
         if (server.isRunning()) {
            buffer.append("error, " + Messages.getMessage("serverRun00"));  //by zk
         }
         else {
             buffer.append("ok,"+Messages.getMessage("serverStop00"));
         }
         try{
           request.setAttribute("info", buffer);
           request.getRequestDispatcher(infoPage).forward(request, response);
         }catch(IOException e1){

         }catch(ServletException e2){
         }

     }
     void getGlobal(HttpServletRequest request, HttpServletResponse response){
        NodeList node=getDeloymentInfo(request,response,"globalConfiguration");
        if(node!=null){
          writerOutWithNodeList(response,node,"../admin/global.xslt");
        }
     }
     void getTransport(HttpServletRequest request, HttpServletResponse response){
       NodeList node=getDeloymentInfo(request,response,"transport");
       if(node!=null){
         writerOutWithNodeList(response,node,"../admin/transport.xslt");
       }
    }

     void getService(HttpServletRequest request, HttpServletResponse response){
        NodeList node=getDeloymentInfo(request,response,"service");
        if(node!=null){
          writerOutWithNodeList(response,node,"../admin/service.xslt");
        }

     }
     /**
      * get service detail from server-config.wsdd file
      * and write out it
      * @param request
      * @param response
      */
    void getJavaServiceDetail(HttpServletRequest request, HttpServletResponse response){
      Node tNode=getServiceDetail(request,response);
      if(tNode!=null) writerOutWithNode(response, tNode, "../admin/javaService/serviceDetail.xslt");
    }
    /**
     * get service detail from server-config.wsdd file
     * @param request
     * @param response
     * @return
     */
    private  Node getServiceDetail(HttpServletRequest request, HttpServletResponse response){
        NodeList nodeList=getDeloymentInfo(request,response,"service");
        if(nodeList!=null){
          for (int i = 0; i <nodeList.getLength(); i++){
            Node tNode = nodeList.item(i);
            NamedNodeMap map=tNode.getAttributes();
            String serviceName = request.getParameter("serviceName");
              if(map.getNamedItem("name").getNodeValue().equals(serviceName)){
                return tNode;
              }
          }

        }
       return null;
     }

     /**
      * invoke org.apache.axis.util.admin,return the MessageContext
      * @param request
      * @param response
      * @return
      * @throws AxisFault
      */
     MessageContext invokeAdmin(HttpServletRequest request, HttpServletResponse response,String bodyString) throws AxisFault{

         AxisEngine engine = getEngine();


         String msgtxt =
             "<SOAP-ENV:Envelope" +
             " xmlns:SOAP-ENV=\"http://schemas.xmlsoap.org/soap/envelope/\">" +
             "<SOAP-ENV:Body>" + bodyString + "</SOAP-ENV:Body>" +
             "</SOAP-ENV:Envelope>";

         ByteArrayInputStream istream =
             new ByteArrayInputStream(msgtxt.getBytes());
         MessageContext msgContext=createMessageContext(engine,request,response);
         Message msg = new Message(istream, false);
         msgContext.setRequestMessage(msg);
         engine.invoke(msgContext);


        return msgContext;
     }
     /**
      * get deploy infomation ,just service-config.wsdd file
      * @param request
      * @param response
      * @param infoName
      * @return
      */
     NodeList getDeloymentInfo(HttpServletRequest request, HttpServletResponse response,String infoName){
       PrintWriter writer=null;
       try{
          writer = response.getWriter();
       }catch(IOException e){
         return null;
       }

       try{
         String body = "<list xmlns=\"http://xml.apache.org/axis/wsdd/\" xmlns:java=\"http://xml.apache.org/axis/wsdd/providers/java\"/>";
         MessageContext msgContext=invokeAdmin(request,response,body);
         Message respMsg = msgContext.getResponseMessage();
            Document doc = null;
            javax.xml.soap.SOAPBody soapBody = null;

            doc = XMLUtils.newDocument(new InputSource(new StringReader(respMsg.getSOAPPartAsString())));
            java.util.StringTokenizer token=new java.util.StringTokenizer(infoName,"/");
            NodeList result=doc.getElementsByTagName(token.nextToken());

            while(token.hasMoreTokens()){
              for(int i=0;i<result.getLength();i++){
                Node n=result.item(i);
                NodeList list=n.getChildNodes();
                String index=token.nextToken();
                for(int j=0;j<list.getLength();j++){
                  if(list.item(j).getNodeName().equals(index)){
                    result=list.item(j).getChildNodes();
                    return result;
                }
                }

              }
              return null;

            }
            return result;

       }catch(AxisFault fault){
         response.setContentType("text/html");
         response.setStatus(500);
         writer.println("<h2>" +Messages.getMessage("error00") + "</h2>");
         writer.println("<p>" + Messages.getMessage("somethingWrong00") +
                                   "</p>");
         writer.println("<pre>Fault - " + fault.toString() + " </pre>");
         writer.println("<pre>" + fault.dumpToString() + " </pre>");


       }catch(IOException e2){

       }
        writer.close();
        return null;

     }
     /**
      * write out the XML infomation to HttpServletResponse with correctly XSL file
      * @param response
      * @param msgContext
      * @param xsltURI
      */
     private void writerOut(HttpServletResponse response,String content,String xsltURI){
       PrintWriter writer=null;
       try {
         writer = response.getWriter();
       }
       catch (IOException e) {
         return ;
       }
       response.setContentType("text/xml");

       writer.println("<?xml version=\"1.0\" encoding=\"UTF-8\"?>");
       writer.println("<?xml-stylesheet type=\"text/xsl\" href=\"" + xsltURI +
                      "\"?>");
       writer.println("<deployment>");
       writer.println(content);
       writer.println("</deployment>");
       writer.close();

     }
     private void writerOutWithNodeList(HttpServletResponse response,NodeList node,String xsltURI){
       StringBuffer buffer=new StringBuffer();
       for (int i = 0; i < node.getLength(); i++)
         buffer.append(XMLUtils.ElementToString( (Element) node.item(i)));
       writerOut(response,buffer.toString(),xsltURI);

     }
     private void writerOutWithNode(HttpServletResponse response,Node node,String xsltURI){

       writerOut(response,org.apache.axis.utils.DOM2Writer.nodeToString(node, true),xsltURI);
     }
     private MessageContext createMessageContext(AxisEngine engine,
                                                HttpServletRequest req,
                                                HttpServletResponse res)
    {
        MessageContext msgContext = new MessageContext(engine);

        //if(isDebug) {

            log.info("MessageContext:" + msgContext);
            log.info("HEADER_CONTENT_TYPE:" +
                      req.getHeader( HTTPConstants.HEADER_CONTENT_TYPE));
            log.info("HEADER_CONTENT_LOCATION:" +
                      req.getHeader( HTTPConstants.HEADER_CONTENT_LOCATION));
            log.info("Constants.MC_HOME_DIR:" + String.valueOf(getHomeDir()));
            log.info("Constants.MC_RELATIVE_PATH:"+req.getServletPath());

            log.info("HTTPConstants.MC_HTTP_SERVLETLOCATION:"+ String.valueOf(getWebInfPath()));
            log.info("HTTPConstants.MC_HTTP_SERVLETPATHINFO:" +
                      req.getPathInfo() );
            log.info("HTTPConstants.HEADER_AUTHORIZATION:" +
                      req.getHeader(HTTPConstants.HEADER_AUTHORIZATION));
            //log.info("Constants.MC_REMOTE_ADDR:"+req.getRemoteAddr());
            log.info("configPath:" + String.valueOf(getWebInfPath()));
        //}

        /* Set the Transport */
        /*********************/
        msgContext.setTransportName("http");
        String servletPath="/service";
        String pathInfo="/AdminService";
        /* Save some HTTP specific info in the bag in case someone needs it */
        /********************************************************************/
        msgContext.setProperty(Constants.MC_JWS_CLASSDIR, "");
        msgContext.setProperty(Constants.MC_HOME_DIR, getHomeDir());
        msgContext.setProperty(Constants.MC_RELATIVE_PATH,
                               servletPath);
        msgContext.setProperty(HTTPConstants.MC_HTTP_SERVLET, this );
        msgContext.setProperty(HTTPConstants.MC_HTTP_SERVLETREQUEST, req );
        msgContext.setProperty(HTTPConstants.MC_HTTP_SERVLETRESPONSE, res );
        msgContext.setProperty(HTTPConstants.MC_HTTP_SERVLETLOCATION,
                               getWebInfPath() );
        msgContext.setProperty(HTTPConstants.MC_HTTP_SERVLETPATHINFO,
                               pathInfo );
        msgContext.setProperty(HTTPConstants.HEADER_AUTHORIZATION,
                               req.getHeader(HTTPConstants.HEADER_AUTHORIZATION));

          //msgContext.setProperty(Constants.MC_REMOTE_ADDR, req.getRemoteAddr());



        // Set up a javax.xml.rpc.server.ServletEndpointContext
        ServletEndpointContextImpl sec = new ServletEndpointContextImpl();

        msgContext.setProperty(Constants.MC_SERVLET_ENDPOINT_CONTEXT, sec);
        /* Save the real path */
        /**********************/
        String realpath =
            getServletConfig().getServletContext()
            .getRealPath(servletPath);

        if (realpath != null) {
            msgContext.setProperty(Constants.MC_REALPATH, realpath);
        }

        msgContext.setProperty(Constants.MC_CONFIGPATH, getWebInfPath());

        return msgContext;
    }
    /*
    void addNewService(HttpServletRequest request, HttpServletResponse response){
      PrintWriter writer=null;
       try{
          writer = response.getWriter();
       }catch(IOException e){
         return;
       }

       String content=request.getParameter("content");
       if(content!=null){
         if(!content.equals("")){
           try {
             String body="<deployment xmlns=\"http://xml.apache.org/axis/wsdd/\"  xmlns:java=\"http://xml.apache.org/axis/wsdd/providers/java\">"+content+"</deployment>";
             MessageContext msgContext = invokeAdmin(request, response, body);
             if(msgContext!=null){
               Message respMsg = msgContext.getResponseMessage();
               if (respMsg != null) {
                 request.setAttribute("info", respMsg.getSOAPPartAsString());
                 request.getRequestDispatcher(infoPage).forward(request, response);


               }
             }
           }
           catch (AxisFault e) {

           }catch(ServletException e2){

           }catch(IOException e2){

           }finally {
            writer.close();
          }

         }
       }


    }*/
  void deployService(HttpServletRequest request, HttpServletResponse response,boolean isDeployment){
   String content=request.getParameter("content");
   deployService(request,response,content,isDeployment);
  }
    void deployService(HttpServletRequest request, HttpServletResponse response,String content,boolean isDeployment){
      PrintWriter writer = null;
      try {
        writer = response.getWriter();
      }
      catch (IOException e) {
        return;
      }

       if(content!=null){
         if (!content.equals("")) {
           try {
             String body=null;
             if(isDeployment) body = "<deployment xmlns=\"http://xml.apache.org/axis/wsdd/\"  xmlns:java=\"http://xml.apache.org/axis/wsdd/providers/java\">" +content + "</deployment>";
               else body="<undeployment xmlns=\"http://xml.apache.org/axis/wsdd/\"  xmlns:java=\"http://xml.apache.org/axis/wsdd/providers/java\">" +"<service name=\""+content +"\"/>"+ "</undeployment>";
             MessageContext msgContext = invokeAdmin(request, response, body);
             if (msgContext != null) {
               Message respMsg = msgContext.getResponseMessage();
               if (respMsg != null) {
                 request.setAttribute("info", respMsg.getSOAPPartAsString());
                 request.getRequestDispatcher(infoPage).forward(request, response);

               }
             }
           }
           catch (AxisFault e) {

           }
           catch (ServletException e2) {

           }
           catch (IOException e2) {

           }
           finally {
             writer.close();
           }

         }
       }

    }
    //zhangGuoZhong--start
    void getHandlerDetail(HttpServletRequest request, HttpServletResponse response){
           String root=request.getParameter("root");
           int index=Integer.parseInt(request.getParameter("index"))-1;
           if(index<0) index=0;
           String returnLocation=request.getParameter("return");
           NodeList nodeList=getDeloymentInfo(request,response,root);

           Node tNode=null;
           int k=0;
           if (nodeList != null) {
               for(int i=0;i<nodeList.getLength();i++){
                 if(nodeList.item(i).getNodeName().equals("handler")){
                   if(k==index){
                     tNode=nodeList.item(i);
                     break;
                   }
                   k++;
                 }
               }
               this.writerOut(response,org.apache.axis.utils.DOM2Writer.nodeToString(tNode, true)+"<return>"+returnLocation+"</return>","../admin/handlerDetail.xslt");
             }

    }
        /**
         * get global requestFlow handler detail from server-config.wsdd file
         * @param request
         * @param response
         * @return
         */
    private  Node getRequestFlowHandlerDetail(HttpServletRequest request, HttpServletResponse response){
            NodeList nodeList=getDeloymentInfo(request,response,"globalConfiguration");
            /*
        NodeList nodes = node.item(0).getChildNodes();
        int t = nodes.getLength();
        Node n = nodes.item(13);

        NodeList l = n.getChildNodes();
        int integer = l.getLength();
        for(int i = 0; i<= l.getLength(); i++){
          Node d = l.item(i);
          NamedNodeMap map = d.getAttributes();
          if (map !=null){
            String s = map.getNamedItem("type").getNodeValue();
            String str = s;
          }

        }
       */
            Element node1=(Element)nodeList.item(0);
            NodeList nodeList1=node1.getElementsByTagName("requestFlow");
                //NodeList nodes=nodeList.item(0).getChildNodes();
            Element node2 = (Element) nodeList1.item(0);
            NodeList nodeList2 = node2.getElementsByTagName("handler");
            if (nodeList2 != null) {
              for (int i = 0; i < nodeList2.getLength(); i++) {
              Node tNode = nodeList2.item(i);
              NamedNodeMap map = tNode.getAttributes();
              String handlerType = request.getParameter("handlerType");
              if (map.getNamedItem("type").getNodeValue().equals(handlerType)) {
               return tNode;
              }
            }
          }
          return null;
         }

         void getGlobalResponseFlowHandlerDetail(HttpServletRequest request, HttpServletResponse response){
                  Node tNode=getResponseFlowHandlerDetail(request,response);
                  if(tNode!=null) writerOutWithNode(response, tNode, "../admin/global/globalHandlerDetail.xslt");
                }
                /**
                 * get global responseFlow handler detail from server-config.wsdd file
                 * @param request
                 * @param response
                 * @return
                 */
        private  Node getResponseFlowHandlerDetail(HttpServletRequest request, HttpServletResponse response){
                  NodeList nodeList=getDeloymentInfo(request,response,"globalConfiguration");

                  Element node1=(Element)nodeList.item(0);
                  NodeList nodeList1=node1.getElementsByTagName("responseFlow");
                  //NodeList nodes=nodeList.item(0).getChildNodes();
                  Element node2 = (Element) nodeList1.item(0);
                  NodeList nodeList2 = node2.getElementsByTagName("handler");
                  if (nodeList2 != null) {
                    for (int i = 0; i < nodeList2.getLength(); i++) {
                       Node tNode = nodeList2.item(i);
                       NamedNodeMap map = tNode.getAttributes();
                       String handlerType = request.getParameter("handlerType");
                      if (map.getNamedItem("type").getNodeValue().equals(handlerType)) {
                      return tNode;
                      }
                   }
                 }
             return null;
           }

         void getTransportRequestFlowHandlerDetail(HttpServletRequest request, HttpServletResponse response){
              Node tNode=getTransportRequestFlowDetail(request,response);
              if(tNode!=null) writerOutWithNode(response, tNode, "../admin/transport/transportHandlerDetail.xslt");
            }
            /**
             * get transport requestFlow handler detail from server-config.wsdd file
             * @param request
             * @param response
             * @return
             */
            private  Node getTransportRequestFlowDetail(HttpServletRequest request, HttpServletResponse response){
                NodeList nodeList=getDeloymentInfo(request,response,"transport");

                if(nodeList!=null){
                  for(int i=0;i<=nodeList.getLength();i++){
                   Element node1=(Element)nodeList.item(i);
                   NodeList nodeList1=node1.getElementsByTagName("requestFlow");
                   Element node2=(Element)nodeList1.item(0);
                   NodeList nodeList2=node2.getElementsByTagName("handler");

                   if (nodeList2 != null) {
                    for (int j = 0; j < nodeList2.getLength(); j++) {
                       Node tNode = nodeList2.item(j);
                       NamedNodeMap map = tNode.getAttributes();
                       String handlerType = request.getParameter("handlerType");
                      if (map.getNamedItem("type").getNodeValue().equals(handlerType)) {
                      return tNode;
                      }
                    }
                  }
                }
              }
              return null;
            }
                /*
                if(nodeList!=null){
                  for (int i = 0; i <nodeList.getLength(); i++){
                    Node tNode = nodeList.item(i);
                    NamedNodeMap map=tNode.getAttributes();
                    String transportName = request.getParameter("transportName");
                      if(map.getNamedItem("name").getNodeValue().equals(transportName)){
                        return tNode;
                      }
                  }

                }
                */

               void getTransportResponseFlowHandlerDetail(HttpServletRequest request, HttpServletResponse response){
                 Node tNode=getTransportResponseFlowDetail(request,response);
                 if(tNode!=null) writerOutWithNode(response, tNode, "../admin/transport/transportHandlerDetail.xslt");
               }
               /**
                * get transport responseFlow handler detail from server-config.wsdd file
                * @param request
                * @param response
                * @return
                */
               private  Node getTransportResponseFlowDetail(HttpServletRequest request, HttpServletResponse response){
                   NodeList nodeList=getDeloymentInfo(request,response,"transport");

                   if(nodeList!=null){
                     for(int i=0;i<=nodeList.getLength();i++){
                      Element node1=(Element)nodeList.item(i);
                      NodeList nodeList1=node1.getElementsByTagName("responseFlow");
                      Element node2=(Element)nodeList1.item(0);
                      NodeList nodeList2=node2.getElementsByTagName("handler");

                      if (nodeList2 != null) {
                       for (int j = 0; j < nodeList2.getLength(); j++) {
                          Node tNode = nodeList2.item(j);
                          NamedNodeMap map = tNode.getAttributes();
                          String handlerType = request.getParameter("handlerType");
                         if (map.getNamedItem("type").getNodeValue().equals(handlerType)) {
                         return tNode;
                         }
                      }
                    }
                   }
                 }
                 return null;
               }

     void showAddServiceParameter(HttpServletRequest request, HttpServletResponse response){

       Node tNode=getServiceDetail(request,response);
       String action="<action name=\"addJavaServiceParameter\"></action>";
       writerOut(response,XMLUtils.ElementToString( (Element)tNode)+action,"../admin/javaService/serviceParameter-1.xsl");
     }

     void addServiceParameter(HttpServletRequest request, HttpServletResponse response){
       String serviceName=request.getParameter("serviceName");
       String name=request.getParameter("name");
       String value=request.getParameter("pvalue");
       NodeList nodeList=getDeloymentInfo(request,response,"service");
       Node tNode=null;
       for(int i=0;i<nodeList.getLength();i++){
         if(nodeList.item(i).getAttributes().getNamedItem("name").getNodeValue().equals(serviceName)){
            tNode=nodeList.item(i);
            //Document doc = XMLUtils.newDocument();
            Node newNode=null;
            for(int j=0;j<tNode.getChildNodes().getLength();j++){
              if(tNode.getChildNodes().item(j).getNodeName().equals("parameter")){
                newNode=tNode.getChildNodes().item(j).cloneNode(true);
                break;
              }
            }



            newNode.getAttributes().getNamedItem("name").setNodeValue(name);
            newNode.getAttributes().getNamedItem("value").setNodeValue(value);
            tNode.appendChild(newNode);
            break;
         }

       }
       deployService(request,response,XMLUtils.ElementToString((Element)tNode),true);
    }

     void modifyJavaService(HttpServletRequest request, HttpServletResponse response){
       deployService(request,response,true);
     }


    //zhangGuoZhong--end

}
